package org.processmining.processprofiler3d.compviz;

public enum DataMapNormalization
{
	LocalSum (0, "Local Sum"),
	LocalMax (1, "Local Max"),
	GlobalMax (2, "Global Max"),
	SubnetMax (3, "Subnet Max"),
	One (4, "One");
	
    private final int modeId;
    private final String modeName;
    
    DataMapNormalization(int id, String name)
    {
    	modeId = id;
    	modeName = name;
    }
    
    public String getModeName()
    {
    	return modeName;
    }
    
    public static DataMapNormalization getModeByName(String n)
    {
    	if (n.equals("Local Sum"))
    	{
    		return DataMapNormalization.LocalSum;
    	}
    	else if (n.equals("Local Max"))
    	{
    		return DataMapNormalization.LocalMax;
    	}
    	else if (n.equals("Subnet Max"))
    	{
    		return DataMapNormalization.SubnetMax;
    	}
    	else if (n.equals("Global Max"))
    	{
    		return DataMapNormalization.GlobalMax;
    	}
    	else if (n.equals("One"))
    	{
    		return DataMapNormalization.One;
    	}
    	
    	return DataMapNormalization.LocalSum;
    }
}
