package org.processmining.processprofiler3d.compviz;

import java.util.Collection;
import java.util.Vector;

import org.processmining.models.graphbased.directed.DirectedGraph;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Arc;
import org.processmining.models.graphbased.directed.petrinet.elements.ExpandableSubNet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public interface INetDataSource 
{	
	
	public DirectedGraph<?,?> getDirectedGraph();
	public Collection<ExpandableSubNet> getGroups();
	public Collection<SubNetDataSource> getSubnets();
	public boolean hasSubnet(Transition t);
	
	public boolean hasParent();
	public INetDataSource getParent();
	public boolean hasParentTrans();
	public Transition getParentTrans();
	
	public Collection<Place> getPlaces();
	public Collection<Transition> getTransitions();
	public Arc getArc(PetrinetNode source, PetrinetNode target);
	public Collection<Arc> getEdges();
	public Collection<Arc> getInEdges(PetrinetNode pn);
	public Collection<Arc> getOutEdges(PetrinetNode pn);

	public Collection<Transition> getPreceedingTransitions(Transition t);
	
	public Place getStartPlace();	
	public Place getEndPlace();
	public SubNetDataSource getSubnetForTransition(Transition t);
	public Transition getTransitionForSubnet(ExpandableSubNet esn);
	public Transition getTransitionForSubnet(SubNetDataSource esnId);
	public Transition getTransitionForSubnet(String esnId);
	public boolean existsInNet(String tId);
	
	public int getMaxSubnetDepth();
	public void getAllSubnetsAtLevel(int targetLvl, Vector<SubNetDataSource> subnets);
	public void getAllSubnetsAtLevel(int lvl, int targetLvl, Vector<SubNetDataSource> subnets);
}
