package org.processmining.processprofiler3d.compviz;

import org.processmining.processprofiler3d.compviz.fileio.DefaultFontData;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOGrid;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOResourceWheel;
import org.processmining.processprofiler3d.resourceanalysis.statics.FrequencyTree;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.JoglPanel;
import org.processmining.visualisation3d.JoglResourceManager;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCamera;
import org.processmining.visualisation3d.interactions.JICameraFree;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;
import org.processmining.visualisation3d.scenemanagement.JoglScene;

public class PP3DAppResourceVisualiser2 extends PP3DAppBase
{	
	private FrequencyTree freqTree;
	
	public PP3DAppResourceVisualiser2(FrequencyTree ftree)
	{
		freqTree = ftree;
	}
	
	@Override
	public void InitScene(JoglCamera cam, JoglScene scene, JoglPanel panel) 
	{
		System.out.println("Creating scene...");
		
		//hack! need to load this before the first JoglTextRenderer is loaded
		JoglResourceManager.AddResource("DefaultFont", new DefaultFontData());
		
		//scene.addSceneObject(new JSOCube());
		scene.addSceneObject(new JSOGrid(true, true, false, cam));
		scene.addSceneObject(new JSOResourceWheel(freqTree));
		scene.addSceneObject(new JSOGraphicalUserInterface(panel));
		
		InitInteractions(panel.getInteractionManager(), cam, scene, panel);
		
//		if (persist != null)
//		{
//			PersistLoad();
//		}
//		
//		bInitialized = true;
	}

	private void InitInteractions(JoglInteractionManager iman, JoglCamera cam, JoglScene scene, JoglPanel panel) 
	{
		JICameraFree camInteraction = new JICameraFree(cam);	
		iman.addInteraction(camInteraction);
		
//		JIResourceVis rvis = new JIResourceVis(iman, scene, freqTree);
//		iman.addInteraction(rvis);
	}
}
