package org.processmining.processprofiler3d.compviz;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class TransitionDataMap<T extends Number>
{
	private Map<String, T> value1Map = new HashMap<String, T>();
	private Map<String, T> value1MinMap = new HashMap<String, T>();
	private Map<String, T> value1MaxMap = new HashMap<String, T>();
	
	public boolean hasValue(Transition t, String classifier)
	{
		String id = t.getLocalID().toString() + classifier;
		return (value1Map.containsKey(id));
	}
	
	public boolean hasValue(String t, String classifier)
	{
		String id = t + classifier;
		return (value1Map.containsKey(id));
	}
	
	public boolean hasValue(String id)
	{
		return (value1Map.containsKey(id));
	}
	
	public T getValueR(Transition t, String classifier)
	{
		String id = t.getLocalID().toString() + classifier;
		if (value1Map.containsKey(id))
		{
			T val = value1Map.get(id);
			T min = value1MinMap.get(id);
			T max = value1MaxMap.get(id);
			if (Double.class.isInstance(val))
			{
				if (max.doubleValue() != min.doubleValue())
				{
					Double res = (val.doubleValue() - min.doubleValue()) / (max.doubleValue() - min.doubleValue());
					return (T)res;
				}
				else
				{
					if (max.doubleValue() == 0)
					{
						Double res = 0.0;
						return (T)res;
					}
					else
					{
						Double res = 1.0;
						return (T)res;
					}
				}
			}
			else if (Long.class.isInstance(val))
			{
				if (max.longValue() != min.longValue())
				{
					Long res = (val.longValue() - min.longValue()) / (max.longValue() - min.longValue());
					return (T)res;
				}
				else
				{
					if (max.longValue() == 0)
					{
						Long res = (long)0;
						return (T)res;
					}
					else
					{
						Long res = (long)1;
						return (T)res;
					}
				}
			}
		}
		return null;
	}
	
	public T getValueR(String t, String classifier)
	{
		String id = t + classifier;
		if (value1Map.containsKey(id))
		{
			T val = value1Map.get(id);
			T min = value1MinMap.get(id);
			T max = value1MaxMap.get(id);
			if (Double.class.isInstance(val))
			{
				if (max.doubleValue() != min.doubleValue())
				{
					Double res = (val.doubleValue() - min.doubleValue()) / (max.doubleValue() - min.doubleValue());
					return (T) res;
				}
				else
				{
					if (max.doubleValue() == 0)
					{
						Double res = 0.0;
						return (T)res;
					}
					else
					{
						Double res = 1.0;
						return (T)res;
					}
				}
			}
			else if (Long.class.isInstance(val))
			{
				if (max.longValue() != min.longValue())
				{
					Long res = (val.longValue() - min.longValue()) / (max.longValue() - min.longValue());
					return (T) res;
				}
				else
				{
					if (max.longValue() == 0)
					{
						Long res = (long)0;
						return (T)res;
					}
					else
					{
						Long res = (long)1;
						return (T)res;
					}
				}
			}
		}
		return null;
	}
	
	public T getValueR(String id)
	{
		if (value1Map.containsKey(id))
		{
			T val = value1Map.get(id);
			T min = value1MinMap.get(id);
			T max = value1MaxMap.get(id);
			if (Double.class.isInstance(val))
			{
				if (max.doubleValue() != min.doubleValue())
				{
					Double res = (val.doubleValue() - min.doubleValue()) / (max.doubleValue() - min.doubleValue());
					return (T) res;
				}
				else
				{
					if (max.doubleValue() == 0)
					{
						Double res = 0.0;
						return (T)res;
					}
					else
					{
						Double res = 1.0;
						return (T)res;
					}
				}
			}
			else if (Long.class.isInstance(val))
			{
				if (max.longValue() != min.longValue())
				{
					Long res = (val.longValue() - min.longValue()) / (max.longValue() - min.longValue());
					return (T) res;
				}
				else
				{
					if (max.longValue() == 0)
					{
						Long res = (long)0;
						return (T)res;
					}
					else
					{
						Long res = (long)1;
						return (T)res;
					}
				}
			}
		}
		return null;
	}
	
	public T getValue(String id)
	{
		if (value1Map.containsKey(id))
		{
			return value1Map.get(id);
		}
		return null;
	}
	
	public T getMin(String id)
	{
		if (value1MinMap.containsKey(id))
		{
			return value1MinMap.get(id);
		}
		return null;
	}
	
	public T getMax(String id)
	{
		if (value1MaxMap.containsKey(id))
		{
			return value1MaxMap.get(id);
		}
		return null;
	}
	
	public void setValue(String id, T val)
	{
		value1Map.put(id, val);
	}
	
	public void setMin(String id, T min)
	{
		value1MinMap.put(id, min);
	}
	
	public void setMax(String id, T max)
	{
		value1MaxMap.put(id, max);
	}
	
	public void setValue(String t, String classifier, T val)
	{
		String id = t + classifier;
		value1Map.put(id, val);
	}
	
	public void setMin(String t, String classifier, T min)
	{
		String id = t + classifier;
		value1MinMap.put(id, min);
	}
	
	public void setMax(String t, String classifier, T max)
	{
		String id = t + classifier;
		value1MaxMap.put(id, max);
	}
	
	public Set<String> getEntryIds()
	{
		return value1Map.keySet();
	}
	
	public static TransitionDataMap<Double> interpolate(TransitionDataMap<Double> map1, TransitionDataMap<Double> map2, double factor)
	{
		TransitionDataMap<Double> newmap = new TransitionDataMap<Double>();

		Set<String> keys = new HashSet<String>();
		keys.addAll(map1.getEntryIds());
		for (String id2 : map2.getEntryIds())
		{
			if (!keys.contains(id2))
			{
				try
				{
					keys.add(id2);
				}
				catch (Exception ex)
				{
					System.out.println("Id2:" + id2);
				}
			}
		}
		for (String id : keys)
		{
			//String name = id.substring(0, id.indexOf("cohort"));
			
			double d1 = 0;
			double d2 = 0;
			double d1min = 0;
			double d2min = 0;
			double d1max = 0;
			double d2max = 0;
			
			if (map1.hasValue(id))
			{
				d1 = map1.getValue(id).doubleValue();
				d1min = map1.getMin(id).doubleValue();
				d1max = map1.getMax(id).doubleValue();
			}
			if (map2.hasValue(id))
			{
				d2 = map2.getValue(id).doubleValue();
				d2min = map2.getMin(id).doubleValue();
				d2max = map2.getMax(id).doubleValue();
			}
			
			if ( (factor <= 0.5f && map1.hasValue(id)) || (factor > 0.5 && map2.hasValue(id)))
			{
				double d = d1 + ((d2 - d1) * factor);		
				double dmin = d1min + ((d2min - d1min) * factor);		
				double dmax = d1max + ((d2max - d1max) * factor);
	
				//System.out.println("Interp: " + id + " - " + d);
				
				newmap.setValue(id, d);
				newmap.setMin(id, dmin);
				newmap.setMax(id, dmax);
			}
		}
		
		return newmap;
	}
}
