package org.processmining.processprofiler3d.compviz.graphicsdatastructures;

import java.util.Vector;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglVertexArrayObjectBuffer;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord4;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.maths.JoglVectord4;

import com.jogamp.opengl.GL2;

public class JoglColoredMesh extends JoglMesh
{
	protected JoglMeshDataBufferVectord4 colorsd;
	
	public JoglColoredMesh(int dType)
	{
		super(dType);
		colorsd = new JoglMeshDataBufferVectord4();
	}
	
	public JoglColoredMesh(int dType, int vCapacity)
	{
		super(dType, vCapacity);
		
		colorsd = new JoglMeshDataBufferVectord4(vCapacity);
	}
	
	public double[] getColors()
	{
		return colorsd.getArray();
	}
	
	public JoglMeshDataBufferVectord4 getColorsBuffer()
	{
		return colorsd;
	}
	
//	public void setColors(double[] tclist)
//	{
//		colorsd.set(tclist);
//	}
	
	public void setColors3(Vector<JoglVectord3> tclist)
	{
		colorsd.set3(tclist);
	}
	
	public void setColors(Vector<JoglVectord4> tclist)
	{
		colorsd.set(tclist);
	}
	
//	public void addColors(double[] tclist)
//	{
//		colorsd.add(tclist);
//	}
	
	public void addColors3(Vector<JoglVectord3> tclist)
	{
		colorsd.add3(tclist);
	}
	
	public void addColors(Vector<JoglVectord4> tclist)
	{
		colorsd.add(tclist);
	}
	
	public void addColors(JoglColoredMesh m)
	{
		colorsd.add(m.getColorsBuffer().getNativeBuffer());
	}
	
	@Override
	public Vector<JoglVertexArrayObjectBuffer> getVAOBuffers(GraphicsPipeline pipe)
	{
		Vector<JoglVertexArrayObjectBuffer> lst = new Vector<JoglVertexArrayObjectBuffer>();
		
		lst.add(vertsd.getVAOBuffer(pipe));
		lst.add(colorsd.getVAOBuffer(pipe));
		
		return lst;
	}
	
	@Override
	public void draw(GraphicsPipeline pipe)
	{
		draw(pipe, 0, getNumVerts());
	}
	
	@Override
	public void draw(GraphicsPipeline pipe, int start, int end)
	{
		GL2 gl = pipe.gl;
		
		// start drawing the mesh
		gl.glBegin(drawType);       
		
		colorsd.position(start);
		vertsd.position(start);
		for (int i = start; i < end; i++)
		{
			colorsd.drawNextColor3d(gl);
			vertsd.drawNextVertex3d(gl);
		}
		
		// done drawing the mesh
		gl.glEnd(); 
	}

}
