package org.processmining.processprofiler3d.compviz.graphicsdatastructures;

import java.nio.IntBuffer;

import com.jogamp.opengl.GL2;

public class JoglDrawState 
{
	boolean blend;
	boolean cullFace;
	byte[] colorMask = new byte[4];
	boolean depthMask;
	boolean depthTest;
	int drawBuffer = -1;
	boolean scissorTest;
	
	public JoglDrawState()
	{
	}
	
	public void get(GL2 gl)
	{
		gl.glGetBooleanv(GL2.GL_COLOR_WRITEMASK, colorMask, 0);
		
		blend = getBoolean(gl, GL2.GL_BLEND);
		cullFace = getBoolean(gl, GL2.GL_CULL_FACE);
		depthTest = getBoolean(gl, GL2.GL_DEPTH_TEST);
		depthMask = getBoolean(gl, GL2.GL_DEPTH_WRITEMASK);
		
		drawBuffer = getInteger(gl, GL2.GL_DRAW_BUFFER);

		scissorTest = getBoolean(gl, GL2.GL_SCISSOR_TEST);
	}

	private boolean getBoolean(GL2 gl, int val)
	{
		byte[] blend = new byte[1];
		gl.glGetBooleanv(val, blend, 0);
		
		return blend[0] == 1;
	}
	
	private int getInteger(GL2 gl, int val)
	{
		IntBuffer ibuf = IntBuffer.allocate(1);
		gl.glGetIntegerv(val, ibuf);
		ibuf.position(0);
		
		return ibuf.get();
	}
	
	public void print()
	{
		System.out.println("Draw State: ");
	}
	
}
