package org.processmining.processprofiler3d.compviz.graphicsdatastructures;

import java.util.Vector;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglVertexArrayObjectBuffer;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord3;
import org.processmining.visualisation3d.maths.JoglVectord3;

import com.jogamp.opengl.GL2;

public class JoglOpenVRMesh extends JoglTexturedMesh
{
	protected JoglMeshDataBufferVectord3 normsd;
	
	public JoglOpenVRMesh(int dType)
	{
		super(dType);
		normsd = new JoglMeshDataBufferVectord3();
	}
	
	public JoglOpenVRMesh(int dType, int vCapacity)
	{
		super(dType, vCapacity);
		normsd = new JoglMeshDataBufferVectord3(vCapacity);
	}
	
	public double[] getNormals()
	{
		return normsd.getArray();
	}
	
	public JoglMeshDataBufferVectord3 getNormalsBuffer()
	{
		return normsd;
	}
	
//	public void setColors(double[] tclist)
//	{
//		colorsd.set(tclist);
//	}
	
	public void setNormals(Vector<JoglVectord3> tclist)
	{
		normsd.set(tclist);
	}
	
//	public void addColors(double[] tclist)
//	{
//		colorsd.add(tclist);
//	}
	
	public void addNormals(Vector<JoglVectord3> tclist)
	{
		normsd.add(tclist);
	}
	
	public void addNormals(JoglOpenVRMesh m)
	{
		normsd.add(m.getNormalsBuffer().getNativeBuffer());
	}
	
	@Override
	public Vector<JoglVertexArrayObjectBuffer> getVAOBuffers(GraphicsPipeline pipe)
	{
		Vector<JoglVertexArrayObjectBuffer> lst = new Vector<JoglVertexArrayObjectBuffer>();
		
		lst.add(vertsd.getVAOBuffer(pipe));
		lst.add(texCoordsd.getVAOBuffer(pipe));
		lst.add(normsd.getVAOBuffer(pipe));
		
		return lst;
	}
	
	@Override
	public void draw(GraphicsPipeline pipe)
	{
		draw(pipe, 0, getNumVerts());
	}
	
	@Override
	public void draw(GraphicsPipeline pipe, int start, int end)
	{
		GL2 gl = pipe.gl;
		
		// start drawing the mesh
		gl.glBegin(drawType);       
		
		normsd.position(start);
		texCoordsd.position(start);
		vertsd.position(start);
		for (int i = start; i < end; i++)
		{
			normsd.drawNextColor3d(gl);
			texCoordsd.drawNextTexCoord2d(gl);
			vertsd.drawNextVertex3d(gl);
		}
		
		// done drawing the mesh
		gl.glEnd(); 
	}

}
