package org.processmining.processprofiler3d.compviz.graphicsdatastructures;

import java.util.Vector;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglVertexArrayObjectBuffer;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord3;
import org.processmining.visualisation3d.maths.JoglVectord3;

import com.jogamp.opengl.GL2;

public class JoglTexturedInterpolationMesh extends JoglTexturedMesh
{
	protected JoglMeshDataBufferVectord3 vertsd2;
	
	public JoglTexturedInterpolationMesh(int dType)
	{
		super(dType);
		vertsd2 = new JoglMeshDataBufferVectord3();
	}
	
	public JoglTexturedInterpolationMesh(int dType, int vCapacity)
	{
		super(dType, vCapacity);
		
		vertsd2 = new JoglMeshDataBufferVectord3(vCapacity);
	}
	
	public double[] getVerts2()
	{
		return vertsd2.getArray();
	}
	
//	public DoubleBuffer getVerts2Buffer()
//	{
//		return vertsd2.getNativeBuffer();
//	}
	
	public JoglMeshDataBufferVectord3 getVerts2Buffer()
	{
		return vertsd2;
	}
	
	public void setVerts2(double[] tclist)
	{
		vertsd2.set(tclist);
	}
	
	public void setVerts2(Vector<JoglVectord3> tclist)
	{
		vertsd2.set(tclist);
	}
	
	public void addVerts2(Vector<JoglVectord3> tclist)
	{
		vertsd2.add(tclist);
	}
	
	public void addVerts2(double[] tclist)
	{
		vertsd2.add(tclist);
	}
	
	@Override
	public Vector<JoglVertexArrayObjectBuffer> getVAOBuffers(GraphicsPipeline pipe)
	{
		Vector<JoglVertexArrayObjectBuffer> lst = new Vector<JoglVertexArrayObjectBuffer>();
		
		lst.add(vertsd.getVAOBuffer(pipe));
		lst.add(texCoordsd.getVAOBuffer(pipe));
		lst.add(vertsd2.getVAOBuffer(pipe));
		
		return lst;
	}
	
	@Override
	public void draw(GraphicsPipeline pipe)
	{
		draw(pipe, 0, getNumVerts());
	}
	
	@Override
	public void draw(GraphicsPipeline pipe, int start, int end)
	{
		GL2 gl = pipe.gl;
		
		// start drawing the mesh
		gl.glBegin(drawType);       
		
		texCoordsd.position(start);
		//vertsd.position(start * 3);
		vertsd.position(start);
		vertsd2.position(start);
		for (int i = start; i < end; i++)
		{
			texCoordsd.drawNextTexCoord2d(gl);
			vertsd2.drawNextNormal3d(gl);
			//gl.glVertex3d(vertsd.get(), vertsd.get(), vertsd.get());
			vertsd.drawNextVertex3d(gl);
		}
		
		// done drawing the mesh
		gl.glEnd(); 
	}

}
