package org.processmining.processprofiler3d.compviz.graphicsdatastructures;

import java.util.Vector;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglVertexArrayObjectBuffer;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord2;
import org.processmining.visualisation3d.maths.JoglVectord2;

import com.jogamp.opengl.GL2;

public class JoglTexturedMesh extends JoglMesh
{
	protected JoglMeshDataBufferVectord2 texCoordsd;
	
	public JoglTexturedMesh(int dType)
	{
		super(dType);
		texCoordsd = new JoglMeshDataBufferVectord2();
	}
	
	public JoglTexturedMesh(int dType, int vCapacity)
	{
		super(dType, vCapacity);
		
		texCoordsd = new JoglMeshDataBufferVectord2(vCapacity);
	}
	
	public double[] getTexCoords()
	{
		return texCoordsd.getArray();
	}
	
//	public DoubleBuffer getTexCoordsBuffer()
//	{
//		return texCoordsd.getNativeBuffer();
//	}
	
	public JoglMeshDataBufferVectord2 getTexCoordsBuffer()
	{
		return texCoordsd;
	}
	
	public void setTexCoords(double[] tclist)
	{
		texCoordsd.set(tclist);
	}
	
	public void setTexCoords(Vector<JoglVectord2> tclist)
	{
		texCoordsd.set(tclist);
	}
	
	public void addTexCoords(double[] tclist)
	{
		texCoordsd.add(tclist);
	}
	
	public void addTexCoords(Vector<JoglVectord2> tclist)
	{
		texCoordsd.add(tclist);
	}
	
	public void addTexCoords(JoglTexturedMesh m)
	{
		texCoordsd.add(m.getTexCoordsBuffer().getNativeBuffer());
	}
	
	@Override
	public Vector<JoglVertexArrayObjectBuffer> getVAOBuffers(GraphicsPipeline pipe)
	{
		Vector<JoglVertexArrayObjectBuffer> lst = new Vector<JoglVertexArrayObjectBuffer>();
		
		lst.add(vertsd.getVAOBuffer(pipe));
		lst.add(texCoordsd.getVAOBuffer(pipe));
		
		return lst;
	}
	
	@Override
	public void draw(GraphicsPipeline pipe)
	{
		draw(pipe, 0, getNumVerts());
	}
	
	@Override
	public void draw(GraphicsPipeline pipe, int start, int end)
	{
		GL2 gl = pipe.gl;
		
		// start drawing the mesh
		gl.glBegin(drawType);       
		
		texCoordsd.position(start);
		//vertsd.position(start * 3);
		vertsd.position(start);
		for (int i = start; i < end; i++)
		{
			texCoordsd.drawNextTexCoord2d(gl);
			//gl.glVertex3d(vertsd.get(), vertsd.get(), vertsd.get());
			vertsd.drawNextVertex3d(gl);
		}
		
		// done drawing the mesh
		gl.glEnd(); 
	}

}
