package org.processmining.processprofiler3d.compviz.jogl;

public class AverageTimeMeasure 
{
	private long currentStartTime = 0;
	private long currentEndTime = 0;
	
	private long[] times;
	
	private int index = 0;
	private boolean bFull = false;
	
	public AverageTimeMeasure()
	{
		times = new long[100];
	}
	
	public void start()
	{
		currentStartTime = System.nanoTime();
	}
	
	public void stop()
	{
		currentEndTime = System.nanoTime();
		
		times[index] = getLastNanoSeconds();
		index = (index + 1);
		if (index == times.length)
		{
			bFull = true;
		}
		index = index % 100;
	}
	
	public long getLastNanoSeconds()
	{
		return currentEndTime - currentStartTime;
	}
	
	public double getLastMilliSeconds()
	{
		return getLastNanoSeconds() * 0.001 * 0.001;
	}
	
	public long getAverageNanoSeconds()
	{
		long val = times[0];
		int num = 1;
		
		if (bFull)
		{
			for (int i = 1; i < 100; i++)
			{
				val = val + times[i];
				num = num + 1;
			}
		}
		else
		{
			for (int i = 1; i < index; i++)
			{
				val = val + times[i];
				num = num + 1;
			}
		}
		
		return (val / num);
	}
	
	public double getAverageMilliSeconds()
	{
		long val = getAverageNanoSeconds();

		return val * 0.001 * 0.001;
	}
}
