package org.processmining.processprofiler3d.compviz.jogl.drawing;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.graphicsdatastructures.JoglMesh;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord2;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord3;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshDataBufferVectord4;
import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.maths.JoglVectord4;

public interface IMeshDrawer
{

	void LoadMesh(GraphicsPipeline pipe, JoglMesh mesh);

	void UpdateDataBufferJV2(GraphicsPipeline pipe, int bufNum, Vector<JoglVectord2> vlst);

	void UpdateDataBufferJV3(GraphicsPipeline pipe, int bufNum, Vector<JoglVectord3> vlst);

	void UpdateDataBufferJV4(GraphicsPipeline pipe, int bufNum, Vector<JoglVectord4> vlst);

	void UpdateDataBufferJV2(GraphicsPipeline pipe, int bufNum, JoglMeshDataBufferVectord2 vbuf);

	void UpdateDataBufferJV3(GraphicsPipeline pipe, int bufNum, JoglMeshDataBufferVectord3 vbuf);

	void UpdateDataBufferJV4(GraphicsPipeline pipe, int bufNum, JoglMeshDataBufferVectord4 vbuf);

	void Dispose();

	void Bind(GraphicsPipeline pipe);

	void Unbind(GraphicsPipeline pipe);

	void DrawSlim(GraphicsPipeline pipe);

	void DrawSlim(GraphicsPipeline pipe, int offset, int count);

	void Draw(GraphicsPipeline pipe);

	void Draw(GraphicsPipeline pipe, int offset, int count);

	void DrawLines(GraphicsPipeline pipe);

	void DrawLines(GraphicsPipeline pipe, int offset, int count);

	void DrawLinesSlim(GraphicsPipeline pipe);

	void DrawLinesSlim(GraphicsPipeline pipe, int offset, int count);

}