package org.processmining.processprofiler3d.compviz.jogl.gui;

import java.util.Date;
import java.util.Vector;
import java.util.concurrent.TimeUnit;

import org.processmining.processprofiler3d.compviz.graphicsdatastructures.JoglTexturedMesh;
import org.processmining.processprofiler3d.compviz.jogl.interactions.IScrollBarListener;
import org.processmining.processprofiler3d.psen.replayanalysis.TimeSpan;
import org.processmining.visualisation3d.FontData;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.JoglResourceManager;
import org.processmining.visualisation3d.gui.JoglGuiObject;
import org.processmining.visualisation3d.input.JoglInputMouseEvent;
import org.processmining.visualisation3d.input.JoglInputMouseWheelEvent;
import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.maths.JoglVectord4;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;

public class JoglGuiListBox extends JoglGuiObject implements IScrollBarListener
{
	private JSOGraphicalUserInterface gui;
	//private JoglGuiTextRenderer textRenderer;
	
	private float bgcolorR = 0.0f;
	private float bgcolorG = 0.0f;
	private float bgcolorB = 0.0f;
	private float bgcolorA = 0.3f;

	private JoglScreenRect rect = new JoglScreenRect(0,0,1,1);
	
	private float padding = 0.0f;
	private static float xoff = 0.0f;
	private static float yoff = 0.0f;

	private JoglGuiColoredRect background;
	
	private Vector<JoglScreenRect> labels = new Vector<JoglScreenRect>();
	private Vector<JoglScreenRect> selectedLabels = new Vector<JoglScreenRect>();
	
	private JoglGuiScrollBar scrollB;
	
	private Vector<JoglGuiColoredRect> highlighters = new Vector<JoglGuiColoredRect>();
	
	private float scrolldist = 0.0f;
	private float scrollmaxdist = 0.0f;
	private boolean bShowScrollbar = false;
	
	private boolean bCanTouch = false;
	private boolean bInitialized = false;
	
	private Vector<String> dataLines = new Vector<String>();
	
	private JoglTexturedMesh jtm = null;
	private JoglGuiMesh jgm = null;
	private JoglGuiScissorBox jgsb = null;
	private Vector<Integer> offsets = new Vector<Integer>();
	
	private boolean bMultiSelect = false;
	
//	public int getAlign()
//	{
//		return textRenderer.getAlign();
//	}
//	
//	public void setAlign(int a)
//	{
//		textRenderer.setAlign(a);
//
//		updateAlignment();
//	}
	
	public void setBackColor(float r, float g, float b)
	{
		bgcolorR = r;
		bgcolorG = g;
		bgcolorB = b;
		
		if (background != null)
		{
			background.setColor(r, g, b);
		}
	}
	
	public void setBackColor(float r, float g, float b, float a)
	{
		bgcolorR = r;
		bgcolorG = g;
		bgcolorB = b;
		bgcolorA = a;
		
		if (background != null)
		{
			background.setColor(r, g, b, a);
		}
	}
	
	public void setBackColor(JoglVectord3 v)
	{
		bgcolorR = (float)v.getX();
		bgcolorG = (float)v.getY();
		bgcolorB = (float)v.getZ();
		
		if (background != null)
		{
			background.setColor(v);
		}
	}
	
	public void setBackColor(JoglVectord4 v)
	{
		bgcolorR = (float)v.getX();
		bgcolorG = (float)v.getY();
		bgcolorB = (float)v.getZ();
		bgcolorA = (float)v.getValue(3);
		
		if (background != null)
		{
			background.setColor(v);
		}
	}
	
	@Override
	public boolean getCanTouch()
	{
		return bCanTouch;
	}
	
	@Override
	public void setCanTouch(boolean b)
	{
		bCanTouch = b;
	}
	
	public boolean getCanMultiSelect()
	{
		return bMultiSelect;
	}
	
	public void setCanMultiSelect(boolean b)
	{
		bMultiSelect = b;
	}
	
	public void setColor(float r, float g, float b)
	{
		//textRenderer.setColor(r, g, b);
	}
	
	public void setColor(JoglVectord3 v)
	{
		//textRenderer.setColor(v);
	}
	
	public JoglVectord4 getRect()
	{
		return rect.getRect();
	}
	
	public void setRect(float x, float y, float w, float h)
	{
		rect = new JoglScreenRect(x, y, w, h);
		
		updateAlignment();
	}
	
	public void setRect(JoglVectord4 v)
	{
		rect = new JoglScreenRect(v);
		
		updateAlignment();
	}
	
	public int getSelectedIndex()
	{
		if (!selectedLabels.isEmpty())
		{
			return labels.indexOf(selectedLabels.get(0));
		}
		
		return -1;
	}
	
	public Vector<Integer> getSelectedIndices()
	{
		Vector<Integer> lst = new Vector<Integer>();
		for (JoglScreenRect l : selectedLabels)
		{
			lst.add(labels.indexOf(l));
		}
		
		return lst;
	}
	
	private void updateAlignment() 
	{
//		int align = textRenderer.getAlign();
//		if (align == 0)
//		{
//			textRenderer.setPosition(rect.getLeft() + (rect.getWidth() * 0.5), rect.getTop() + (rect.getHeight() * 0.5), 0);
//		}
//		else if (align == 1)
//		{
//			textRenderer.setPosition(rect.getLeft() + padding, rect.getTop() + (rect.getHeight() * 0.5), 0);
//		}
//		else if (align == 2)
//		{
//			textRenderer.setPosition(rect.getRight() - padding, rect.getTop() + (rect.getHeight() * 0.5), 0);
//		}
	}
	
	public float getPadding()
	{
		return padding;
	}

	public void setPadding(float p)
	{
		padding = p;
		
		updateAlignment();
	}
	
//	public void setTextSize(float tx, float ty)
//	{
//		textRenderer.setTextSize(tx, ty);
//	}
	
	public JoglGuiListBox()
	{
		//textRenderer = new JoglGuiTextRenderer(ff);
	}


	public Vector<String> getTextItems()
	{
		return dataLines;
	}
	
	public void setTextItems(Vector<String> lst)
	{
		dataLines = lst;
	}
	
	@Override
	public boolean IsInside(float x, float y)
	{
		if (bCanTouch)
		{
			if (rect.IsInside(x, y))
			{
				return true;
			}
		}
		return false;
	}
	
	@Override
	public void OnAddToGui(JSOGraphicalUserInterface g)
	{
		gui = g;
		
		float aspect = (float)gui.getAspect();
		
		//float textPadding = 0.005f;
		
		yoff = 0;
		
		//required height
		float listHeight = (dataLines.size() + 1) * 0.05f;
		float maxHeight = rect.getHeight();
		
		float perc = maxHeight / listHeight;
		scrollmaxdist = listHeight - maxHeight;
		
		background = new JoglGuiColoredRect();
		background.setRect(xoff + rect.getLeft(), yoff + rect.getTop(), rect.getWidth(), maxHeight);
		//background.setColor(JoglGuiStyle.backColor);
		background.setColor(bgcolorR, bgcolorG, bgcolorB, bgcolorA);
		
		gui.AddGuiObject(background);
		
		if (perc < 1.0f)
		{
			bShowScrollbar = true;
			
			scrollB = new JoglGuiScrollBar();
			scrollB.setCanTouch(true);
			scrollB.setPerc(perc);
			scrollB.setRect(xoff + rect.getRight() - 0.025f, yoff + rect.getTop(), 0.025f, maxHeight);
			scrollB.addScrollbarListener(this);
			
			gui.AddGuiObject(scrollB);
		}

		Date s1Timexy = new Date();
		
		ListBoxTextMeshConstructor test = new ListBoxTextMeshConstructor();
		test.constructMesh(dataLines, aspect, rect.getWidth());

		Date e1Timexy = new Date();
		TimeSpan tsxy = new TimeSpan(s1Timexy, e1Timexy);
		
		System.out.println("List labels generated test (" + tsxy.ToString(TimeUnit.MILLISECONDS) + "ms).");
		
		jtm = test.jtm;
		offsets = test.offsets;
		labels = test.labels;
		
		if (jtm != null) //HACK! if no items in list, make things still work!
		{
			FontData fontData = (FontData)JoglResourceManager.GetResource("DefaultFont");
			jgm = new JoglGuiMesh(jtm, fontData.getTexture());
			jgm.setPosition(xoff + rect.getLeft() + 0.01f, yoff + rect.getTop() + maxHeight, 0);
			
			jgsb = new JoglGuiScissorBox(gui);
			jgsb.setRect(background.getRect());
			jgsb.addChild(jgm);
			gui.AddGuiObject(jgsb);
			
			//clip contents of listbox
			MoveScrollbar();
		}

		if (!labels.isEmpty())
		{
			scrollmaxdist = (float)Math.abs(labels.get(labels.size()-1).getTop()) - maxHeight + 0.05f;
		}
		bInitialized = true;
	}
	
	@Override
	public void OnRemoveFromGui(JSOGraphicalUserInterface g)
	{
		labels.clear();
		if (jgm != null)
		{
			gui.RemoveGuiObject(jgsb);
			jgm.Dispose();
		}

		ClearHighlighters();
		
		if (bShowScrollbar)
		{
			gui.RemoveGuiObject(scrollB);
		}
		gui.RemoveGuiObject(background);
		
		bInitialized = false;
	}
	
	private void AddHighlighterFor(JoglScreenRect targetLabel)
	{
		JoglGuiColoredRect highlighter = new JoglGuiColoredRect();
		highlighter.setRect(JoglVectord4.Add(targetLabel.getRect(), new JoglVectord4(rect.getLeft(), rect.getBottom() - 0.025f,0,0)));
		highlighter.setColor(JoglGuiStyle.highlightColor);
		highlighter.setVisible(true);
		highlighter.setZLevel(-1.0f);
		
		jgsb.addChild(highlighter);
		highlighters.add(highlighter);
	}
	
	private void RemoveHighlighterFor(JoglScreenRect targetLabel)
	{
		int idx = selectedLabels.indexOf(targetLabel);
		jgsb.removeChild(highlighters.get(idx));
		highlighters.remove(idx);
	}

	public void ClearHighlighters()
	{
		for (JoglGuiColoredRect highlighter : highlighters)
		{
			//gui.RemoveGuiObject(highlighter);
			jgsb.removeChild(highlighter);
		}
		highlighters.clear();
	}
	
	//MouseListener method implementation
    public boolean mousePressed(JoglInteractionManager iman, JoglInputMouseEvent e) 
    {
		Vector<JoglGuiObject> jgo = gui.GetObjectsFromPos(e.getX(), e.getY());
		if (jgo != null && !jgo.isEmpty())
		{
			//if clicked on scrollbar
			if (jgo.contains(scrollB))
			{
				scrollB.StartMoveInteraction(iman, e);
				return true;
			}
		}
		
		//boolean bCtrlDown = (e.getModifiersEx() & InputEvent.CTRL_DOWN_MASK) != 0;
		//boolean bShiftDown = (e.getModifiersEx() & InputEvent.SHIFT_DOWN_MASK) != 0;
		boolean bCtrlDown = e.isControlDown();
		boolean bShiftDown = e.isShiftDown();
		
		//if user is not holding down the ctrl-key
		if (!bMultiSelect || !(bCtrlDown || bShiftDown))
		{
			ClearHighlighters();
			selectedLabels.clear();
		}
		
		//if clicked on a listbox item
		JoglScreenRect targetLabel = getTargetLabel(e);
		if (targetLabel != null)
		{
			Vector<JoglScreenRect> nlabels = new Vector<JoglScreenRect>();
			if (bShiftDown && bMultiSelect)
			{
				getAllLabelsInBetween(nlabels, targetLabel);
			}
			else
			{
				nlabels.add(targetLabel);
			}
			
			boolean bUpdateClipping = false;
			for (JoglScreenRect nlabel : nlabels)
			{
				if (!selectedLabels.contains(nlabel))
				{
					selectedLabels.add(nlabel);
					
					//highlight label
					//highlighter.setRect(JoglVectord4.Add(targetLabel.getRect(), new JoglVectord4(rect.getLeft(), rect.getBottom() - 0.025f,0,0)));
					AddHighlighterFor(nlabel);
					
					if (scrollB == null)
					{
						//highlighter.setVisible(true);
					}
					else
					{
						//clip contents of listbox
						bUpdateClipping = true;
					}
				}
				else if (!(bMultiSelect && bShiftDown))
				{
					RemoveHighlighterFor(nlabel);
					selectedLabels.remove(nlabel);
				}
			}
			
			if (bUpdateClipping)
			{
				MoveScrollbar();
			}
		}
		
		return false;
    }
    
    public void mouseWheelMoved(JoglInputMouseWheelEvent e)
    {
		if (scrollB == null || background == null || gui == null)
		{
			return;
		}
		
		JoglVectord2 cursorPos = gui.GetNDCPos(e.getX(), e.getY());
		//if cursor hovers over list box
		JoglScreenRect srect = new JoglScreenRect(background.getRect());
		if (srect.IsInside((float)cursorPos.getX(), (float)cursorPos.getY()))
		{
			int delta = e.getWheelRotation();
			scrollB.setScrollPerc(scrollB.getScrollPerc() + (0.1f * delta));
			MoveScrollbar();
		}
    }
    
    public JoglScreenRect getTargetLabel(JoglInputMouseEvent e) 
    {
		JoglVectord2 ndcPos = gui.GetNDCPos(e.getX(), e.getY());
		for (JoglScreenRect l : labels)
		{
			if (l.IsInside((float)(ndcPos.getX() - rect.getLeft()), (float)(ndcPos.getY() - rect.getBottom()) + 0.025f))
			{
				return l;
			}
		}
		
		return null;
    }
    
    private void getAllLabelsInBetween(Vector<JoglScreenRect> nlabels, JoglScreenRect target)
    {
    	int idxTarget = labels.indexOf(target);
    	
    	int idx2 = -1;
    	for (JoglScreenRect l : labels)
    	{
    		idx2++;
    		if (selectedLabels.contains(l))
    		{
    			break;
    		}
    	}
    	
    	int minId = Math.min(idxTarget, idx2);
    	int maxId = Math.max(idxTarget, idx2);
    	
    	for (int i = minId; i < maxId + 1; i++)
    	{
    		nlabels.add(labels.get(i));
    	}
    }
    
    public Vector<JoglScreenRect> getSelectedLabels() 
    {
    	Vector<JoglScreenRect> slst = new Vector<JoglScreenRect>(selectedLabels);
    	
		return slst;
    }
	
//	private void MoveWindow(JoglVectord2 d)
//	{
//		JoglVectord4 diff = new JoglVectord4(d.getX(), d.getY(), 0, 0);
//		
//		xoff = xoff + (float)diff.getX();
//		yoff = yoff + (float)diff.getY();
//
//		if (jgm != null)
//		{
//			jgm.setPosition(JoglVectord3.Add(jgm.getPosition(), new JoglVectord3(diff.getX(), diff.getY(),0)));
//		}
//		
//		if (bShowScrollbar)
//		{
//			scrollB.setRect(JoglVectord4.Add(diff, scrollB.getRect()));
//		}
//		background.setRect(JoglVectord4.Add(diff, background.getRect()));
//		
//		for (JoglScreenRect l : labels)
//		{
//			l.transform(diff);
//		}
//	}
	
//	private float testoff = 0;
//	private double testoffd = 0;
	
	private void MoveScrollbar()
	{
		if (scrollB == null)
			return;
		
		double oldscrolldist = scrolldist;
		scrolldist = scrollB.getScrollPerc() * scrollmaxdist;
//		testoff = testoff + (float)(scrolldist - oldscrolldist);
//		testoffd = testoffd + (scrolldist - oldscrolldist);
		
		JoglVectord4 diff = new JoglVectord4(0.0f, scrolldist - oldscrolldist, 0, 0);

		float windowTop = yoff + 0.075f;
		float windowBottom = yoff - rect.getHeight() - 0.05f;
		
		//update selection highlight position and visibility
		for (JoglGuiColoredRect highlighter : highlighters)
		{
			highlighter.transform(diff);
			
			JoglVectord4 hrect = highlighter.getRect();
			double hrectBottom = (hrect.getY() - rect.getBottom()) + 0.025;
			double hrectTop = hrectBottom + hrect.getW();
			if (hrectBottom > windowBottom && hrectTop < windowTop)
			{
				highlighter.setVisible(true);
			}
			else
			{
				highlighter.setVisible(false);
			}
		}
		
		//update position of list text batch-mesh
		if (jgm != null)
		{
			//jgm.setPosition(JoglVectord3.Add(jgm.getPosition(), new JoglVectord3(0.0f, scrolldist - oldscrolldist, 0)));
			jgm.setPosition(xoff + rect.getLeft() + 0.01f, yoff + rect.getTop() + rect.getHeight() + scrolldist, 0);
		}
		
		//update visibility of lines in list text batch-mesh
		int firstVis = -1;
		int lastVis = -1;
		int i = 0;
		for (JoglScreenRect l : labels)
		{
			l.transform(diff);

			double labelBottom = l.getTop();
			double labelTop = labelBottom + l.getHeight();

			if ((labelBottom < 0) && (labelTop > -rect.getHeight()))
			{
				if (firstVis == -1)
				{
					firstVis = i;
				}
				lastVis = i;
			}
			i++;
		}
		
		int firstVert = offsets.get(firstVis);
		int lastVert = offsets.get(lastVis+1);
		int numVerts = lastVert - firstVert;

//		System.out.println("VisLabels: " + firstVis + " - " + lastVis + " out of " + (offsets.size() - 2));
//		System.out.println("Scrolldist: " + scrolldist + " out of " + scrollmaxdist);
//		System.out.println("TestOff: " + testoff + "(" + testoffd + ")");
//		System.out.println("Visible verts: " + firstVert + " - " + lastVert + " out of " + jgm.getMesh().getNumVerts());

		if (jgm != null)
		{	
			jgm.setDrawRange((firstVert / 4) * 6, (numVerts / 4) * 6);
		}
	}

	public void OnScrollBarMoved(JoglGuiScrollBar sb, JoglVectord2 dir) 
	{
		MoveScrollbar();
	}
}
