package org.processmining.processprofiler3d.compviz.jogl.gui;

import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord4;

public class JoglScreenRect 
{
	private float left = 0.0f;
	private float top = 0.0f;
	
	private float width = 1.0f;
	private float height = 1.0f;
	
	public float getLeft()
	{
		return left;
	}
	
	public float getRight()
	{
		return left + width;
	}
	
	public float getTop()
	{
		return top;
	}
	
	public float getBottom()
	{
		return top + height;
	}
	
	public float getWidth()
	{
		return width;
	}
	
	public float getHeight()
	{
		return height;
	}
	
	public JoglVectord2 getCenter()
	{
		return new JoglVectord2(left + (0.5 * width), top + (0.5 * height));
	}
	
	public JoglVectord4 getRect()
	{
		return new JoglVectord4(left, top, width, height);
	}
	
	public JoglScreenRect(float x, float y, float w, float h)
	{
		left = x;
		top = y;
		width = w;
		height = h;
		
		if (width < 0)
		{
			System.out.println("GuiRect: W less than zero!");
		}
		if (height < 0)
		{
			System.out.println("GuiRect: H less than zero!");
		}
	}
	
	public JoglScreenRect(JoglVectord4 v)
	{
		setRect(v);
	}
	
	public void setRect(JoglVectord4 v)
	{
		left = (float)v.getX();
		top = (float)v.getY();
		width = (float)v.getZ();
		height = (float)v.getValue(3);
		
		if (width < 0)
		{
			System.out.println("GuiRect: W less than zero!");
		}
		if (height < 0)
		{
			System.out.println("GuiRect: H less than zero!");
		}
	}
	
	public void transform(JoglVectord4 t)
	{
		left += t.getX();
		top += t.getY();
		width += t.getZ();
		height += t.getW();
	}
	
	public boolean IsInside(float x, float y)
	{
		if (x > left && x < left + width)
		{
			if (height < 0) //hack for now, but really should not allow height to be negative!
			{
				if (y < top && y > top + height)
				{
					return true;
				}
			}
			else
			{
				if (y > top && y < top + height)
				{
					return true;
				}
				
			}
		}
		return false;
	}

}
