package org.processmining.processprofiler3d.compviz.jogl.interactions;

import org.processmining.visualisation3d.JoglInteraction;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCamera;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCameraLens;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCameraLensPerspective;
import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.scenemanagement.JoglScene;

public class JIDepthRangeCompressor extends JoglInteraction
{
	private JoglCamera cam = null;
	
    public JIDepthRangeCompressor(JoglCamera c)
    {
    	this.cam = c;
    	
    	//make sure this is the last interaction in stack to execute UpdateScene
    	zlevel = 1000.0f;
    }

	@Override
	public void UpdateScene(JoglScene scene)
	{		
		//System.out.println("DepthCompressor update scene");
		JoglVectord2 r1 = cam.calcDepthRange(scene.getBoundingBoxes());
		JoglCameraLens oldLens = cam.getCameraLens();
		if (oldLens instanceof JoglCameraLensPerspective)
		{
			JoglCameraLensPerspective oldLensP = (JoglCameraLensPerspective)oldLens;
			cam.setCameraLens(new JoglCameraLensPerspective(oldLensP.getFieldOfView(), oldLens.getAspect(), r1.getX(), r1.getY()));
		}
	}
}
