package org.processmining.processprofiler3d.compviz.jogl.interactions;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnEdge;
import org.processmining.processprofiler3d.compviz.jogl.scene.datavis.JSODataVisMagnetLineBase;
import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;

public class JIPSENEdgeInfo extends JIPSENBaseInfo
{
	public JIPSENEdgeInfo(JoglInteractionManager iman, JSOGraphicalUserInterface gui, JSOPnEdge edge, String infoTitle, IPerformanceStatisticsEnrichedNet psnet)
	{
		super(iman, gui);
		
		String tIDs = edge.transitionPairID;

		dataThread = new AsyncInfoThreadEdge(tIDs, psnet, this);
		dataThread.start();
		
		//SetData(StatsList(tIDs, psnet));
		header = infoTitle;
		
		infoSubject = edge;
	}
	
	public JIPSENEdgeInfo(JoglInteractionManager iman, JSOGraphicalUserInterface gui, JSODataVisMagnetLineBase line, String infoTitle, IPerformanceStatisticsEnrichedNet psnet)
	{
		super(iman, gui);
		
		String tIDs = line.getParentRef();
		
		dataThread = new AsyncInfoThreadEdge(tIDs, psnet, this);
		dataThread.start();
		
		//SetData(StatsList(tIDs, psnet));
		header = infoTitle;
		
		infoSubject = line;
	}
}
