package org.processmining.processprofiler3d.compviz.jogl.interactions;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.gui.JoglGuiScrollBar;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.gui.JoglGuiObject;
import org.processmining.visualisation3d.input.JoglInputMouseEvent;
import org.processmining.visualisation3d.interactions.JoglGuiInteraction;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;
import org.processmining.visualisation3d.scenemanagement.JoglScene;

public class JIScrollBarMove extends JoglGuiInteraction
{
	private JoglInteractionManager iman;
	
	private boolean bUpdateScene = false;
	
	private JoglGuiScrollBar scrollB;
	
	public JIScrollBarMove(JoglInteractionManager iman, JSOGraphicalUserInterface gui, JoglGuiScrollBar sb, JoglInputMouseEvent e)
	{
		super(gui);
		
		this.iman = iman;
		this.scrollB = sb;
		
		//setZLevel(-2.5f);
		setZLevel(-2000.0f);
		
		mousePressed(e);
	}
	
	@Override
	public boolean ShouldAnimate()
	{
		return bUpdateScene;
	}
	
	@Override
	public void UpdateScene(JoglScene scene)
	{
		bUpdateScene = false;
    }
	
	//MouseListener method implementation
	@Override
    public boolean mousePressed(JoglInputMouseEvent e) 
    {
		Vector<JoglGuiObject> jgo = gui.GetObjectsFromPos(e.getX(), e.getY());
		if (jgo != null)
		{
			if (jgo.contains(scrollB))
			{
				scrollB.mousePressed(e);
				bUpdateScene = true;
				
				return true;
			}
		}
		return false;
    }
	
	@Override
    public boolean mouseReleased(JoglInputMouseEvent e) 
    {
		scrollB.mouseReleased(e);
		iman.removeInteraction(this);
		
		return true;
    }
	
	@Override
    public void mouseDragged(JoglInputMouseEvent e) 
    {
		if (scrollB != null && scrollB.IsScrollbarMoving())
		{
			scrollB.mouseDragged(e);
			bUpdateScene = true;
		}
    }

}
