package org.processmining.processprofiler3d.compviz.jogl.interactions;

import org.processmining.processprofiler3d.compviz.jogl.input.PP3DKeyBindings;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPetriNet;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnEdge;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnTransition;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;
import org.processmining.processprofiler3d.compviz.jogl.scene.datavis.JSODataVisMagnetLineBase;
import org.processmining.processprofiler3d.compviz.scenemanagement.JoglModelScene;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.input.JoglInputKeyEvent;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

public class JIViewManagerPSEN extends JIViewManagerModel
{	
	public JIViewManagerPSEN(JoglInteractionManager iman, JoglModelScene scene, JSOGraphicalUserInterface gui)
	{
		super(iman, scene, gui);
	}
	
	//KeyListener method implementations
	@Override
	public boolean keyPressed(JoglInputKeyEvent evt) 
	{
        //System.out.println(evt);
        
		if (evt.getKeyCode() == PP3DKeyBindings.SwitchCameraMode) //c-key
		{
			SwitchCameraMode();

        	bUpdateScene = true;
		}
		if (evt.getKeyCode() == PP3DKeyBindings.ToggleFloatingLabels) //f-key
		{
			SwitchFloatingLabels();

        	bUpdateScene = true;
		}
		if (evt.getKeyCode() == PP3DKeyBindings.ToggleGrid) //g-key
		{
			SwitchGrid();

        	bUpdateScene = true;
		}
		if (evt.getKeyCode() == PP3DKeyBindings.ToggleInfoPanel) //i-key
		{
			ToggleInfoPanel();
		}
		if (evt.getKeyCode() == PP3DKeyBindings.ToggleSubprocess) //n-key
		{
			JISelectModelElement jsme = iman.findInteraction(JISelectModelElement.class);
			if (jsme != null)
			{			
				for (JSOSubNet snet : scene.findSceneObject(JSOPetriNet.class).getAllSubNets())
				{
					if (snet.getParent() != null && jsme.getSelection().contains(snet.getParent()))
					{
						ToggleSubNet(snet, 0.02f);
					}
				}
	        	bUpdateScene = true;
			}
		}
		
		return false;
	}

	private void ToggleInfoPanel() 
	{
		JIPSENSelectModelElement psme = iman.findInteraction(JIPSENSelectModelElement.class);
		if (psme != null)
		{
			if (psme.getInfoPanel() != null)
			{
				psme.CloseExistingInfoPanel();
			}
			else
			{
				for (JoglSceneObject so : psme.getSelection().getElements())
				{
					if (so instanceof JSOPnTransition)
					{
						psme.OpenInfoPanel((JSOPnTransition)so);
					}
					else if (so instanceof JSOPnEdge)
					{
						psme.OpenInfoPanel((JSOPnEdge)so);
					}
					else if (so instanceof JSODataVisMagnetLineBase)
					{
						psme.OpenInfoPanel((JSODataVisMagnetLineBase)so);
					}
				}
			}

			bUpdateScene = true;
		}
	}

}
