package org.processmining.processprofiler3d.compviz.jogl.interactions.cohortsplit;

import java.util.Date;
import java.util.Vector;
import java.util.concurrent.TimeUnit;

import org.deckfour.xes.model.XTrace;
import org.processmining.processprofiler3d.psen.classification.CohortClassifier;
import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PerformanceStatisticsDB;
import org.processmining.processprofiler3d.psen.replayanalysis.TimeSpan;

public class AsyncDataSplitThread extends Thread 
{
	private IPerformanceStatisticsEnrichedNet psen;
	private IPerformanceStatisticsEnrichedNet wten;
	private CohortClassifier mycc = null;

	private Vector<XTrace> tracelst;
	public boolean bProcessingDone = false;
	
	public AsyncDataSplitThread(IPerformanceStatisticsEnrichedNet psen, IPerformanceStatisticsEnrichedNet wten, CohortClassifier cc, Vector<XTrace> tracelst)
	{
		this.psen = psen;
		this.wten = wten;
		mycc = cc;
		
		this.tracelst = tracelst;
	}
	
    public void run() 
    {
    	PerformanceStatisticsDB psenDB = (PerformanceStatisticsDB)psen;
    	PerformanceStatisticsDB wtenDB = (PerformanceStatisticsDB)wten;
    	
    	this.setPriority(MIN_PRIORITY);
        System.out.println("Data split thread started!");
        
		Date startTime = new Date();
		
		psen.setCohortsForTraces(tracelst, mycc);
		wtenDB.keyStore.classToNum = psenDB.keyStore.classToNum;
		wtenDB.keyStore.numToClass = psenDB.keyStore.numToClass;
		psenDB.getTransitionLabelValueGroupsOptTbl("tableCalcTmp");
		wtenDB.getTransitionLabelValueGroupsOptTbl("tableCalcTmp2");
		Date endTime2 = new Date();
		TimeSpan ts2 = new TimeSpan(startTime, endTime2);
		System.out.println("Data split trace classification completed (" + ts2.ToString(TimeUnit.SECONDS) + "s).");
		
		bProcessingDone = true;
    }
}
