package org.processmining.processprofiler3d.compviz.jogl.interactions.cohortsplit;

import java.util.Vector;

import org.processmining.processprofiler3d.psen.classification.CohortDefinition;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.gui.JoglGuiObject;
import org.processmining.visualisation3d.interactions.JoglGuiInteraction;
import org.processmining.visualisation3d.scene.JSOGraphicalUserInterface;
import org.processmining.visualisation3d.scenemanagement.JoglScene;

public class JICohortConfig2Panel extends JoglGuiInteraction
{
	protected JoglScene scene;
	protected JoglInteractionManager iman;
	protected JICohortConfig2 parent = null;
	
	private Vector<JoglGuiObject> controls = new Vector<JoglGuiObject>();
	
	private boolean bInit = true;
	
	protected CohortDefinition resultCohort = null;
	
	public CohortDefinition getResultCohort()
	{
		return resultCohort;
	}
	
	public JICohortConfig2Panel(JoglInteractionManager iman, JoglScene scene, JSOGraphicalUserInterface gui, JICohortConfig2 jicc)
	{
		super(gui);
		
		this.parent = jicc;
		this.scene = scene;
		this.iman = iman;
		
		setZLevel(-200.0f);
		
		//updatedAttribute();
	}
	
	
	public void Init()
	{	
		bInit = false;
	}

	
	public void Dispose()
	{	
		for (JoglGuiObject jgo : controls)
		{
			gui.RemoveGuiObject(jgo);
		}
	}
	
	private boolean bUpdateScene = false;
	
	@Override
	public boolean ShouldAnimate()
	{
		return bUpdateScene;
	}
	
	@Override
	public void UpdateScene(JoglScene scene)
	{	
		if (bInit)
		{
			Init();
		}
		
		bUpdateScene = false;
	}
	
	public void Close()
	{
		//JISplitCohorts.preferredAttribute = btnAttribute.getText();
		
		Dispose();
		iman.removeInteraction(this);
		
		parent.Close();
	}
	
}
