package org.processmining.processprofiler3d.compviz.jogl.interactions.replay;

import java.util.HashMap;
import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnNode;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;

public class LaneCache 
{
	private static HashMap<String, ITokenLane> laneCache = new HashMap<String, ITokenLane>();
	private static HashMap<JSOSubNet, Vector<ITokenLane>> lanesByNet = new HashMap<JSOSubNet, Vector<ITokenLane>>();

	public static ITokenLane getStaticLane(JSOPnNode pnode)
	{
		String lid = pnode.getOrgNode().getLocalID().toString();
		if (laneCache.containsKey(lid))
		{
			//c.setTokenLane(laneCache.get(lid));
			return laneCache.get(lid);
		}
		else
		{
			ITokenLane l = new TokenLaneStatic(pnode);
			//c.setTokenLane(l);
			laneCache.put(lid, l);
			if (!lanesByNet.containsKey(l.getSubnet()))
			{
				lanesByNet.put(l.getSubnet(), new Vector<ITokenLane>());
			}
			lanesByNet.get(l.getSubnet()).add(l);
			return l;
		}
	}
	
	public static ITokenLane getEdgeLane(JSOPnNode source, JSOPnNode target)
	{
		String lid = source.getOrgNode().getLocalID().toString() + target.getOrgNode().getLocalID().toString();
		if (laneCache.containsKey(lid))
		{
			return laneCache.get(lid);
		}
		else
		{
			ITokenLane l = new TokenLaneEdge(source, target);
			laneCache.put(lid, l);
			if (!lanesByNet.containsKey(l.getSubnet()))
			{
				lanesByNet.put(l.getSubnet(), new Vector<ITokenLane>());
			}
			lanesByNet.get(l.getSubnet()).add(l);
			
			return l;
		}
	}
	
	public static Vector<ITokenLane> getLanesForSubnet(JSOSubNet snet)
	{
		if (lanesByNet.containsKey(snet))
		{
			return lanesByNet.get(snet);
		}
		return new Vector<ITokenLane>();
	}
	
	public static void Clear()
	{
		laneCache.clear();
		lanesByNet.clear();
	}
}
