package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialCamWidgetCube extends JoglMaterial
{
	private boolean bOldDepthTest = false;
	private MaskState oldMaskState = MaskState.DrawBoth;
	private BlendMode oldDrawMode = BlendMode.Opaque;
	
	public MaterialCamWidgetCube()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		bOldDepthTest = bDepthTest;
		oldMaskState = currentMaskState;
		oldDrawMode = currentBlendMode;
		
		setDepthTest(false);
		setMaskState(MaskState.DrawColorOnly);

		setDrawMode(BlendMode.AlphaBlended);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		setDrawMode(oldDrawMode);
		setDepthTest(bOldDepthTest);
		setMaskState(oldMaskState);
	}
}
