package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialCamWidgetCubeBase extends JoglMaterial
{
	private boolean bOldDepthTest = false;
	private MaskState oldMaskState = MaskState.DrawBoth;
	private CullState oldCullState = CullState.CullNone;
	
	public MaterialCamWidgetCubeBase()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		bOldDepthTest = bDepthTest;
		oldMaskState = currentMaskState;
		oldCullState = currentCullState;
		
		setMaskState(MaskState.DrawColorOnly);
		setDepthTest(false);
		setCullState(CullState.CullFront); //looks like winding order in the model is wrong, might want to fix that eventually			
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setDepthTest(bOldDepthTest);
		setMaskState(oldMaskState);
		setCullState(oldCullState);
	}
}
