package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.processprofiler3d.compviz.jogl.shaders.JoglShaderTrajectory;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.settings.JoglGraphicsSettings;

public class MaterialCamWidgetCubeSides extends JoglMaterial
{
	private JoglShader shad = null;
	
	public MaterialCamWidgetCubeSides()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		if (shad == null)
		{
			InitShaders(pipe);
		}
		
		if (shad != null)
		{
			shad.Bind(pipe);
		}
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		if (shad != null)
		{
			shad.Unbind(pipe);
		}
	}
	
	private void InitShaders(GraphicsPipeline pipe)
	{
		if (JoglGraphicsSettings.SupportsShaderObjects(pipe))
		{
			shad = new JoglShaderTrajectory();
			shad.Create(pipe);
		}
	}
}
