package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.maths.JoglColor3;

public class MaterialEdgeVertex extends JoglMaterial
{
	private CullState oldCullState = CullState.CullNone;
	
	public MaterialEdgeVertex()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		oldCullState = currentCullState;
		
		//looks like winding order in the model is wrong, might want to fix that eventually
		setCullState(CullState.CullBack);
		
		setColor(JoglColor3.RED);   // set the color of the quad (red)
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setCullState(oldCullState);
		setColor(JoglColor3.WHITE);   // set the color of the quad (red)
	}
}
