package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialGuiColoredRect extends JoglMaterial
{
	private boolean bAlphaSet = false;
	private BlendMode oldBlendMode = BlendMode.Opaque;
	
	public MaterialGuiColoredRect()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		oldBlendMode = currentBlendMode;
		
		setColor(1.0f, 1.0f, 1.0f, 1.0f);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		if (bAlphaSet)
		{
			setDrawMode(oldBlendMode);
			bAlphaSet = false;
		}
	}
	
	public void DrawAlpha(float colorA)
	{
		if (colorA < 1.0f)
		{
			setDrawMode(BlendMode.AlphaBlended);
			bAlphaSet = true;
		}	
	}
}
