package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.processprofiler3d.compviz.jogl.shaders.JoglShaderTextRender;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class MaterialGuiTextRenderer extends JoglMaterial
{
	private BlendMode oldBlendMode = BlendMode.Opaque;
	private JoglShader shad;
	
	public MaterialGuiTextRenderer()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		if (shad == null)
		{
			shad = new JoglShaderTextRender();
			shad.Create(pipe);
		}
		
		oldBlendMode = currentBlendMode;
		setDrawMode(BlendMode.AlphaBlended);

		shad.Bind(pipe);
		//setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		shad.Unbind(pipe);
		
		setDrawMode(oldBlendMode);
		
		setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
	}
	
	public void DrawColor(float r, float g, float b, float a)
	{
		setColor(r, g, b, a);   // set the color of the quads
		shad.SetUniform(pipe, "textColor", new JoglVectord3(r, g, b));
	}
}
