package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialGuiTexturedRect extends JoglMaterial
{
	private boolean bAlphaSet = false;
	private BlendMode oldBlendMode = BlendMode.Opaque;
	
	public MaterialGuiTexturedRect()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		oldBlendMode = currentBlendMode;
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		if (bAlphaSet)
		{
			setDrawMode(oldBlendMode);
			bAlphaSet = false;
		}
	}
	
	public void DrawColor(float colorR, float colorG, float colorB, float colorA, boolean bAlpha)
	{
		if (bAlpha || colorA < 1.0f)
		{
			setDrawMode(BlendMode.AlphaBlended);
			bAlphaSet = true;
		}	
		setColor(colorR, colorG, colorB, colorA);
	}
}
