package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.maths.JoglVectord3;

import com.jogamp.opengl.GL;

public class MaterialPetrinetElementBatch extends JoglMaterial
{
	public MaterialPetrinetElementBatch()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		setDepthTest(true);
		setMaskState(MaskState.DrawBoth);
		setCullState(CullState.CullBack);

		//sanity check!!!
		if (JoglShader.boundShader != null)
		{
			JoglShader.boundShader.Unbind(pipe);
		}
		gl.glBindTexture(GL.GL_TEXTURE_2D, 0);	
		
		setColor(1.0, 1.0, 1.0, 1.0);   // set the color of the quads
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setCullState(CullState.CullNone);
		setColor(1, 1, 1, 1.0f);   // set the color of the quads
	}
	
	public void DrawColor(JoglVectord3 color)
	{
		setColor(color.getX(), color.getY(), color.getZ(), 1.0f);   // set the color of the quads
	}
}
