package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialPetrinetElementBatchMasked extends JoglMaterial
{
	private boolean oldDepthTest = true;
	private CullState oldCullState = CullState.CullNone;
	private MaskState oldMaskState = MaskState.DrawBoth;
	
	public MaterialPetrinetElementBatchMasked()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		oldDepthTest = bDepthTest;
		oldCullState = currentCullState;
		oldMaskState = currentMaskState;
		
		setDepthTest(false);
		setMaskState(MaskState.DrawColorOnly);
		setCullState(CullState.CullBack);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		setDepthTest(oldDepthTest);
		setMaskState(oldMaskState);
		setCullState(oldCullState);
	}
}
