package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.materials.JoglMaterial;

import com.jogamp.opengl.GL;

public class MaterialSubnetPedestalSurface extends JoglMaterial
{
	private BlendMode oldDrawMode = BlendMode.Opaque;
	private CullState oldCullState = CullState.CullNone;
	
	public MaterialSubnetPedestalSurface()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		//sanity check!!!
		if (JoglShader.boundShader != null)
		{
			JoglShader.boundShader.Unbind(pipe);
		}
		gl.glBindTexture(GL.GL_TEXTURE_2D, 0);	
		
		oldCullState = currentCullState;
		oldDrawMode = currentBlendMode;
		
		setCullState(CullState.CullBack);
		
		setDrawMode(BlendMode.AlphaBlended);

		setColor(0.75f, 0.75f, 0.75f, 0.75f);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setDrawMode(oldDrawMode);
		setCullState(oldCullState);
	}
}
