package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialTextRenderer extends JoglMaterial
{
	private boolean bOldDepthTest = false;
	private MaskState oldMaskState = MaskState.DrawBoth;
	private BlendMode oldDrawMode = BlendMode.Opaque;
	
	public MaterialTextRenderer()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		bOldDepthTest = bDepthTest;
		oldMaskState = currentMaskState;
		oldDrawMode = currentBlendMode;
		
		setDrawMode(BlendMode.AlphaBlended);
		setDepthTest(false);
		setMaskState(MaskState.DrawColorOnly);

		//setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setDepthTest(bOldDepthTest);
		setMaskState(oldMaskState);
		setDrawMode(oldDrawMode);
		
		setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
	}
	
	public void DrawColor(float r, float g, float b, float a)
	{
		setColor(r, g, b, a);   // set the color of the quads
	}
}
