package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.processprofiler3d.compviz.fileio.BMFontFile;
import org.processmining.processprofiler3d.compviz.jogl.shaders.JoglShaderTextRenderDF;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.JoglResourceManager;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.gldatastructures.JoglTexture;
import org.processmining.visualisation3d.materials.JoglMaterial;

public class MaterialTextRendererDF extends JoglMaterial
{
	private boolean oldDepthTest = false;
	private MaskState oldMaskState = MaskState.DrawBoth;
	private BlendMode oldDrawMode = BlendMode.Opaque;
	
	private static BMFontFile mybmf;
    private static JoglTexture bmfTex = null;
    private static JoglShader shad;
    
    private JoglTexture tex = bmfTex;
    
	public MaterialTextRendererDF()
	{
	}

	public void setBMF(BMFontFile bmf)
	{
		mybmf = bmf;
	}
	
	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		oldDepthTest = bDepthTest;
		oldMaskState = currentMaskState;
		oldDrawMode = currentBlendMode;
		
		setDrawMode(BlendMode.AlphaBlended);
		setDepthTest(false);
		setMaskState(MaskState.DrawColorOnly);

		//setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
		
        if (bmfTex == null)
        {
        	if (mybmf.tex == null)
        	{
        		mybmf.LoadFontTexture(pipe);
        	}
        	bmfTex = mybmf.tex;
        }

        if (shad == null)
        {
			if (JoglResourceManager.HasResource("TextShaderDF"))
			{
				shad = (JoglShader)JoglResourceManager.GetResource("TextShaderDF");
			}
			else
			{
				shad = new JoglShaderTextRenderDF();
				shad.Create(pipe);
				
				JoglResourceManager.AddResource("TextShaderDF", shad);
			}
        }
        shad.Bind(pipe);
        shad.SetUniform(pipe, "tex", 0);
        //shad.SetUniform(gl, "textScale", 1.0f);
        
        tex = bmfTex;
	    tex.Bind(pipe);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

	    tex.Unbind(pipe);
	    
	    shad.Unbind(pipe);
	    
		setDepthTest(oldDepthTest);
		setMaskState(oldMaskState);
		setDrawMode(oldDrawMode);
		
		setColor(1.0f, 1.0f, 1.0f, 1.0f);   // set the color of the quads
	}
	
	public void DrawColor(float r, float g, float b, float a)
	{
		setColor(r, g, b, a);   // set the color of the quads
	}
}
