package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class MaterialTokenCube extends JoglMaterial
{
	private CullState oldCullState = CullState.CullNone;
	
	public MaterialTokenCube()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);
		
		oldCullState = currentCullState;
		
		//looks like winding order in the model is wrong, might want to fix that eventually
		setCullState(CullState.CullFront);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);
		
		setCullState(oldCullState);
	}
	
	public void DrawColor(JoglVectord3 color)
	{
		setColor(color);   // set the color of the quad (red)
	}
}
