package org.processmining.processprofiler3d.compviz.jogl.materials;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.materials.JoglMaterial;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class MaterialTokenCubeOpt2 extends JoglMaterial
{
	private boolean oldDepthTest = true;
	private CullState oldCullState = CullState.CullNone;
	
	public MaterialTokenCubeOpt2()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		oldDepthTest = bDepthTest;
		oldCullState = currentCullState;
		
		setDepthTest(false);
		setCullState(CullState.CullBack);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		setDepthTest(oldDepthTest);
		setCullState(oldCullState);
	}
	
	public void DrawColor(JoglVectord3 color)
	{
		setColor(color);   // set the color of the quad (red)
	}
}
