uniform samplerCube Env;

in vec2 texCoord;
out vec4 fragColor;

void main(){

  // SphericalCoordinates
  // Source: http://mathworld.wolfram.com/SphericalCoordinates.html
  vec3 coords;
  coords.x = cos(texCoord.x) * sin(texCoord.y);
  coords.z = sin(texCoord.x) * sin(texCoord.y);
  coords.y = cos(texCoord.y);

	fragColor.rgb = texture(Env, coords).rgb;
	fragColor.a = 1.0;
}
