varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;

void main( )
{
	vec2 texcoord = (gl_FragCoord.xy) / textureSize(my_color_texture, 0);
	vec4 tex = texture2D(my_color_texture, texcoord);
	
	if (tex.r == 1.0)
	{
		discard;
	}

	//vec4 colorRed = vec4(1.0, 0.0, 0.0, 1.0);
	vec4 colorBack = vec4(0.3, 0.5, 0.7, 1.0);
	vec4 colorGrid = vec4(0.75, 0.75, 0.75, 1.0);

	float maxDepth = 2000;
	float depthFactor = min(1.0, ((gl_FragCoord.z / gl_FragCoord.w) / maxDepth));

	gl_FragColor = mix(colorGrid, colorBack, depthFactor);
}
