package org.processmining.processprofiler3d.compviz.jogl.scene;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.datavis.JSODataVisGroup;
import org.processmining.processprofiler3d.psen.fileio.obj.OBJWriter;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.JoglInteractionManager;
import org.processmining.visualisation3d.JoglPanel;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.scenemanagement.JoglScene;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;
import org.processmining.visualisation3d.settings.JoglGraphicsSettings;

public class JSOPSENVisualizationLayer extends JoglSceneObject 
{
	public JoglScene scene;
	public JSOSubNet snet;
	public JSOCohortColorManager cohortColors;
	public JoglInteractionManager iman;
	public JoglGraphicsSettings gSettings;

	public Vector<JSODataVisGroup> elements;
	public Vector<JSODataVisGroup> viselements;
	
	protected JoglAABB boundingBox;

	public JSOSubNet getSubNet()
	{
		return snet;
	}
	
	public JoglAABB getAABB()
	{
		return boundingBox;
	}
	
	public int getElementCount()
	{
		return elements.size();
	}
	
	public JSOPSENVisualizationLayer(JoglScene scene, JSOSubNet snet, JSOCohortColorManager jccm, JoglPanel p)
	{
		this.scene = scene;
		this.snet = snet;
		
		cohortColors = jccm;
		iman = p.getInteractionManager();
		gSettings = p.getGraphicsSettings();
		
		elements = new Vector<JSODataVisGroup>();
		viselements = new Vector<JSODataVisGroup>();
	}
	
	public void BuildScene()
	{
	}
	
	@Override
	public void DrawObject(GraphicsPipeline pipe)
	{
	}

	
	public void Export(OBJWriter out)
	{
		for (int i = 0; i < viselements.size(); i++)
		{
			JSODataVisGroup group = viselements.get(i);
			group.Export(snet, out);
		}
	}
	
	public void Dispose()
	{
	}
}
