package org.processmining.processprofiler3d.compviz.jogl.scene;

import org.processmining.processprofiler3d.compviz.jogl.drawing.IMeshDrawer;
import org.processmining.processprofiler3d.compviz.jogl.materials.MaterialEdgeVertex;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.JoglResourceManager;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class JSOPnEdgeVertex extends JSOPnNode
{
	public int vertexId;
	public JoglVectord3 vertexPos;
	public JSOPnEdge myEdge = null;
	private boolean bVisible = false;

	public JSOPnEdgeVertex()
	{
		// TODO Auto-generated constructor stub
	}
	
	public void Show()
	{
		bVisible = true;
	}
	
	public void Hide()
	{
		bVisible = false;
	}

	private static JoglShader getShader(GraphicsPipeline pipe) 
	{
		JoglShader s = null;
		if (JoglResourceManager.HasResource("EdgeVertexShader"))
		{
			s = (JoglShader)JoglResourceManager.GetResource("EdgeVertexShader");
		}
		else
		{
			s = new JoglShader("/org/processmining/processprofiler3d/compviz/jogl/resources", "vaoOtherShaderVS2","vaoOtherShaderFS2");
			s.Create(pipe);
			
			JoglResourceManager.AddResource("EdgeVertexShader", s);
		}
		return s;
	}
	
	private IMeshDrawer md = null;
	private static MaterialEdgeVertex matTC = new MaterialEdgeVertex();
	
	@Override
	public void DrawObject(GraphicsPipeline pipe)
	{
		if (!bVisible)
		{
			return;
		}
		
		if (md == null)
		{
			md = TokenDrawer.GenerateVAO(pipe, 5.0f);
		}
		
		JoglShader shad = getShader(pipe);

		pipe.transform.Push();
		pipe.transform.MultMatrix(transform);
		
		matTC.Apply(pipe);
		
		shad.Bind(pipe);
		md.Draw(pipe);
		shad.Unbind(pipe);
		
		matTC.Unapply(pipe);

		pipe.transform.Pop();
	}
	
	public void UpdateAABB()
	{
		double halfwidth = 5.0;
		JoglVectord3 amin = new JoglVectord3(-halfwidth, -5, -halfwidth);
		JoglVectord3 amax = new JoglVectord3(halfwidth, 0, halfwidth);
		
		JoglVectord3 vmin = new JoglVectord3(position.getX() + amin.getX(), position.getY() + amin.getY(), position.getZ() + amin.getZ());
		JoglVectord3 vmax = new JoglVectord3(position.getX() + amax.getX(), position.getY() + amax.getY(), position.getZ() + amax.getZ());

		JoglAABB aabb = new JoglAABB(vmin, vmax);
		
		boundingBox = aabb;
	}

}
