package org.processmining.processprofiler3d.compviz.jogl.scene;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.maths.JoglMatrixd4x4;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class JSOPnNode extends JSOPnElement
{
	protected JoglVectord3 position = new JoglVectord3(0,0,0);
	protected JoglMatrixd4x4 transform = JoglMatrixd4x4.CreateIdentity();

	protected JoglAABB boundingBox;

	public JoglAABB getAABB()
	{
		return boundingBox;
	}
	
	public JoglVectord3 getPosition()
	{
		return position;
	}
	
	public void setPosition(double x, double y, double z)
	{
		position = new JoglVectord3(x,y,z);
		transform = JoglMatrixd4x4.CreateTranslation(x, y, z);
	}

	public void setPosition(JoglVectord3 position) 
	{
		this.position = position;
		transform = JoglMatrixd4x4.CreateTranslation(position.getX(), position.getY(), position.getZ());
	}
	
	public PetrinetNode getOrgNode()
	{
		return null;
	}
}
