package org.processmining.processprofiler3d.compviz.jogl.scene;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.graphicsdatastructures.JoglColoredMesh;
import org.processmining.processprofiler3d.compviz.jogl.drawing.IMeshDrawer;
import org.processmining.processprofiler3d.compviz.jogl.drawing.VAODrawer;
import org.processmining.processprofiler3d.compviz.jogl.shaders.JoglShaderTrajectory;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.graphicsdatastructures.JoglMeshIndexBuffer;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

import com.jogamp.opengl.GL2;

/*
 * A quad to render in the scene
 */
public class JSOQuad extends JoglSceneObject 
{
	private IMeshDrawer vao;
	private static JoglShader shad;
	
	private static Vector<JoglVectord3> GenerateGeometry()
	{
		Vector<JoglVectord3> lst = new Vector<JoglVectord3>();
		
		lst.add(new JoglVectord3(-1.0f, 1.0f, 0.0f));   // Top Left
		lst.add(new JoglVectord3( 1.0f, 1.0f, 0.0f));   // Top Right
		lst.add(new JoglVectord3( 1.0f,-1.0f, 0.0f));   // Bottom Right
		lst.add(new JoglVectord3(-1.0f,-1.0f, 0.0f));   // Bottom Left
		
		return lst;
	}
	
	private static Vector<JoglVectord3> GenerateColor()
	{
		Vector<JoglVectord3> lst = new Vector<JoglVectord3>();
		
		lst.add(new JoglVectord3(0.0f, 0.0f, 1.0f));   // Top Left
		lst.add(new JoglVectord3(0.0f, 0.0f, 1.0f));   // Top Right
		lst.add(new JoglVectord3(0.0f, 0.0f, 1.0f));   // Bottom Right
		lst.add(new JoglVectord3(0.0f, 0.0f, 1.0f));   // Bottom Left
		
		return lst;
	}
	
	private JoglColoredMesh CreateMesh()
	{
		JoglColoredMesh jcm = new JoglColoredMesh(GL2.GL_QUADS);
		jcm.setVerts(GenerateGeometry());
		jcm.setColors3(GenerateColor());
		jcm.setIndexBuffer(JoglMeshIndexBuffer.GenerateIndicesQuad(jcm.getNumVerts()));
		
		return jcm;
	}
	
	@Override
	public void DrawObject(GraphicsPipeline pipe)
	{
		// Draw A Quad
//		gl.glBegin(GL2.GL_QUADS);       
//		
//		gl.glColor3f(0.0f, 0.0f, 1.0f);   // set the color of the quad
//		gl.glVertex3f(-1.0f, 1.0f, 0.0f);   // Top Left
//		gl.glVertex3f( 1.0f, 1.0f, 0.0f);   // Top Right
//		gl.glVertex3f( 1.0f,-1.0f, 0.0f);   // Bottom Right
//		gl.glVertex3f(-1.0f,-1.0f, 0.0f);   // Bottom Left
//		
//		// Done Drawing The Quad
//		gl.glEnd(); 
		
		if (vao == null)
		{
			vao = new VAODrawer();
			vao.LoadMesh(pipe, CreateMesh());
		}
		if (shad == null)
		{
			shad = new JoglShaderTrajectory();
			shad.Create(pipe);
		}
		
		shad.Bind(pipe);
		vao.Draw(pipe);
		shad.Unbind(pipe);
	}

}
