package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;
import org.processmining.processprofiler3d.psen.fileio.obj.OBJWriter;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

public class JSODataVisGroup extends JoglSceneObject
{
	protected JoglAABB aabb = null;
	
	public String parentRef = "";
	
	protected Vector<JoglSceneObject> elements;

	public JoglAABB getAABB()
	{
		return aabb;
	}
	
	public Vector<JoglSceneObject> getElements()
	{
		return elements;
	}
	
	public boolean isEmpty()
	{
		return elements.isEmpty();
	}
	
	public JSODataVisGroup()
	{
		elements = new Vector<JoglSceneObject>();
	}
	
	public void addElement(JoglSceneObject jso)
	{
		elements.add(jso);
	}
	
	public JoglAABB updateAABB()
	{
		return null;
	}
	
	@Override
	public void DrawObject(GraphicsPipeline pipe)
	{
		for (int j = 0; j < elements.size(); j++)
		{
			elements.get(j).DrawObject(pipe);
		}
	}
	
	public void Export(JSOSubNet snet, OBJWriter out)
	{
		for (int j = 0; j < elements.size(); j++)
		{
			JoglSceneObject jso = elements.get(j);
			if (jso instanceof JSODataVisBarChart)
			{
				JSODataVisBarChart jbc = (JSODataVisBarChart)jso;
				jbc.Export(snet, out);
			}
			if (jso instanceof JSODataVisTriangle)
			{
				JSODataVisTriangle jt = (JSODataVisTriangle)jso;
				jt.Export(snet, out);
			}
			if (jso instanceof JSODataVisMagnetLineBase)
			{
				JSODataVisMagnetLineBase jt = (JSODataVisMagnetLineBase)jso;
				jt.Export(snet, out);
			}
		}
	}
}
