package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import java.util.HashSet;
import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnTransition;
import org.processmining.processprofiler3d.compviz.jogl.scene.VisualisationDataPipeline;
import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class JSODataVisGroupBarChart1D extends JSODataVisGroupBarChartBase
{
	private boolean bVerbose = false;
	
	public JSODataVisGroupBarChart1D(JSOPnTransition t, VisualisationDataPipeline tdp, double barHeight)
	{
		HashSet<String> classifiers = tdp.classifiers;
		
		Vector<JoglVectord3> cols = new Vector<JoglVectord3>();
		Vector<Float> valsX = new Vector<Float>();
		Vector<Float> valsY = new Vector<Float>();
		for (String classifier : classifiers)
		{	
			if (tdp.map1.hasValue(t.orgTransition, classifier))
			{
				//JoglVectord3 col = colorsByCohort.get(classifier);
				JoglVectord3 col = tdp.cohortColors.getColorForCohort(classifier);
				cols.add(col);
				
				double val1 = tdp.map1.getValueR(t.orgTransition, classifier);
				val1 = tdp.TransformScale1(val1);
				//System.out.println(t.getLabel() + " has data value: " + val1);
				valsX.add((float)val1);
				valsY.add(1.0f);
			}
			else if (bVerbose)
			{
				System.out.println(t.getLabel() + " has no data value.");
			}
		}
		
		JoglVectord3 pos = t.getPosition();
		JoglVectord2 size = t.getSize();	
		
		double barWidth = (size.getX());

		double posXx = (pos.getX() + (size.getX() * 0.5)) - (barWidth * 0.5);
		double posYx = pos.getZ() + (size.getY() * 0.5);
		
		JSODataVisBarChart bar = new JSODataVisBarChart();
		bar.setPosition(posXx, 0, posYx);
		bar.setSize((float)barWidth, (float)barHeight);
		bar.setData(valsX, valsY, cols);
		
		this.parentRef = t.orgTransition.getLocalID().toString();
		this.addElement(bar);
	}
}
