package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import java.util.HashSet;
import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnTransition;
import org.processmining.processprofiler3d.compviz.jogl.scene.VisualisationDataPipeline;
import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class JSODataVisGroupBarChart2DColor extends JSODataVisGroupBarChartBase
{
	private boolean bVerbose = false;
	
	public JSODataVisGroupBarChart2DColor(JSOPnTransition t, VisualisationDataPipeline tdp, double barHeight, double barHeight2)
	{
		HashSet<String> classifiers = tdp.classifiers;
		
		JoglVectord3 blendCol = new JoglVectord3(1.0,1.0,1.0);
		
		Vector<JoglVectord3> cols = new Vector<JoglVectord3>();
		Vector<JoglVectord3> cols2 = new Vector<JoglVectord3>();
		Vector<Float> valsX = new Vector<Float>();
		Vector<Float> valsY = new Vector<Float>();
		for (String classifier : classifiers)
		{	
			if (tdp.map1.hasValue(t.orgTransition, classifier) && tdp.map2.hasValue(t.orgTransition, classifier))
			{
				//JoglVectord3 col = colorsByCohort.get(classifier);
				JoglVectord3 col = tdp.cohortColors.getColorForCohort(classifier);
				cols.add(col);
				
				double val1 = tdp.map1.getValueR(t.orgTransition, classifier);
				double val2 = tdp.map2.getValueR(t.orgTransition, classifier);
				val1 = tdp.TransformScale1(val1);
				val2 = tdp.TransformScale2(val2);
				valsX.add((float) (val1));
				valsY.add(1.0f);
				cols2.add(JoglVectord3.Blend(col, blendCol, (float)val2));
			}
			else if (bVerbose)
			{
				System.out.println(t.getLabel() + " has no data value.");
			}
		}
		
		JoglVectord3 pos = t.getPosition();
		JoglVectord2 size = t.getSize();	
		
		double barWidth = (size.getX());

		double posXx = (pos.getX() + (size.getX() * 0.5)) - (barWidth * 0.5);
		double posYx = pos.getZ() + (size.getY() * 0.5);
		
		JSODataVisBarChart bar = new JSODataVisBarChart();
		bar.setPosition(posXx, 0, posYx);
		bar.setSize((float)barWidth, (float)barHeight);
		bar.setData(valsX, valsY, cols2);
		
		//elements.add(bar);
		JSODataVisGroup group = new JSODataVisGroup();
		group.parentRef = t.orgTransition.getLocalID().toString();
		group.addElement(bar);
		
		JSODataVisBarChart bar2 = new JSODataVisBarChart();
		bar2.setPosition(posXx, barHeight, posYx);
		bar2.setSize((float)barWidth, (float)barHeight2);
		bar2.setData(valsX, valsY, cols);
		
		//elements.add(tri2);
		group.addElement(bar2);
		elements.add(group);
	}
}
