package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import org.processmining.processprofiler3d.compviz.graphicsdatastructures.JoglColoredMesh;
import org.processmining.processprofiler3d.compviz.jogl.drawing.IMeshDrawer;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

public class JSODataVisGroupBarChartBase extends JSODataVisGroup
{
	public JSODataVisGroupBarChartBase()
	{
	}

	public void LoadMesh(JoglColoredMesh jcm)
	{
		for (JoglSceneObject jso : elements)
		{
			if (jso instanceof JSODataVisBarChart)
			{
				JSODataVisBarChart dvbc = (JSODataVisBarChart)jso;
				dvbc.LoadMesh(jcm);
			}
		}
	}
	
	public void DrawObjectFast(GraphicsPipeline pipe, IMeshDrawer d)
	{
		for (JoglSceneObject jso : elements)
		{
			if (jso instanceof JSODataVisBarChart)
			{
				JSODataVisBarChart dvbc = (JSODataVisBarChart)jso;
				dvbc.DrawObjectFast(pipe, d);
			}
		}
	}
	
	public void Dispose()
	{
		//dispose VAOs properly
		for (JoglSceneObject jso : elements)
		{
			if (jso instanceof JSODataVisBarChart)
			{
				JSODataVisBarChart dvbc = (JSODataVisBarChart)jso;
				dvbc.Dispose();
			}
		}
	}
}
