package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.IDataVisMagnetLine;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;
import org.processmining.processprofiler3d.psen.fileio.obj.OBJWriter;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

public class JSODataVisMagnetLineBase extends JoglSceneObject implements IDataVisMagnetLine 
{	
	protected JSOSubNet jsoPnet;
	
	protected String parentRef = "";
	protected String cohortRef = "";
	protected String label = "";

	protected Vector<JoglVectord3> points;
	protected double length = 100.0;
	
	protected JoglAABB aabb = null;
	
	public JSODataVisMagnetLineBase(Vector<JoglVectord3> pts) 
	{
		super();
		
		points = pts;
		
		length = 0;
		for (int i = 0; i < pts.size() - 1; i++)
		{
			length = length + JoglVectord3.Distance(pts.get(i), pts.get(i+1));
		}
	}
	
	@Override
	public JSOSubNet getJSOPnet()
	{
		return jsoPnet;
	}
	
	@Override
	public void setJSOPnet(JSOSubNet snet)
	{
		jsoPnet = snet;
	}

	@Override
	public String getLabel()
	{
		return label;
	}

	@Override
	public void setLabel(String pr)
	{
		label = pr;
	}

	@Override
	public String getCohortRef()
	{
		return cohortRef;
	}

	@Override
	public void setCohortRef(String pr)
	{
		cohortRef = pr;
	}

	@Override
	public String getParentRef()
	{
		return parentRef;
	}

	@Override
	public void setParentRef(String pr)
	{
		parentRef = pr;
	}

	public JoglVectord3 getStartPoint()
	{
		return points.get(0);
	}

	public JoglVectord3 getEndPoint()
	{
		return points.get(points.size() - 1);
	}
	
	public Vector<JoglVectord3> getPoints()
	{
		return points;
	}
	
	public JoglAABB getAABB()
	{
		return aabb;
	}
	
	public JoglVectord3 getCamFocusPoint()
	{
		JoglVectord3 dir = JoglVectord3.Subtract(getEndPoint(), getStartPoint());
		JoglVectord3 center = JoglVectord3.Add(getStartPoint(), JoglVectord3.Multiply(dir, 0.5));
		return JoglVectord3.Add(center, getJSOPnet().getOffset());
	}
	
	public void Highlight()
	{
	}
	
	public void Unhighlight()
	{
	}
	
	public void Export(JSOSubNet snet, OBJWriter out)
	{
	}
	
	public String getExportMaterialNameFromColor(JoglVectord3 col)
	{
		if (col.getX() == 1 && col.getY() == 0 && col.getZ() == 0)
		{
			return "CohortRed";
		}
		if (col.getX() == 0 && col.getY() == 1 && col.getZ() == 0)
		{
			return "CohortGreen";
		}
		if (col.getX() == 0 && col.getY() == 0 && col.getZ() == 1)
		{
			return "CohortBlue";
		}
		if (col.getX() == 1 && col.getY() == 1 && col.getZ() == 0)
		{
			return "CohortYellow";
		}
		if (col.getX() == 0 && col.getY() == 1 && col.getZ() == 1)
		{
			return "CohortCyan";
		}
		if (col.getX() == 1 && col.getY() == 0 && col.getZ() == 1)
		{
			return "CohortMagenta";
		}
		if (col.getX() == 1 && col.getY() == 1 && col.getZ() == 1)
		{
			return "CohortWhite";
		}
		if (col.getX() == 1 && col.getY() == 0 && col.getZ() == 1)
		{
			return "CohortBlack";
		}
		
		return "ModelPedestal";
	}

}