package org.processmining.processprofiler3d.compviz.jogl.scene.datavis;

import java.util.Vector;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnTransition;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;
import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.collision.JoglAABB;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.scenemanagement.JoglSceneObject;

public class JSODataVisMagnetLineGroupBase extends JSODataVisGroup 
{
	protected JSOPnTransition sourceNode = null;
	protected JSOPnTransition targetNode = null;
	protected String label = "";
	protected JSOSubNet snet;

	public JSODataVisMagnetLineGroupBase(JSOSubNet snet, JSOPnTransition sourceNode, JSOPnTransition targetNode, String localIDs) 
	{
		super();

		this.snet = snet;
		
		this.parentRef = localIDs;
		
		this.sourceNode = sourceNode;
		this.targetNode = targetNode;
	}

	public String getLabel()
	{
		return label;
	}

	public void setLabel(String l) 
	{
		label = l;
	}

	public String getSourceRef() 
	{
		return sourceNode.getOrgNode().getLocalID().toString();
	}

	public String getTargetRef() 
	{
		return targetNode.getOrgNode().getLocalID().toString();
	}

	public Vector<JSODataVisMagnetLineBase> getMagnetLines() 
	{
		Vector<JSODataVisMagnetLineBase> lines = new Vector<JSODataVisMagnetLineBase>();
		for (JoglSceneObject jso : elements)
		{
			if (jso instanceof JSODataVisMagnetLineBase)
			{
				lines.add((JSODataVisMagnetLineBase)jso);
			}
		}
		return lines;
	}
	
	public void ClearMagnetLines()
	{
	}
	
	public void Dispose()
	{
	}

	@Override
	public JoglAABB updateAABB() 
	{
		double minx = Double.POSITIVE_INFINITY;
		double miny = Double.POSITIVE_INFINITY;
		double minz = Double.POSITIVE_INFINITY;
		double maxx = Double.NEGATIVE_INFINITY;
		double maxy = Double.NEGATIVE_INFINITY;
		double maxz = Double.NEGATIVE_INFINITY;
		
		for (int i = 0; i < elements.size(); i++)
		{
			JoglSceneObject jso = elements.get(i);
			if (jso instanceof JSODataVisMagnetLine)
			{
				JSODataVisMagnetLine line = (JSODataVisMagnetLine)jso;
				JoglAABB aabb = line.getAABB();
				
				minx = Math.min(minx, aabb.getMin().getX());
				miny = Math.min(miny, aabb.getMin().getY());
				minz = Math.min(minz, aabb.getMin().getZ());
				
				maxx = Math.max(maxx, aabb.getMax().getX());
				maxy = Math.max(maxy, aabb.getMax().getY());
				maxz = Math.max(maxz, aabb.getMax().getZ());
			}
		}
		
		JoglVectord3 vmin = new JoglVectord3(minx, miny, minz);
		JoglVectord3 vmax = new JoglVectord3(maxx, maxy, maxz);
	
		aabb = new JoglAABB(vmin, vmax);
		
		return aabb;
	}
	
	public JSODataVisMagnetLineBase AddCohortValue(double scale, JoglVectord3 color, String cohortName)
	{
			return null;
	}

	public void DrawTop(GraphicsPipeline pipe, boolean bMasked)
	{	
	}
	
	public void DrawBottom(GraphicsPipeline pipe, boolean bMasked)
	{	
	}

}