package org.processmining.processprofiler3d.compviz.jogl.shaders;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglShader;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCamera;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCameraLensOrthographic;

public class JoglShaderGridOrtho extends JoglShader
{

	public JoglShaderGridOrtho()
	{
		super("/org/processmining/processprofiler3d/compviz/jogl/resources", "gridShaderOrthoVS", "gridShaderOrthoFS");
	}

	public void applyCamera(GraphicsPipeline pipe, JoglCamera c)
	{
		SetUniform(pipe, "camPos", c.GetPosition());
		SetUniform(pipe, "camLook", c.GetLookDir());
		SetUniform(pipe, "camUp", c.GetUpDir());
		SetUniform(pipe, "camLeft", c.GetLeftDir());		
	}

	public void applyCameraLens(GraphicsPipeline pipe, JoglCameraLensOrthographic jclo)
	{
		SetUniform(pipe, "scaleW", (float)jclo.getScaleW());
		SetUniform(pipe, "scaleH", (float)jclo.getScaleW());
		SetUniform(pipe, "scaleD", (float)jclo.getScaleD());
	}
}
