package org.processmining.processprofiler3d.compviz.methods;

import java.util.List;
import java.util.Vector;

public class EdgeDataVisualisationMethodCollection
{
	private static Vector<EdgeDataVisualizationMethod> values = new Vector<EdgeDataVisualizationMethod>();
	
	public static EdgeDataVisualizationMethod EDVM_None;
	public static EdgeDataVisualizationMethod EDVM_MagneticLines;
	public static EdgeDataVisualizationMethod EDVM_MagneticLinesNew;
	public static EdgeDataVisualizationMethod EDVM_QualityLines;

	public EdgeDataVisualisationMethodCollection()
	{
	}
	
	public void clearValues()
	{
		values.clear();
	}
	
	public void addValue(EdgeDataVisualizationMethod evm)
	{
		values.add(evm);
	}
	
	public static EdgeDataVisualizationMethod get(String methodName)
	{
		for (EdgeDataVisualizationMethod edvm : values)
		{
			if (edvm.GetName().equals(methodName))
			{
				return edvm;
			}
		}
		return EDVM_None;
	}
	
	public static List<String> GetNames()
	{
		Vector<String> names = new Vector<String>();
		
		for (EdgeDataVisualizationMethod edvm : values)
		{
			names.add(edvm.GetName());
		}
		
		return names;
	}
    
    public static EdgeDataVisualizationMethod Next(EdgeDataVisualizationMethod c)
    {
    	int visId = 0;
    	if (c != null)
    	{
    		values.indexOf(c);
    	}
    	int nId = (visId + 1) % values.size();
    	
    	return values.get(nId);
    }

}
