package org.processmining.processprofiler3d.compviz.methods;

import java.util.List;
import java.util.Vector;

public class TransitionDataVisualisationMethodCollection
{
	private static Vector<TransitionDataVisualizationMethod> values = new Vector<TransitionDataVisualizationMethod>();
	
	public static TransitionDataVisualizationMethod TDVM_None;
	public static TransitionDataVisualizationMethod TDVM_BarChart1D;
	public static TransitionDataVisualizationMethod TDVM_BarChart2DHeight;
	public static TransitionDataVisualizationMethod TDVM_BarChart2DColor;
	public static TransitionDataVisualizationMethod TDVM_TriangleGlyphs;

	public TransitionDataVisualisationMethodCollection()
	{
	}
	
	public void clearValues()
	{
		values.clear();
	}
	
	public void addValue(TransitionDataVisualizationMethod evm)
	{
		values.add(evm);
	}
	
	public static TransitionDataVisualizationMethod get(String methodName)
	{
		for (TransitionDataVisualizationMethod edvm : values)
		{
			if (edvm.GetName().equals(methodName))
			{
				return edvm;
			}
		}
		return TDVM_None;
	}
	
	public static List<String> GetNames()
	{
		Vector<String> names = new Vector<String>();
		
		for (TransitionDataVisualizationMethod edvm : values)
		{
			names.add(edvm.GetName());
		}
		
		return names;
	}
    
    public static TransitionDataVisualizationMethod Next(TransitionDataVisualizationMethod c)
    {
    	int visId = 0;
    	if (c != null)
    	{
    		values.indexOf(c);
    	}
    	int nId = (visId + 1) % values.size();
    	
    	return values.get(nId);
    }

}
