package org.processmining.processprofiler3d.compviz.methods;

import java.util.Collections;
import java.util.Vector;

import org.processmining.processprofiler3d.compviz.DataMapNormalization;
import org.processmining.processprofiler3d.compviz.DataMapProviderTransition;
import org.processmining.processprofiler3d.compviz.TransitionDataMapDouble;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPSENTransitionVisualizationLayer;
import org.processmining.processprofiler3d.compviz.jogl.scene.VisualisationDataPipeline;
import org.processmining.processprofiler3d.compviz.jogl.scene.datavis.JSOPSENTransitionVisualizer_BarChart1D;
import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;

public class TransitionDataVisualizationMethod_BarChart1D extends TransitionDataVisualizationMethod
{
//	None (0, "None", false, false),
//	BarChart1D (1, "Bar Chart 1D", true, false),
//	BarChart2DHeight (2, "Bar Chart 2D Height", true, true),
//	BarChart2DColor (3, "Bar Chart 2D Color", true, true),
//	TriangleGlyphs (4, "Triangle Glyphs", true, true);
	private IPerformanceStatisticsEnrichedNet psen;
	private DataMapProviderTransition mapProvider;
    
    public TransitionDataVisualizationMethod_BarChart1D(IPerformanceStatisticsEnrichedNet psen, DataMapProviderTransition mp) 
    {
    	super("Bar Chart 1D", 1);
    	
    	this.psen = psen;
    	this.mapProvider = mp;
    }
	
    @Override
	public Vector<String> GetLabelNames()
	{
		Vector<String> lst = new Vector<String>();

		for (PSENLabel l : psen.getLabels())
		{
			lst.add(l.getLabelName());
		}
		
		Collections.sort(lst);
		
		return lst;
	}
	
    @Override
	public Vector<String> GetClassifierNames()
	{
		Vector<String> lst = new Vector<String>();

		for (String s : psen.getClassifierValues())
		{
			lst.add(s);
		}

		Collections.sort(lst);
		
		return lst;
	}
	
    @Override
	public DataMapNormalization getValidNormalizationMode(int dim, DataMapNormalization current)
	{
    	if (dim == 1)
    	{
    		return DataMapNormalization.LocalSum;
    	}
    	return super.getValidNormalizationMode(dim, current);
	}
	
    @Override
	public Vector<String> GetNormalizationNames(int dim)
	{
    	if (dim == 1)
    	{
			Vector<String> lst = new Vector<String>();
			lst.add(DataMapNormalization.LocalSum.getModeName());
			
			return lst;
    	}
    	return super.GetNormalizationNames(dim);
	}

    @Override
	public TransitionDataMapDouble GenerateDataMap(int dim, String label1Name, DataMapNormalization normMode, String focusClassifier)
	{
    	if (dim == 1)
    	{
    		return mapProvider.getMap(label1Name, DataMapNormalization.LocalSum);
    	}
    	return super.GenerateDataMap(dim, label1Name, normMode, focusClassifier);
	}

    @Override
	public void VisualizeData(JSOPSENTransitionVisualizationLayer ev, VisualisationDataPipeline tdp)
	{	
		tdp.classifiers = psen.getClassifierValues();
		
    	JSOPSENTransitionVisualizer_BarChart1D evml = new JSOPSENTransitionVisualizer_BarChart1D(ev);
    	evml.VisualizeTransitionData(tdp);
	}
}
