package org.processmining.processprofiler3d.compviz.vr;

import java.util.BitSet;

import org.processmining.processprofiler3d.compviz.vr.jna.OpenVRInterop;
import org.processmining.processprofiler3d.compviz.vr.jna.VRControllerState;
import org.processmining.visualisation3d.maths.JoglVectord2;

public class HzdVRControllerState
{
	private VRControllerState myVcs;
	private BitSet pressed;
	private BitSet touched;
	
	public HzdVRControllerState(VRControllerState vcs)
	{
		myVcs = vcs;
		pressed = vcs.toBitSet(vcs.ulButtonPressed);
		touched = vcs.toBitSet(vcs.ulButtonTouched);
		
//		System.out.println("Axis 0: " + vcs.rAxis[0].x + "/" + vcs.rAxis[0].y);
//		System.out.println("Axis 1: " + vcs.rAxis[1].x + "/" + vcs.rAxis[1].y);
//		System.out.println("Axis 2: " + vcs.rAxis[2].x + "/" + vcs.rAxis[2].y);
//		System.out.println("Axis 3: " + vcs.rAxis[3].x + "/" + vcs.rAxis[3].y);
//		System.out.println("Axis 4: " + vcs.rAxis[4].x + "/" + vcs.rAxis[4].y);
	}
	
	public JoglVectord2 getTouchpadPos()
	{
		return new JoglVectord2(myVcs.rAxis[0].x, myVcs.rAxis[0].y);
	}
	
	public JoglVectord2 getTriggerPos()
	{
		return new JoglVectord2(myVcs.rAxis[1].x, myVcs.rAxis[1].y);
	}

	public boolean IsAppMenuTouched()
	{
		return touched.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_ApplicationMenu);
	}

	public boolean IsGripTouched()
	{
		return touched.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_Grip);
	}

	public boolean IsTouchpadTouched()
	{
		return touched.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_SteamVR_Touchpad);
	}

	public boolean IsTriggerTouched()
	{
		return touched.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_SteamVR_Trigger);
	}

	public boolean IsAppMenuPressed()
	{
		return pressed.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_ApplicationMenu);
	}

	public boolean IsGripPressed()
	{
		return pressed.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_Grip);
	}

	public boolean IsTouchpadPressed()
	{
		return pressed.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_SteamVR_Touchpad);
	}

	public boolean IsTriggerPressed()
	{
		return pressed.get(OpenVRInterop.EVRButtonId.EVRButtonId_k_EButton_SteamVR_Trigger);
	}
}
