package org.processmining.processprofiler3d.compviz.vr;

import org.processmining.processprofiler3d.compviz.vr.jna.OpenVRInterop;
import org.processmining.processprofiler3d.compviz.vr.jna.VRControllerState;
import org.processmining.visualisation3d.maths.JoglMatrixd4x4;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class VRController
{
	public VR_TrackedDevice myDev;
	public VRTransform trans;
	
	public String meshName = null;

	public VRController(VR_TrackedDevice dev, VRTransform cT)
	{
		myDev = dev;
		trans = cT;
		
		meshName = dev.GetStringTrackedDeviceProperty(OpenVRInterop.ETrackedDeviceProperty.Prop_RenderModelName_String);
	}
	
	public VRControllerState GetControllerState()
	{
		return myDev.GetControllerState();
	}
	
	public JoglVectord3 getScale()
	{
		return trans.scale;
	}
	
	public JoglMatrixd4x4 getWSRotationMat()
	{
		JoglVectord3 pos = trans.hmdPosWS;
		JoglVectord3 lookAt = JoglVectord3.Add(trans.hmdPosWS, trans.hmdLookDirWS);
		JoglVectord3 up = trans.hmdUpDirWS;
		JoglMatrixd4x4 rotationMatrix = JoglMatrixd4x4.CreateRotationFromLookAt(pos, lookAt, up);
		//return rotationMatrix;
		return JoglMatrixd4x4.CreateTranspose(rotationMatrix);
	}

}
