package org.processmining.processprofiler3d.compviz.vr;

import java.util.prefs.Preferences;

public class VRSettings
{
	private String openVRLibPath = "C:/OpenVR/win64/openvr_api.dll";
	private double vrScale = 0.0025;
	
	public VRSettings()
	{
	}
	
	public double getVRScale()
	{
		return vrScale;
	}
	
	public String getLibPath()
	{
		return openVRLibPath;
	}
	
	public void setLibPath(String libPath)
	{
		openVRLibPath = libPath;
	}
	
	public void LoadPreferences()
	{
		Preferences prefs = Preferences.userNodeForPackage(this.getClass());
		
		openVRLibPath = prefs.get("VRLibPath", openVRLibPath);
		vrScale = prefs.getDouble("VRScale", vrScale);
	}
	
	public void SavePreferences()
	{
		Preferences prefs = Preferences.userNodeForPackage(this.getClass());
		
		prefs.put("VRLibPath", openVRLibPath);;
		prefs.putDouble("AnisoSamples", vrScale);
	}

}
