package org.processmining.processprofiler3d.compviz.vr.jna;

import java.util.List;
import java.util.Vector;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;
import com.sun.jna.win32.StdCallLibrary.StdCallCallback;

public class IVRCompositor extends Structure
{
	public ISetTrackingSpace SetTrackingSpace;
	public IGetTrackingSpace GetTrackingSpace;
	public IWaitGetPoses WaitGetPoses;
	public IGetLastPoses GetLastPoses;
	public IGetLastPoseForTrackedDeviceIndex GetLastPoseForTrackedDeviceIndex;
	public ISubmit Submit;
	public IClearLastSubmittedFrame ClearLastSubmittedFrame;
	public IPostPresentHandoff PostPresentHandoff;
	public IGetFrameTiming GetFrameTiming;
	public IGetFrameTimeRemaining GetFrameTimeRemaining;
	
	public IVRCompositor() 
	{
		super();
	}
	
	public IVRCompositor(Pointer p) 
	{
		super(p);
		read();
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("SetTrackingSpace");
		lst.add("GetTrackingSpace");
		lst.add("WaitGetPoses");
		lst.add("GetLastPoses");
		lst.add("GetLastPoseForTrackedDeviceIndex");
		lst.add("Submit");
		lst.add("ClearLastSubmittedFrame");
		lst.add("PostPresentHandoff");
		lst.add("GetFrameTiming");
		lst.add("GetFrameTimeRemaining");
		
		return lst;
		//return Arrays.asList(new String[] { "GetRecommendedRenderTargetSize" });
	}

    public interface ISetTrackingSpace extends StdCallCallback 
    {
        void invoke(int eOrigin);
    }

    public interface IGetTrackingSpace extends StdCallCallback 
    {
        int invoke();
    }

    public interface IWaitGetPoses extends StdCallCallback 
    {
        //int invoke(Pointer pRenderPoseArray, int unRenderPoseArrayCount, Pointer pGamePoseArray, int unGamePoseArrayCount);
        int invoke(VRTrackedDevicePose[] pRenderPoseArray, int unRenderPoseArrayCount, VRTrackedDevicePose[] pGamePoseArray, int unGamePoseArrayCount);
    }

    public interface IGetLastPoses extends StdCallCallback 
    {
        int invoke(Pointer pRenderPoseArray, int unRenderPoseArrayCount, Pointer pGamePoseArray, int unGamePoseArrayCount);
    }

    public interface IGetLastPoseForTrackedDeviceIndex extends StdCallCallback 
    {
        int invoke(int unDeviceIndex, Pointer pOutputPose, Pointer pOutputGamePose);
    }

    public interface ISubmit extends StdCallCallback 
    {
        int invoke(int eEye, VRTexture pTexture, VRTextureBounds pBounds, int nSubmitFlags);
    }

    public interface IClearLastSubmittedFrame extends StdCallCallback 
    {
        void invoke();
    }

    public interface IPostPresentHandoff extends StdCallCallback 
    {
        void invoke();
    }

    public interface IGetFrameTiming extends StdCallCallback 
    {
        boolean invoke(Pointer pTiming, int unFramesAgo);
    }

    public interface IGetFrameTimeRemaining extends StdCallCallback 
    {
        float invoke();
    }
    
//	+void (OPENVR_FNTABLE_CALLTYPE *SetTrackingSpace)(ETrackingUniverseOrigin eOrigin);
//	+ETrackingUniverseOrigin (OPENVR_FNTABLE_CALLTYPE *GetTrackingSpace)();
//	+EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *WaitGetPoses)(struct TrackedDevicePose_t * pRenderPoseArray, uint32_t unRenderPoseArrayCount, struct TrackedDevicePose_t * pGamePoseArray, uint32_t unGamePoseArrayCount);
//	+EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *GetLastPoses)(struct TrackedDevicePose_t * pRenderPoseArray, uint32_t unRenderPoseArrayCount, struct TrackedDevicePose_t * pGamePoseArray, uint32_t unGamePoseArrayCount);
//	+EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *GetLastPoseForTrackedDeviceIndex)(TrackedDeviceIndex_t unDeviceIndex, struct TrackedDevicePose_t * pOutputPose, struct TrackedDevicePose_t * pOutputGamePose);
//	+EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *Submit)(EVREye eEye, struct Texture_t * pTexture, struct VRTextureBounds_t * pBounds, EVRSubmitFlags nSubmitFlags);
//	+void (OPENVR_FNTABLE_CALLTYPE *ClearLastSubmittedFrame)();
//	+void (OPENVR_FNTABLE_CALLTYPE *PostPresentHandoff)();
//	+bool (OPENVR_FNTABLE_CALLTYPE *GetFrameTiming)(struct Compositor_FrameTiming * pTiming, uint32_t unFramesAgo);
//	+float (OPENVR_FNTABLE_CALLTYPE *GetFrameTimeRemaining)();
//	void (OPENVR_FNTABLE_CALLTYPE *GetCumulativeStats)(struct Compositor_CumulativeStats * pStats, uint32_t nStatsSizeInBytes);
//	void (OPENVR_FNTABLE_CALLTYPE *FadeToColor)(float fSeconds, float fRed, float fGreen, float fBlue, float fAlpha, bool bBackground);
//	void (OPENVR_FNTABLE_CALLTYPE *FadeGrid)(float fSeconds, bool bFadeIn);
//	EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *SetSkyboxOverride)(struct Texture_t * pTextures, uint32_t unTextureCount);
//	void (OPENVR_FNTABLE_CALLTYPE *ClearSkyboxOverride)();
//	void (OPENVR_FNTABLE_CALLTYPE *CompositorBringToFront)();
//	void (OPENVR_FNTABLE_CALLTYPE *CompositorGoToBack)();
//	void (OPENVR_FNTABLE_CALLTYPE *CompositorQuit)();
//	bool (OPENVR_FNTABLE_CALLTYPE *IsFullscreen)();
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetCurrentSceneFocusProcess)();
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetLastFrameRenderer)();
//	bool (OPENVR_FNTABLE_CALLTYPE *CanRenderScene)();
//	void (OPENVR_FNTABLE_CALLTYPE *ShowMirrorWindow)();
//	void (OPENVR_FNTABLE_CALLTYPE *HideMirrorWindow)();
//	bool (OPENVR_FNTABLE_CALLTYPE *IsMirrorWindowVisible)();
//	void (OPENVR_FNTABLE_CALLTYPE *CompositorDumpImages)();
//	bool (OPENVR_FNTABLE_CALLTYPE *ShouldAppRenderWithLowResources)();
//	void (OPENVR_FNTABLE_CALLTYPE *ForceInterleavedReprojectionOn)(bool bOverride);
//	void (OPENVR_FNTABLE_CALLTYPE *ForceReconnectProcess)();
//	void (OPENVR_FNTABLE_CALLTYPE *SuspendRendering)(bool bSuspend);
//	EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *RequestScreenshot)(EVRScreenshotType type, char * pchDestinationFileName, char * pchVRDestinationFileName);
//	EVRScreenshotType (OPENVR_FNTABLE_CALLTYPE *GetCurrentScreenshotType)();
//	EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *GetMirrorTextureD3D11)(EVREye eEye, void * pD3D11DeviceOrResource, void ** ppD3D11ShaderResourceView);
//	EVRCompositorError (OPENVR_FNTABLE_CALLTYPE *GetMirrorTextureGL)(EVREye eEye, glUInt_t * pglTextureId, glSharedTextureHandle_t * pglSharedTextureHandle);
//	bool (OPENVR_FNTABLE_CALLTYPE *ReleaseSharedGLTexture)(glUInt_t glTextureId, glSharedTextureHandle_t glSharedTextureHandle);
//	void (OPENVR_FNTABLE_CALLTYPE *LockGLSharedTextureForAccess)(glSharedTextureHandle_t glSharedTextureHandle);
//	void (OPENVR_FNTABLE_CALLTYPE *UnlockGLSharedTextureForAccess)(glSharedTextureHandle_t glSharedTextureHandle);


	public static class ByReference extends IVRCompositor implements Structure.ByReference 
	{
		
	};
	
	public static class ByValue extends IVRCompositor implements Structure.ByValue 
	{
		
	};

}
