package org.processmining.processprofiler3d.compviz.vr.jna;

import java.util.List;
import java.util.Vector;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.win32.StdCallLibrary.StdCallCallback;

public class IVRRenderModels extends Structure
{
	public ILoadRenderModel_Async LoadRenderModel_Async;
	public IFreeRenderModel FreeRenderModel;
	public ILoadTexture_Async LoadTexture_Async;
//	public IGetProjectionRaw GetProjectionRaw;
//	public IComputeDistortion ComputeDistortion;
//	public IGetEyeToHeadTransform GetEyeToHeadTransform;
//	public IGetTimeSinceLastVsync GetTimeSinceLastVsync;
//	public IGetD3D9AdapterIndex GetD3D9AdapterIndex;
//	public IGetDXGIOutputInfo GetDXGIOutputInfo;
//	public IIsDisplayOnDesktop IsDisplayOnDesktop;
//	public ISetDisplayVisibility SetDisplayVisibility;
//	public IGetDeviceToAbsoluteTrackingPose GetDeviceToAbsoluteTrackingPose;
//	public IResetSeatedZeroPose ResetSeatedZeroPose;
//	public IGetSeatedZeroPoseToStandingAbsoluteTrackingPose GetSeatedZeroPoseToStandingAbsoluteTrackingPose;
//	public IGetRawZeroPoseToStandingAbsoluteTrackingPose GetRawZeroPoseToStandingAbsoluteTrackingPose;
//	public IGetSortedTrackedDeviceIndicesOfClass GetSortedTrackedDeviceIndicesOfClass;
//	public IGetTrackedDeviceActivityLevel GetTrackedDeviceActivityLevel;
//	public IApplyTransform ApplyTransform;
//	public IGetTrackedDeviceIndexForControllerRole GetTrackedDeviceIndexForControllerRole;
//	public IGetControllerRoleForTrackedDeviceIndex GetControllerRoleForTrackedDeviceIndex;
//	public IGetTrackedDeviceClass GetTrackedDeviceClass;
//	public IIsTrackedDeviceConnected IsTrackedDeviceConnected;
//    public IGetBoolTrackedDeviceProperty GetBoolTrackedDeviceProperty;
//    public IGetFloatTrackedDeviceProperty GetFloatTrackedDeviceProperty;
//    public IGetInt32TrackedDeviceProperty GetInt32TrackedDeviceProperty;
//    public IGetUint64TrackedDeviceProperty GetUint64TrackedDeviceProperty;
//    public IGetMatrix34TrackedDeviceProperty GetMatrix34TrackedDeviceProperty;
//    public IGetStringTrackedDeviceProperty GetStringTrackedDeviceProperty;
//    public IGetPropErrorNameFromEnum GetPropErrorNameFromEnum;

	public IVRRenderModels() 
	{
		super();
	}
	
	public IVRRenderModels(Pointer p) 
	{
		super(p);
		read();
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("LoadRenderModel_Async");
		lst.add("FreeRenderModel");
		lst.add("LoadTexture_Async");
//		lst.add("ComputeDistortion");
//		lst.add("GetEyeToHeadTransform");
//		lst.add("GetTimeSinceLastVsync");
//		lst.add("GetD3D9AdapterIndex");
//		lst.add("GetDXGIOutputInfo");
//		lst.add("IsDisplayOnDesktop");
//		lst.add("SetDisplayVisibility");
//		lst.add("GetDeviceToAbsoluteTrackingPose");
//		lst.add("ResetSeatedZeroPose");
//		lst.add("GetSeatedZeroPoseToStandingAbsoluteTrackingPose");
//		lst.add("GetRawZeroPoseToStandingAbsoluteTrackingPose");
//		lst.add("GetSortedTrackedDeviceIndicesOfClass");
//		lst.add("GetTrackedDeviceActivityLevel");
//		lst.add("ApplyTransform");
//		lst.add("GetTrackedDeviceIndexForControllerRole");
//		lst.add("GetControllerRoleForTrackedDeviceIndex");
//		lst.add("GetTrackedDeviceClass");
//		lst.add("IsTrackedDeviceConnected");
//		lst.add("GetBoolTrackedDeviceProperty");
//		lst.add("GetFloatTrackedDeviceProperty");
//		lst.add("GetInt32TrackedDeviceProperty");
//		lst.add("GetUint64TrackedDeviceProperty");
//		lst.add("GetMatrix34TrackedDeviceProperty");
//		lst.add("GetStringTrackedDeviceProperty");
//		lst.add("GetPropErrorNameFromEnum");
		
		return lst;
	}

    public interface ILoadRenderModel_Async extends StdCallCallback 
    {
        int invoke(String pchRenderModelName, PointerByReference ppRenderModel);
    }

    public interface IFreeRenderModel extends StdCallCallback 
    {
        void invoke(Pointer ppRenderModel);
    }

    public interface ILoadTexture_Async extends StdCallCallback 
    {
        int invoke(int texture_id, PointerByReference ppRenderModel);
    }
//
//    public interface IGetProjectionRaw extends StdCallCallback 
//    {
//        void invoke(int eye, FloatByReference pfLeft, FloatByReference pfRight, FloatByReference pfTop, FloatByReference pfBottom);
//    }
//
//    public interface IComputeDistortion extends StdCallCallback 
//    {
//        Pointer invoke(int eye, float fU, float fV);
//    }
//
//    public interface IGetEyeToHeadTransform extends Callback 
//    {
//    	VRHmdMatrix34.ByValue invoke(int eye);
//    }
//
//    public interface IGetTimeSinceLastVsync extends StdCallCallback 
//    {
//        boolean invoke(FloatByReference pfSecondsSinceLastVsync, LongByReference pulFrameCounter);
//    }
//
//    public interface IGetD3D9AdapterIndex extends StdCallCallback 
//    {
//        int invoke();
//    }
//
//    public interface IGetDXGIOutputInfo extends StdCallCallback 
//    {
//        void invoke(IntByReference pnAdapterIndex);
//    }
//
//    public interface IIsDisplayOnDesktop extends StdCallCallback 
//    {
//        boolean invoke();
//    }
//
//    public interface ISetDisplayVisibility extends StdCallCallback 
//    {
//        boolean invoke(boolean bIsVisibleOnDesktop);
//    }
//
//    public interface IGetDeviceToAbsoluteTrackingPose extends StdCallCallback 
//    {
//        void invoke(int eOrigin, float fPredictedSecondsToPhotonsFromNow, Pointer pTrackedDevicePoseArray, int unTrackedDevicePoseArrayCount);
//    }
//
//    public interface IResetSeatedZeroPose extends StdCallCallback 
//    {
//        void invoke();
//    }
//
//    public interface IGetSeatedZeroPoseToStandingAbsoluteTrackingPose extends StdCallCallback 
//    {
//        Pointer invoke();
//    }
//
//    public interface IGetRawZeroPoseToStandingAbsoluteTrackingPose extends StdCallCallback 
//    {
//        Pointer invoke();
//    }
//
//    public interface IGetSortedTrackedDeviceIndicesOfClass extends StdCallCallback 
//    {
//        int invoke(int eTrackedDeviceClass, Pointer punTrackedDeviceIndexArray, int unTrackedDeviceIndexArrayCount, int unRelativeToTrackedDeviceIndex);
//    }
//
//    public interface IGetTrackedDeviceActivityLevel extends StdCallCallback 
//    {
//        int invoke(int unDeviceId);
//    }
//
//    public interface IApplyTransform extends StdCallCallback 
//    {
//        void invoke(Pointer pOutputPose, Pointer pTrackedDevicePose, Pointer pTransform);
//    }
//
//    public interface IGetTrackedDeviceIndexForControllerRole extends StdCallCallback 
//    {
//        int invoke(int unDeviceType);
//    }
//
//    public interface IGetControllerRoleForTrackedDeviceIndex extends StdCallCallback 
//    {
//        int invoke(int unDeviceIndex);
//    }
//
//    public interface IGetTrackedDeviceClass extends StdCallCallback 
//    {
//        int invoke(int unDeviceIndex);
//    }
//
//    public interface IIsTrackedDeviceConnected extends StdCallCallback 
//    {
//        boolean invoke(int unDeviceIndex);
//    }
//
//    public interface IGetBoolTrackedDeviceProperty extends StdCallCallback 
//    {
//        boolean invoke(int unDeviceIndex, int prop, IntByReference pError);
//    }
//
//    public interface IGetFloatTrackedDeviceProperty extends StdCallCallback 
//    {
//        float invoke(int unDeviceIndex, int prop, IntByReference pError);
//    }
//
//    public interface IGetInt32TrackedDeviceProperty extends StdCallCallback 
//    {
//        int invoke(int unDeviceIndex, int prop, IntByReference pError);
//    }
//
//    public interface IGetUint64TrackedDeviceProperty extends StdCallCallback 
//    {
//        long invoke(int unDeviceIndex, int prop, IntByReference pError);
//    }
//
//    public interface IGetMatrix34TrackedDeviceProperty extends StdCallCallback 
//    {
//        Pointer invoke(int unDeviceIndex, int prop, IntByReference pError);
//    }
//
//    public interface IGetStringTrackedDeviceProperty extends StdCallCallback 
//    {
//        //int invoke(int unDeviceIndex, int prop, String pchValue, int unBufferSize, IntByReference pError);
//        int invoke(int unDeviceIndex, int prop, PointerByReference pchValue, int unBufferSize, IntByReference pError);
//    }
//
//    public interface IGetPropErrorNameFromEnum extends StdCallCallback 
//    {
//        String invoke(int pError);
//    }

//	EVRRenderModelError (OPENVR_FNTABLE_CALLTYPE *LoadRenderModel_Async)(char * pchRenderModelName, struct RenderModel_t ** ppRenderModel);
//	void (OPENVR_FNTABLE_CALLTYPE *FreeRenderModel)(struct RenderModel_t * pRenderModel);
//	EVRRenderModelError (OPENVR_FNTABLE_CALLTYPE *LoadTexture_Async)(TextureID_t textureId, struct RenderModel_TextureMap_t ** ppTexture);
//	void (OPENVR_FNTABLE_CALLTYPE *FreeTexture)(struct RenderModel_TextureMap_t * pTexture);
//	EVRRenderModelError (OPENVR_FNTABLE_CALLTYPE *LoadTextureD3D11_Async)(TextureID_t textureId, void * pD3D11Device, void ** ppD3D11Texture2D);
//	EVRRenderModelError (OPENVR_FNTABLE_CALLTYPE *LoadIntoTextureD3D11_Async)(TextureID_t textureId, void * pDstTexture);
//	void (OPENVR_FNTABLE_CALLTYPE *FreeTextureD3D11)(void * pD3D11Texture2D);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetRenderModelName)(uint32_t unRenderModelIndex, char * pchRenderModelName, uint32_t unRenderModelNameLen);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetRenderModelCount)();
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetComponentCount)(char * pchRenderModelName);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetComponentName)(char * pchRenderModelName, uint32_t unComponentIndex, char * pchComponentName, uint32_t unComponentNameLen);
//	uint64_t (OPENVR_FNTABLE_CALLTYPE *GetComponentButtonMask)(char * pchRenderModelName, char * pchComponentName);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetComponentRenderModelName)(char * pchRenderModelName, char * pchComponentName, char * pchComponentRenderModelName, uint32_t unComponentRenderModelNameLen);
//	bool (OPENVR_FNTABLE_CALLTYPE *GetComponentState)(char * pchRenderModelName, char * pchComponentName, VRControllerState_t * pControllerState, struct RenderModel_ControllerMode_State_t * pState, struct RenderModel_ComponentState_t * pComponentState);
//	bool (OPENVR_FNTABLE_CALLTYPE *RenderModelHasComponent)(char * pchRenderModelName, char * pchComponentName);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetRenderModelThumbnailURL)(char * pchRenderModelName, char * pchThumbnailURL, uint32_t unThumbnailURLLen, EVRRenderModelError * peError);
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *GetRenderModelOriginalPath)(char * pchRenderModelName, char * pchOriginalPath, uint32_t unOriginalPathLen, EVRRenderModelError * peError);

	public static class ByReference extends IVRRenderModels implements Structure.ByReference 
	{
		
	};
	
	public static class ByValue extends IVRRenderModels implements Structure.ByValue 
	{
		
	};

}
