package org.processmining.processprofiler3d.compviz.vr.jna;

import java.util.List;
import java.util.Vector;

import com.sun.jna.Callback;
import com.sun.jna.Pointer;
import com.sun.jna.Structure;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.LongByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.win32.StdCallLibrary.StdCallCallback;

public class IVRSystem extends Structure
{
	public IGetRecommendedRenderTargetSize GetRecommendedRenderTargetSize;
	public IGetProjectionMatrix GetProjectionMatrix;
	public IGetProjectionRaw GetProjectionRaw;
	public IComputeDistortion ComputeDistortion;
	public IGetEyeToHeadTransform GetEyeToHeadTransform;
	public IGetTimeSinceLastVsync GetTimeSinceLastVsync;
	public IGetD3D9AdapterIndex GetD3D9AdapterIndex;
	public IGetDXGIOutputInfo GetDXGIOutputInfo;
	public IIsDisplayOnDesktop IsDisplayOnDesktop;
	public ISetDisplayVisibility SetDisplayVisibility;
	public IGetDeviceToAbsoluteTrackingPose GetDeviceToAbsoluteTrackingPose;
	public IResetSeatedZeroPose ResetSeatedZeroPose;
	public IGetSeatedZeroPoseToStandingAbsoluteTrackingPose GetSeatedZeroPoseToStandingAbsoluteTrackingPose;
	public IGetRawZeroPoseToStandingAbsoluteTrackingPose GetRawZeroPoseToStandingAbsoluteTrackingPose;
	public IGetSortedTrackedDeviceIndicesOfClass GetSortedTrackedDeviceIndicesOfClass;
	public IGetTrackedDeviceActivityLevel GetTrackedDeviceActivityLevel;
	public IApplyTransform ApplyTransform;
	public IGetTrackedDeviceIndexForControllerRole GetTrackedDeviceIndexForControllerRole;
	public IGetControllerRoleForTrackedDeviceIndex GetControllerRoleForTrackedDeviceIndex;
	public IGetTrackedDeviceClass GetTrackedDeviceClass;
	public IIsTrackedDeviceConnected IsTrackedDeviceConnected;
    public IGetBoolTrackedDeviceProperty GetBoolTrackedDeviceProperty;
    public IGetFloatTrackedDeviceProperty GetFloatTrackedDeviceProperty;
    public IGetInt32TrackedDeviceProperty GetInt32TrackedDeviceProperty;
    public IGetUint64TrackedDeviceProperty GetUint64TrackedDeviceProperty;
    public IGetMatrix34TrackedDeviceProperty GetMatrix34TrackedDeviceProperty;
    public IGetStringTrackedDeviceProperty GetStringTrackedDeviceProperty;
    public IGetPropErrorNameFromEnum GetPropErrorNameFromEnum;
    public IPollNextEvent PollNextEvent;
    public IPollNextEventWithPose PollNextEventWithPose;
    public IGetEventTypeNameFromEnum GetEventTypeNameFromEnum;
    public IGetHiddenAreaMesh GetHiddenAreaMesh;
    public IGetControllerState GetControllerState;
    public IGetControllerStateWithPose GetControllerStateWithPose;
    
	public IVRSystem() 
	{
		super();
	}
	
	public IVRSystem(Pointer p) 
	{
		super(p);
		read();
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("GetRecommendedRenderTargetSize");
		lst.add("GetProjectionMatrix");
		lst.add("GetProjectionRaw");
		lst.add("ComputeDistortion");
		lst.add("GetEyeToHeadTransform");
		lst.add("GetTimeSinceLastVsync");
		lst.add("GetD3D9AdapterIndex");
		lst.add("GetDXGIOutputInfo");
		lst.add("IsDisplayOnDesktop");
		lst.add("SetDisplayVisibility");
		lst.add("GetDeviceToAbsoluteTrackingPose");
		lst.add("ResetSeatedZeroPose");
		lst.add("GetSeatedZeroPoseToStandingAbsoluteTrackingPose");
		lst.add("GetRawZeroPoseToStandingAbsoluteTrackingPose");
		lst.add("GetSortedTrackedDeviceIndicesOfClass");
		lst.add("GetTrackedDeviceActivityLevel");
		lst.add("ApplyTransform");
		lst.add("GetTrackedDeviceIndexForControllerRole");
		lst.add("GetControllerRoleForTrackedDeviceIndex");
		lst.add("GetTrackedDeviceClass");
		lst.add("IsTrackedDeviceConnected");
		lst.add("GetBoolTrackedDeviceProperty");
		lst.add("GetFloatTrackedDeviceProperty");
		lst.add("GetInt32TrackedDeviceProperty");
		lst.add("GetUint64TrackedDeviceProperty");
		lst.add("GetMatrix34TrackedDeviceProperty");
		lst.add("GetStringTrackedDeviceProperty");
		lst.add("GetPropErrorNameFromEnum");
		lst.add("PollNextEvent");
		lst.add("PollNextEventWithPose");
		lst.add("GetEventTypeNameFromEnum");
		lst.add("GetHiddenAreaMesh");
		lst.add("GetControllerState");
		lst.add("GetControllerStateWithPose");
		
		return lst;
		//return Arrays.asList(new String[] { "GetRecommendedRenderTargetSize" });
	}

    public interface IGetRecommendedRenderTargetSize extends StdCallCallback 
    {
        void invoke(IntByReference pnWidth, IntByReference pnHeight);
    }

    public interface IGetProjectionMatrix extends Callback 
    {
        //Pointer invoke(int eye, float fNearZ, float fFarZ, int eProjType);
        VRHmdMatrix44.ByValue invoke(int eye, float fNearZ, float fFarZ, int eProjType);
    }

    public interface IGetProjectionRaw extends StdCallCallback 
    {
        void invoke(int eye, FloatByReference pfLeft, FloatByReference pfRight, FloatByReference pfTop, FloatByReference pfBottom);
    }

    public interface IComputeDistortion extends StdCallCallback 
    {
        Pointer invoke(int eye, float fU, float fV);
    }

    public interface IGetEyeToHeadTransform extends Callback 
    {
    	VRHmdMatrix34.ByValue invoke(int eye);
    }

    public interface IGetTimeSinceLastVsync extends StdCallCallback 
    {
        boolean invoke(FloatByReference pfSecondsSinceLastVsync, LongByReference pulFrameCounter);
    }

    public interface IGetD3D9AdapterIndex extends StdCallCallback 
    {
        int invoke();
    }

    public interface IGetDXGIOutputInfo extends StdCallCallback 
    {
        void invoke(IntByReference pnAdapterIndex);
    }

    public interface IIsDisplayOnDesktop extends StdCallCallback 
    {
        boolean invoke();
    }

    public interface ISetDisplayVisibility extends StdCallCallback 
    {
        boolean invoke(boolean bIsVisibleOnDesktop);
    }

    public interface IGetDeviceToAbsoluteTrackingPose extends StdCallCallback 
    {
        void invoke(int eOrigin, float fPredictedSecondsToPhotonsFromNow, Pointer pTrackedDevicePoseArray, int unTrackedDevicePoseArrayCount);
    }

    public interface IResetSeatedZeroPose extends StdCallCallback 
    {
        void invoke();
    }

    public interface IGetSeatedZeroPoseToStandingAbsoluteTrackingPose extends StdCallCallback 
    {
        Pointer invoke();
    }

    public interface IGetRawZeroPoseToStandingAbsoluteTrackingPose extends StdCallCallback 
    {
        Pointer invoke();
    }

    public interface IGetSortedTrackedDeviceIndicesOfClass extends StdCallCallback 
    {
        int invoke(int eTrackedDeviceClass, Pointer punTrackedDeviceIndexArray, int unTrackedDeviceIndexArrayCount, int unRelativeToTrackedDeviceIndex);
    }

    public interface IGetTrackedDeviceActivityLevel extends StdCallCallback 
    {
        int invoke(int unDeviceId);
    }

    public interface IApplyTransform extends StdCallCallback 
    {
        void invoke(Pointer pOutputPose, Pointer pTrackedDevicePose, Pointer pTransform);
    }

    public interface IGetTrackedDeviceIndexForControllerRole extends StdCallCallback 
    {
        int invoke(int unDeviceType);
    }

    public interface IGetControllerRoleForTrackedDeviceIndex extends StdCallCallback 
    {
        int invoke(int unDeviceIndex);
    }

    public interface IGetTrackedDeviceClass extends StdCallCallback 
    {
        int invoke(int unDeviceIndex);
    }

    public interface IIsTrackedDeviceConnected extends StdCallCallback 
    {
        boolean invoke(int unDeviceIndex);
    }

    public interface IGetBoolTrackedDeviceProperty extends StdCallCallback 
    {
        boolean invoke(int unDeviceIndex, int prop, IntByReference pError);
    }

    public interface IGetFloatTrackedDeviceProperty extends StdCallCallback 
    {
        float invoke(int unDeviceIndex, int prop, IntByReference pError);
    }

    public interface IGetInt32TrackedDeviceProperty extends StdCallCallback 
    {
        int invoke(int unDeviceIndex, int prop, IntByReference pError);
    }

    public interface IGetUint64TrackedDeviceProperty extends StdCallCallback 
    {
        long invoke(int unDeviceIndex, int prop, IntByReference pError);
    }

    public interface IGetMatrix34TrackedDeviceProperty extends StdCallCallback 
    {
        Pointer invoke(int unDeviceIndex, int prop, IntByReference pError);
    }

    public interface IGetStringTrackedDeviceProperty extends StdCallCallback 
    {
        //int invoke(int unDeviceIndex, int prop, String pchValue, int unBufferSize, IntByReference pError);
        int invoke(int unDeviceIndex, int prop, PointerByReference pchValue, int unBufferSize, IntByReference pError);
    }

    public interface IGetPropErrorNameFromEnum extends StdCallCallback 
    {
        String invoke(int pError);
    }

    public interface IPollNextEvent extends StdCallCallback 
    {
    	boolean invoke(Pointer ptr_VrEvent, int uncbVREvent);
    }

    public interface IPollNextEventWithPose extends StdCallCallback 
    {
    	boolean invoke(int eOrigin, Pointer ptr_VrEvent, int uncbVREvent, Pointer pTrackedDevicePose);
    }

    public interface IGetEventTypeNameFromEnum extends StdCallCallback 
    {
        String invoke(int eType);
    }

    public interface IGetHiddenAreaMesh extends StdCallCallback 
    {
        Pointer invoke(int evrEye);
    }

    public interface IGetControllerState extends StdCallCallback 
    {
    	boolean invoke(int unDeviceIndex, Pointer ptrControllerState);
    }

    public interface IGetControllerStateWithPose extends StdCallCallback 
    {
    	boolean invoke(int eOrigin, int unDeviceIndex, Pointer ptrControllerState, Pointer pTrackedDevicePose);
    }
    
//	+void (OPENVR_FNTABLE_CALLTYPE *GetRecommendedRenderTargetSize)(uint32_t * pnWidth, uint32_t * pnHeight);
//	+struct HmdMatrix44_t (OPENVR_FNTABLE_CALLTYPE *GetProjectionMatrix)(EVREye eEye, float fNearZ, float fFarZ, EGraphicsAPIConvention eProjType);
//	+void (OPENVR_FNTABLE_CALLTYPE *GetProjectionRaw)(EVREye eEye, float * pfLeft, float * pfRight, float * pfTop, float * pfBottom);
//	+struct DistortionCoordinates_t (OPENVR_FNTABLE_CALLTYPE *ComputeDistortion)(EVREye eEye, float fU, float fV);
//	+struct HmdMatrix34_t (OPENVR_FNTABLE_CALLTYPE *GetEyeToHeadTransform)(EVREye eEye);
//	+bool (OPENVR_FNTABLE_CALLTYPE *GetTimeSinceLastVsync)(float * pfSecondsSinceLastVsync, uint64_t * pulFrameCounter);
//	+int32_t (OPENVR_FNTABLE_CALLTYPE *GetD3D9AdapterIndex)();
//	+void (OPENVR_FNTABLE_CALLTYPE *GetDXGIOutputInfo)(int32_t * pnAdapterIndex);
//	+bool (OPENVR_FNTABLE_CALLTYPE *IsDisplayOnDesktop)();
//	+bool (OPENVR_FNTABLE_CALLTYPE *SetDisplayVisibility)(bool bIsVisibleOnDesktop);
//	+void (OPENVR_FNTABLE_CALLTYPE *GetDeviceToAbsoluteTrackingPose)(ETrackingUniverseOrigin eOrigin, float fPredictedSecondsToPhotonsFromNow, struct TrackedDevicePose_t * pTrackedDevicePoseArray, uint32_t unTrackedDevicePoseArrayCount);
//	+void (OPENVR_FNTABLE_CALLTYPE *ResetSeatedZeroPose)();
//	+struct HmdMatrix34_t (OPENVR_FNTABLE_CALLTYPE *GetSeatedZeroPoseToStandingAbsoluteTrackingPose)();
//	+struct HmdMatrix34_t (OPENVR_FNTABLE_CALLTYPE *GetRawZeroPoseToStandingAbsoluteTrackingPose)();
//	+uint32_t (OPENVR_FNTABLE_CALLTYPE *GetSortedTrackedDeviceIndicesOfClass)(ETrackedDeviceClass eTrackedDeviceClass, TrackedDeviceIndex_t * punTrackedDeviceIndexArray, uint32_t unTrackedDeviceIndexArrayCount, TrackedDeviceIndex_t unRelativeToTrackedDeviceIndex);
//	+EDeviceActivityLevel (OPENVR_FNTABLE_CALLTYPE *GetTrackedDeviceActivityLevel)(TrackedDeviceIndex_t unDeviceId);
//	+void (OPENVR_FNTABLE_CALLTYPE *ApplyTransform)(struct TrackedDevicePose_t * pOutputPose, struct TrackedDevicePose_t * pTrackedDevicePose, struct HmdMatrix34_t * pTransform);
//	+TrackedDeviceIndex_t (OPENVR_FNTABLE_CALLTYPE *GetTrackedDeviceIndexForControllerRole)(ETrackedControllerRole unDeviceType);
//	+ETrackedControllerRole (OPENVR_FNTABLE_CALLTYPE *GetControllerRoleForTrackedDeviceIndex)(TrackedDeviceIndex_t unDeviceIndex);
//	+ETrackedDeviceClass (OPENVR_FNTABLE_CALLTYPE *GetTrackedDeviceClass)(TrackedDeviceIndex_t unDeviceIndex);
//	+bool (OPENVR_FNTABLE_CALLTYPE *IsTrackedDeviceConnected)(TrackedDeviceIndex_t unDeviceIndex);
//	+bool (OPENVR_FNTABLE_CALLTYPE *GetBoolTrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, ETrackedPropertyError * pError);
//	+float (OPENVR_FNTABLE_CALLTYPE *GetFloatTrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, ETrackedPropertyError * pError);
//	+int32_t (OPENVR_FNTABLE_CALLTYPE *GetInt32TrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, ETrackedPropertyError * pError);
//	+uint64_t (OPENVR_FNTABLE_CALLTYPE *GetUint64TrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, ETrackedPropertyError * pError);
//	+struct HmdMatrix34_t (OPENVR_FNTABLE_CALLTYPE *GetMatrix34TrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, ETrackedPropertyError * pError);
//	+uint32_t (OPENVR_FNTABLE_CALLTYPE *GetStringTrackedDeviceProperty)(TrackedDeviceIndex_t unDeviceIndex, ETrackedDeviceProperty prop, char * pchValue, uint32_t unBufferSize, ETrackedPropertyError * pError);
//	+char * (OPENVR_FNTABLE_CALLTYPE *GetPropErrorNameFromEnum)(ETrackedPropertyError error);
//	+bool (OPENVR_FNTABLE_CALLTYPE *PollNextEvent)(struct VREvent_t * pEvent, uint32_t uncbVREvent);
//	+bool (OPENVR_FNTABLE_CALLTYPE *PollNextEventWithPose)(ETrackingUniverseOrigin eOrigin, struct VREvent_t * pEvent, uint32_t uncbVREvent, TrackedDevicePose_t * pTrackedDevicePose);
//	+char * (OPENVR_FNTABLE_CALLTYPE *GetEventTypeNameFromEnum)(EVREventType eType);
//	+struct HiddenAreaMesh_t (OPENVR_FNTABLE_CALLTYPE *GetHiddenAreaMesh)(EVREye eEye);
//	bool (OPENVR_FNTABLE_CALLTYPE *GetControllerState)(TrackedDeviceIndex_t unControllerDeviceIndex, VRControllerState_t * pControllerState);
//	bool (OPENVR_FNTABLE_CALLTYPE *GetControllerStateWithPose)(ETrackingUniverseOrigin eOrigin, TrackedDeviceIndex_t unControllerDeviceIndex, VRControllerState_t * pControllerState, struct TrackedDevicePose_t * pTrackedDevicePose);
//	void (OPENVR_FNTABLE_CALLTYPE *TriggerHapticPulse)(TrackedDeviceIndex_t unControllerDeviceIndex, uint32_t unAxisId, unsigned short usDurationMicroSec);
//	char * (OPENVR_FNTABLE_CALLTYPE *GetButtonIdNameFromEnum)(EVRButtonId eButtonId);
//	char * (OPENVR_FNTABLE_CALLTYPE *GetControllerAxisTypeNameFromEnum)(EVRControllerAxisType eAxisType);
//	bool (OPENVR_FNTABLE_CALLTYPE *CaptureInputFocus)();
//	void (OPENVR_FNTABLE_CALLTYPE *ReleaseInputFocus)();
//	bool (OPENVR_FNTABLE_CALLTYPE *IsInputFocusCapturedByAnotherProcess)();
//	uint32_t (OPENVR_FNTABLE_CALLTYPE *DriverDebugRequest)(TrackedDeviceIndex_t unDeviceIndex, char * pchRequest, char * pchResponseBuffer, uint32_t unResponseBufferSize);
//	EVRFirmwareError (OPENVR_FNTABLE_CALLTYPE *PerformFirmwareUpdate)(TrackedDeviceIndex_t unDeviceIndex);
//	void (OPENVR_FNTABLE_CALLTYPE *AcknowledgeQuit_Exiting)();
//	void (OPENVR_FNTABLE_CALLTYPE *AcknowledgeQuit_UserPrompt)();

	public static class ByReference extends IVRSystem implements Structure.ByReference 
	{
		
	};
	
	public static class ByValue extends IVRSystem implements Structure.ByValue 
	{
		
	};

}
