package org.processmining.processprofiler3d.compviz.vr.jna;

import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.win32.StdCallLibrary;

public interface OpenVRInterop extends StdCallLibrary
{
	  //public static final String JNA_LIBRARY_NAME = "C:/OpenVR/win64/openvr_api.dll";
	  //public static final String JNA_LIBRARY_NAME = "openvr_api.dll";
	  //public static final OpenVRInterop INSTANCE = (OpenVRInterop)Native.loadLibrary(OpenVRInterop.JNA_LIBRARY_NAME, OpenVRInterop.class);
	  
	  public static interface EDeviceActivityLevel
	  {
		  public static final int Unknown = -1;
		  public static final int Idle = 0;
		  public static final int UserInteraction = 1;
		  public static final int UserInteraction_Timeout = 2;
		  public static final int Standby = 3;
	  }
	  
	  public static interface EVRButtonId
	  {
		  public static final int EVRButtonId_k_EButton_System = 0;
		  public static final int EVRButtonId_k_EButton_ApplicationMenu = 1;
		  public static final int EVRButtonId_k_EButton_Grip = 2;
		  public static final int EVRButtonId_k_EButton_DPad_Left = 3;
		  public static final int EVRButtonId_k_EButton_DPad_Up = 4;
		  public static final int EVRButtonId_k_EButton_DPad_Right = 5;
		  public static final int EVRButtonId_k_EButton_DPad_Down = 6;
		  public static final int EVRButtonId_k_EButton_A = 7;
		  public static final int EVRButtonId_k_EButton_Axis0 = 32;
		  public static final int EVRButtonId_k_EButton_Axis1 = 33;
		  public static final int EVRButtonId_k_EButton_Axis2 = 34;
		  public static final int EVRButtonId_k_EButton_Axis3 = 35;
		  public static final int EVRButtonId_k_EButton_Axis4 = 36;
		  public static final int EVRButtonId_k_EButton_SteamVR_Touchpad = 32;
		  public static final int EVRButtonId_k_EButton_SteamVR_Trigger = 33;
		  public static final int EVRButtonId_k_EButton_Dashboard_Back = 2;
		  public static final int EVRButtonId_k_EButton_Max = 64;
	  }


	  public static interface EVREye
	  {
		  public static final int Eye_Left = 0;
		  public static final int Eye_Right = 1;
	  }

	  public static interface EGraphicsAPIConvention
	  {
		  public static final int API_DirectX = 0;
		  public static final int API_OpenGL = 1;
	  }
	  
	  public static interface EColorSpace
	  {
		  public static final int ColorSpace_Auto = 0;
		  public static final int ColorSpace_Gamma = 1;
		  public static final int ColorSpace_Linear = 2;
	  }
	  
	  public static interface EVRSubmitFlags
	  {
		  public static final int Submit_Default = 0;
		  public static final int Submit_LensDistortionAlreadyApplied = 1;
		  public static final int Submit_GlRenderBuffer = 2;
		  public static final int Submit_Screenshot = 4;
	  }

	  
	  public static interface ETrackedDeviceClass
	  {
		  public static final int TrackedDeviceClass_Invalid = 0;
		  public static final int TrackedDeviceClass_HMD = 1;
		  public static final int TrackedDeviceClass_Controller = 2;
		  public static final int TrackedDeviceClass_TrackingReference = 4;
		  public static final int TrackedDeviceClass_Other = 1000;
	  }
	  
	  public static interface ETrackedDeviceProperty
	  {
		  public static final int Prop_TrackingSystemName_String = 1000;
		  public static final int Prop_ModelNumber_String = 1001;
		  public static final int Prop_SerialNumber_String = 1002;
		  public static final int Prop_RenderModelName_String = 1003;
		  public static final int Prop_WillDriftInYaw_Bool = 1004;
		  public static final int Prop_ManufacturerName_String = 1005;
		  public static final int Prop_TrackingFirmwareVersion_String = 1006;
		  public static final int Prop_HardwareRevision_String = 1007;
		  public static final int Prop_AllWirelessDongleDescriptions_String = 1008;
		  public static final int Prop_ConnectedWirelessDongle_String = 1009;
		  public static final int Prop_DeviceIsWireless_Bool = 1010;
		  public static final int Prop_DeviceIsCharging_Bool = 1011;
		  public static final int Prop_DeviceBatteryPercentage_Float = 1012;
		  public static final int Prop_StatusDisplayTransform_Matrix34 = 1013;
		  public static final int Prop_Firmware_UpdateAvailable_Bool = 1014;
		  public static final int Prop_Firmware_ManualUpdate_Bool = 1015;
		  public static final int Prop_Firmware_ManualUpdateURL_String = 1016;
		  public static final int Prop_HardwareRevision_Uint64 = 1017;
		  public static final int Prop_FirmwareVersion_Uint64 = 1018;
		  public static final int Prop_FPGAVersion_Uint64 = 1019;
		  public static final int Prop_VRCVersion_Uint64 = 1020;
		  public static final int Prop_RadioVersion_Uint64 = 1021;
		  public static final int Prop_DongleVersion_Uint64 = 1022;
		  public static final int Prop_BlockServerShutdown_Bool = 1023;
		  public static final int Prop_CanUnifyCoordinateSystemWithHmd_Bool = 1024;
		  public static final int Prop_ContainsProximitySensor_Bool = 1025;
		  public static final int Prop_DeviceProvidesBatteryStatus_Bool = 1026;
		  public static final int Prop_DeviceCanPowerOff_Bool = 1027;
		  public static final int Prop_Firmware_ProgrammingTarget_String = 1028;
		  public static final int Prop_DeviceClass_Int32 = 1029;
		  public static final int Prop_HasCamera_Bool = 1030;
		  public static final int Prop_DriverVersion_String = 1031;
		  public static final int Prop_Firmware_ForceUpdateRequired_Bool = 1032;
		  public static final int Prop_ReportsTimeSinceVSync_Bool = 2000;
		  public static final int Prop_SecondsFromVsyncToPhotons_Float = 2001;
		  public static final int Prop_DisplayFrequency_Float = 2002;
		  public static final int Prop_UserIpdMeters_Float = 2003;
		  public static final int Prop_CurrentUniverseId_Uint64 = 2004;
		  public static final int Prop_PreviousUniverseId_Uint64 = 2005;
		  public static final int Prop_DisplayFirmwareVersion_Uint64 = 2006;
		  public static final int Prop_IsOnDesktop_Bool = 2007;
		  public static final int Prop_DisplayMCType_Int32 = 2008;
		  public static final int Prop_DisplayMCOffset_Float = 2009;
		  public static final int Prop_DisplayMCScale_Float = 2010;
		  public static final int Prop_EdidVendorID_Int32 = 2011;
		  public static final int Prop_DisplayMCImageLeft_String = 2012;
		  public static final int Prop_DisplayMCImageRight_String = 2013;
		  public static final int Prop_DisplayGCBlackClamp_Float = 2014;
		  public static final int Prop_EdidProductID_Int32 = 2015;
		  public static final int Prop_CameraToHeadTransform_Matrix34 = 2016;
		  public static final int Prop_DisplayGCType_Int32 = 2017;
		  public static final int Prop_DisplayGCOffset_Float = 2018;
		  public static final int Prop_DisplayGCScale_Float = 2019;
		  public static final int Prop_DisplayGCPrescale_Float = 2020;
		  public static final int Prop_DisplayGCImage_String = 2021;
		  public static final int Prop_LensCenterLeftU_Float = 2022;
		  public static final int Prop_LensCenterLeftV_Float = 2023;
		  public static final int Prop_LensCenterRightU_Float = 2024;
		  public static final int Prop_LensCenterRightV_Float = 2025;
		  public static final int Prop_UserHeadToEyeDepthMeters_Float = 2026;
		  public static final int Prop_CameraFirmwareVersion_Uint64 = 2027;
		  public static final int Prop_CameraFirmwareDescription_String = 2028;
		  public static final int Prop_DisplayFPGAVersion_Uint64 = 2029;
		  public static final int Prop_DisplayBootloaderVersion_Uint64 = 2030;
		  public static final int Prop_DisplayHardwareVersion_Uint64 = 2031;
		  public static final int Prop_AudioFirmwareVersion_Uint64 = 2032;
		  public static final int Prop_CameraCompatibilityMode_Int32 = 2033;
		  public static final int Prop_ScreenshotHorizontalFieldOfViewDegrees_Float = 2034;
		  public static final int Prop_ScreenshotVerticalFieldOfViewDegrees_Float = 2035;
		  public static final int Prop_AttachedDeviceId_String = 3000;
		  public static final int Prop_SupportedButtons_Uint64 = 3001;
		  public static final int Prop_Axis0Type_Int32 = 3002;
		  public static final int Prop_Axis1Type_Int32 = 3003;
		  public static final int Prop_Axis2Type_Int32 = 3004;
		  public static final int Prop_Axis3Type_Int32 = 3005;
		  public static final int Prop_Axis4Type_Int32 = 3006;
		  public static final int Prop_FieldOfViewLeftDegrees_Float = 4000;
		  public static final int Prop_FieldOfViewRightDegrees_Float = 4001;
		  public static final int Prop_FieldOfViewTopDegrees_Float = 4002;
		  public static final int Prop_FieldOfViewBottomDegrees_Float = 4003;
		  public static final int Prop_TrackingRangeMinimumMeters_Float = 4004;
		  public static final int Prop_TrackingRangeMaximumMeters_Float = 4005;
		  public static final int Prop_ModeLabel_String = 4006;
		  public static final int Prop_VendorSpecific_Reserved_Start = 10000;
		  public static final int Prop_VendorSpecific_Reserved_End = 10999;
		}

	  	public static interface ETrackedPropertyError
		{
	  		public static final int TrackedProp_Success = 0;
	  		public static final int TrackedProp_WrongDataType = 1;
	  		public static final int TrackedProp_WrongDeviceClass = 2;
	  		public static final int TrackedProp_BufferTooSmall = 3;
	  		public static final int TrackedProp_UnknownProperty = 4;
	  		public static final int TrackedProp_InvalidDevice = 5;
	  		public static final int TrackedProp_CouldNotContactServer = 6;
	  		public static final int TrackedProp_ValueNotProvidedByDevice = 7;
	  		public static final int TrackedProp_StringExceedsMaximumLength = 8;
	  		public static final int TrackedProp_NotYetAvailable = 9;
		}

	  
	  public static interface ETrackingUniverseOrigin
	  {
		  public static final int TrackingUniverseSeated = 0;
		  public static final int TrackingUniverseStanding = 1;
		  public static final int TrackingUniverseRawAndUncalibrated = 2;
	  }


	  public static interface EVRApplicationType
	  {
		  public static final int VRApplication_Other = 0;
		  public static final int VRApplication_Scene = 1;
		  public static final int VRApplication_Overlay = 2;
		  public static final int VRApplication_Background = 3;
		  public static final int VRApplication_Utility = 4;
		  public static final int VRApplication_VRMonitor = 5;
	  }
	  
	  public static interface EVRInitError
	  {
		  public static final int None = 0;
		  public static final int Unknown = 1;
		  public static final int Init_InstallationNotFound = 100;
		  public static final int Init_InstallationCorrupt = 101;
		  public static final int Init_VRClientDLLNotFound = 102;
		  public static final int Init_FileNotFound = 103;
		  public static final int Init_FactoryNotFound = 104;
		  public static final int Init_InterfaceNotFound = 105;
		  public static final int Init_InvalidInterface = 106;
		  public static final int Init_UserConfigDirectoryInvalid = 107;
		  public static final int Init_HmdNotFound = 108;
		  public static final int Init_NotInitialized = 109;
		  public static final int Init_PathRegistryNotFound = 110;
		  public static final int Init_NoConfigPath = 111;
		  public static final int Init_NoLogPath = 112;
		  public static final int Init_PathRegistryNotWritable = 113;
		  public static final int Init_AppInfoInitFailed = 114;
		  public static final int Init_Retry = 115;
		  public static final int Init_InitCanceledByUser = 116;
		  public static final int Init_AnotherAppLaunching = 117;
		  public static final int Init_SettingsInitFailed = 118;
		  public static final int Init_ShuttingDown = 119;
		  public static final int Init_TooManyObjects = 120;
		  public static final int Init_NoServerForBackgroundApp = 121;
		  public static final int Init_NotSupportedWithCompositor = 122;
		  public static final int Init_NotAvailableToUtilityApps = 123;
		  public static final int Init_Internal = 124;
		  public static final int Driver_Failed = 200;
		  public static final int Driver_Unknown = 201;
		  public static final int Driver_HmdUnknown = 202;
		  public static final int Driver_NotLoaded = 203;
		  public static final int Driver_RuntimeOutOfDate = 204;
		  public static final int Driver_HmdInUse = 205;
		  public static final int Driver_NotCalibrated = 206;
		  public static final int Driver_CalibrationInvalid = 207;
		  public static final int Driver_HmdDisplayNotFound = 208;
		  public static final int IPC_ServerInitFailed = 300;
		  public static final int IPC_ConnectFailed = 301;
		  public static final int IPC_SharedStateInitFailed = 302;
		  public static final int IPC_CompositorInitFailed = 303;
		  public static final int IPC_MutexInitFailed = 304;
		  public static final int IPC_Failed = 305;
		  public static final int Compositor_Failed = 400;
		  public static final int Compositor_D3D11HardwareRequired = 401;
		  public static final int Compositor_FirmwareRequiresUpdate = 402;
		  public static final int VendorSpecific_UnableToConnectToOculusRuntime = 1000;
		  public static final int VendorSpecific_HmdFound_CantOpenDevice = 1101;
		  public static final int VendorSpecific_HmdFound_UnableToRequestConfigStart = 1102;
		  public static final int VendorSpecific_HmdFound_NoStoredConfig = 1103;
		  public static final int VendorSpecific_HmdFound_ConfigTooBig = 1104;
		  public static final int VendorSpecific_HmdFound_ConfigTooSmall = 1105;
		  public static final int VendorSpecific_HmdFound_UnableToInitZLib = 1106;
		  public static final int VendorSpecific_HmdFound_CantReadFirmwareVersion = 1107;
		  public static final int VendorSpecific_HmdFound_UnableToSendUserDataStart = 1108;
		  public static final int VendorSpecific_HmdFound_UnableToGetUserDataStart = 1109;
		  public static final int VendorSpecific_HmdFound_UnableToGetUserDataNext = 1110;
		  public static final int VendorSpecific_HmdFound_UserDataAddressRange = 1111;
		  public static final int VendorSpecific_HmdFound_UserDataError = 1112;
		  public static final int VendorSpecific_HmdFound_ConfigFailedSanityCheck = 1113;
		  public static final int Steam_SteamInstallationNotFound = 2000;
	  }
	  
	  public static interface EVRCompositorError
	  {
		public static final int EVRCompositorError_VRCompositorError_None = 0;
		public static final int EVRCompositorError_VRCompositorError_RequestFailed = 1;
		public static final int EVRCompositorError_VRCompositorError_IncompatibleVersion = 100;
		public static final int EVRCompositorError_VRCompositorError_DoNotHaveFocus = 101;
		public static final int EVRCompositorError_VRCompositorError_InvalidTexture = 102;
		public static final int EVRCompositorError_VRCompositorError_IsNotSceneApplication = 103;
		public static final int EVRCompositorError_VRCompositorError_TextureIsOnWrongDevice = 104;
		public static final int EVRCompositorError_VRCompositorError_TextureUsesUnsupportedFormat = 105;
		public static final int EVRCompositorError_VRCompositorError_SharedTexturesNotSupported = 106;
		public static final int EVRCompositorError_VRCompositorError_IndexOutOfRange = 107;
		public static final int EVRCompositorError_VRCompositorError_ScreenshotAlreadyInProgress = 108;
	  }
	  
	  public static interface EVRRenderModelError
	  {
		public static final int EVRRenderModelError_VRRenderModelError_None = 0;
		public static final int EVRRenderModelError_VRRenderModelError_Loading = 100;
		public static final int EVRRenderModelError_VRRenderModelError_NotSupported = 200;
		public static final int EVRRenderModelError_VRRenderModelError_InvalidArg = 300;
		public static final int EVRRenderModelError_VRRenderModelError_InvalidModel = 301;
		public static final int EVRRenderModelError_VRRenderModelError_NoShapes = 302;
		public static final int EVRRenderModelError_VRRenderModelError_MultipleShapes = 303;
		public static final int EVRRenderModelError_VRRenderModelError_TooManyVertices = 304;
		public static final int EVRRenderModelError_VRRenderModelError_MultipleTextures = 305;
		public static final int EVRRenderModelError_VRRenderModelError_BufferTooSmall = 306;
		public static final int EVRRenderModelError_VRRenderModelError_NotEnoughNormals = 307;
		public static final int EVRRenderModelError_VRRenderModelError_NotEnoughTexCoords = 308;
		public static final int EVRRenderModelError_VRRenderModelError_InvalidTexture = 400;
	  }


	  
	  public Pointer VR_InitInternal(IntByReference peError, int eApplicationType);
	  public void VR_ShutdownInternal();
	  public boolean VR_IsHmdPresent();
	  public boolean VR_IsRuntimeInstalled();
	  public String VR_GetStringForHmdError(int peError);
	  public String VR_RuntimePath();
	  public boolean VR_IsInterfaceVersionValid(String pchInterfaceVersion);
	  public Pointer VR_GetGenericInterface(String pchInterfaceVersion, IntByReference peError);
}
