package org.processmining.processprofiler3d.compviz.vr.jna;

import java.util.BitSet;
import java.util.List;
import java.util.Vector;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;

public class VRControllerState extends Structure
{
	public int unPacketNum;
	public long ulButtonPressed;
	public long ulButtonTouched;
	public VRControllerAxis[] rAxis = new VRControllerAxis[5];

	public VRControllerState()
	{
		super();
		
		//this.setAlignType(this.ALIGN_NONE);
	}
	
	public VRControllerState(Pointer peer)
	{
		super(peer);
		read();
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("unPacketNum");
		lst.add("ulButtonPressed");
		lst.add("ulButtonTouched");
		lst.add("rAxis");
		
		return lst;
	}
	
	public BitSet toBitSet(long value) 
	{
		BitSet bits = new BitSet();
		int index = 0;
		while (value != 0L)
		{
			if (value % 2L != 0)
			{
				bits.set(index);
			}
			++index;
			value = value >>> 1;
		}
		return bits;
	}
	
	public static class ByReference extends VRControllerState implements Structure.ByReference {
		
	};
	public static class ByValue extends VRControllerState implements Structure.ByValue {
		
	};

}
