package org.processmining.processprofiler3d.compviz.vr.jna;

import java.util.List;
import java.util.Vector;

import org.processmining.visualisation3d.maths.JoglMatrixd4x4;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;

public class VRHmdMatrix44 extends Structure 
{
	public float[] m = new float[16];
	
	public VRHmdMatrix44() 
	{
		super();
	}
	
	public VRHmdMatrix44(float m[]) 
	{
		super();
		if ((m.length != 16))
		{
			throw new IllegalArgumentException("Wrong array size!");
		}
		this.m = m;
	}
	
	public VRHmdMatrix44(Pointer peer) 
	{
		super(peer);
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("m");
		
		return lst;
	}

    public JoglMatrixd4x4 toJoglMatrix4x4()
    {
    	JoglMatrixd4x4 mat = JoglMatrixd4x4.CreateIdentity();
        
        mat.SetValue(0,0, m[0]);
        mat.SetValue(0,1, m[1]);
        mat.SetValue(0,2, m[2]);
        mat.SetValue(0,3, m[3]);

        mat.SetValue(1,0, m[4]);
        mat.SetValue(1,1, m[5]);
        mat.SetValue(1,2, m[6]);
        mat.SetValue(1,3, m[7]);

        mat.SetValue(2,0, m[8]);
        mat.SetValue(2,1, m[9]);
        mat.SetValue(2,2, m[10]);
        mat.SetValue(2,3, m[11]);

        mat.SetValue(3,0, m[12]);
        mat.SetValue(3,1, m[13]);
        mat.SetValue(3,2, m[14]);
        mat.SetValue(3,3, m[15]);

        return mat;
    }
	
	public static class ByReference extends VRHmdMatrix44 implements Structure.ByReference 
	{
	};
	
	public static class ByValue extends VRHmdMatrix44 implements Structure.ByValue 
	{	
	};
}
