package org.processmining.processprofiler3d.compviz.vr.jna;

import java.nio.ByteBuffer;
import java.util.List;
import java.util.Vector;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglTexture;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.util.texture.Texture;
import com.jogamp.opengl.util.texture.TextureData;
import com.jogamp.opengl.util.texture.TextureIO;
import com.sun.jna.Pointer;
import com.sun.jna.Structure;

public class VRRenderModelTexture extends Structure
{
	public short width;
	public short height;
	public Pointer data;

	public VRRenderModelTexture()
	{
		super();
		
		//this.setAlignType(this.ALIGN_NONE);
	}
	
	public VRRenderModelTexture(Pointer peer)
	{
		super(peer);
		read();
	}
	
	protected List<String> getFieldOrder() 
	{
		Vector<String> lst = new Vector<String>();
		lst.add("width");
		lst.add("height");
		lst.add("data");
		
		return lst;
	}

	public JoglTexture loadTexture(GraphicsPipeline pipe)
	{
		byte[] imageInByte = data.getByteArray(0, width * height * 4);
		
//		InputStream in = new ByteArrayInputStream(imageInByte);
//		try
//		{
			//BufferedImage img = ImageIO.read(in);
//			BufferedImage img = new BufferedImage(width, height, BufferedImage.TYPE_4BYTE_ABGR);
//			
//			
//			int offset = 0;
//			for (int y = 0; y < height; y++)
//			{
//				for (int x = 0; x < width; x++)
//				{
//					int r = imageInByte[offset+2] & 0xFF;
//					int g = imageInByte[offset+1] & 0xFF;
//					int b = imageInByte[offset] & 0xFF;
//					int a = imageInByte[offset+3] & 0xFF;		
//					
//					Color myColor = new Color(r, g, b, a);
//					
//					int rgb = myColor.getRGB();
//					
//					img.setRGB(x, y, rgb);
//					
//					offset += 4;
//				}
//			}
//
            final ByteBuffer res = ByteBuffer.allocate(width * height * 4);
            res.put(imageInByte);
            res.rewind();
            
            TextureData tdata = new TextureData(pipe.gl.getGLProfile(), GL.GL_RGBA8, width, height, 0, GL.GL_RGBA, GL.GL_UNSIGNED_BYTE,
                                   false, false, true, res, null);
            
			Texture tx = TextureIO.newTexture(tdata);
			
			JoglTexture tex = new JoglTexture(pipe, tx);
			tex.setDefaultFilterSettings(pipe, false);
			
//			File outputfile;
//			try
//			{
//				outputfile = new File(new URI("file:///D:/Lab/image.png"));
//				try
//				{
//					ImageIO.write(img, "png", outputfile);
//				}
//				catch (IOException e)
//				{
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				}
//			}
//			catch (URISyntaxException e1)
//			{
//				// TODO Auto-generated catch block
//				e1.printStackTrace();
//			}
//			
//			JoglTexture tex = null;
//			try
//			{
//				tex = JoglTexture.LoadTextureFromFile(pipe, new URL("file:///D:/Lab/image.jpg"), false);
//			}
//			catch (MalformedURLException e)
//			{
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
			return tex;
//		}
//		catch (IOException e)
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
		
//		return null;
	}
	
	public static class ByReference extends VRRenderModelTexture implements Structure.ByReference {
		
	};
	public static class ByValue extends VRRenderModelTexture implements Structure.ByValue {
		
	};

}
