package org.processmining.processprofiler3d.maths;

import java.util.Vector;

public class ScaleTransforms 
{	
	public static Vector<String> getScaleModes()
	{
		Vector<String> lst = new Vector<String>();
		
		lst.add("Linear");
		lst.add("SquareRoot");
		lst.add("Quadratic");
		lst.add("SphericUp");
		lst.add("SphericDown");
		
		return lst;
	}

	public static double TransformScale(double ts, String smode)
	{
		if (smode.equals("SquareRoot"))
		{
			return ScaleTransforms.TransformSquareRoot(ts);
		}
		else if (smode.equals("Quadratic"))
		{
			return ScaleTransforms.TransformQuadratic(ts);
		}
		else if (smode.equals("SphericUp"))
		{
			return ScaleTransforms.TransformSphericUp(ts);
		}
		else if (smode.equals("SphericDown"))
		{
			return ScaleTransforms.TransformSphericDown(ts);
		}
		return ts;
	}
	
	public static double TransformSquareRoot(double ts)
	{
		if (ts > 0)
		{
			//return 1.0 - ((1.0 - ts) * (1.0 - ts));
			return Math.sqrt(ts);
		}
		else if (ts < 0)
		{
			double ats = Math.abs(ts);
			//return -(1.0 - ((1.0 - ats) * (1.0 - ats)));
			return -Math.sqrt(ats);
		}
		return ts;
	}
	
	public static double TransformQuadratic(double ts)
	{
		if (ts > 0)
		{
			return ts * ts;
		}
		else if (ts < 0)
		{
			return -(ts * ts);
		}
		return ts;
	}
	
	public static double TransformSphericUp(double ts)
	{
		if (ts > 0)
		{
			return Math.sqrt(1.0-((1.0-ts) * (1.0-ts)));
		}
		else if (ts < 0)
		{
			double ats = Math.abs(ts);
			return (1.0-Math.sqrt(1.0-((1.0-ats)*(1.0-ats)))) -1.0;
		}
		return ts;
	}
	
	public static double TransformSphericDown(double ts)
	{
		if (ts > 0)
		{
			return 1.0 - Math.sqrt(1.0-(ts * ts));
		}
		else if (ts < 0)
		{
			return -(1.0 - Math.sqrt(1.0-(ts*ts)));
		}
		return ts;
	}
	
}
