package org.processmining.processprofiler3d.netstructure;

import java.util.Vector;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Arc;

public class ArcPath 
{
	private Vector<Arc> path = null;
	private Vector<PetrinetNode> nodes = null;
	
	public ArcPath()
	{
		path = new Vector<Arc>();
		nodes = new Vector<PetrinetNode>();
	}
	
	public ArcPath(ArcPath p)
	{
		path = new Vector<Arc>(p.path);
		nodes = new Vector<PetrinetNode>(p.nodes);
	}
	
	public int getLength()
	{
		return path.size();
	}
	
	public boolean containsArc(Arc a)
	{
		return path.contains(a);
	}
	
	public boolean containsNode(PetrinetNode pn)
	{
		return nodes.contains(pn);
	}
	
	public int nodeDist(PetrinetNode pn)
	{
		if (containsNode(pn))
		{
			return nodes.indexOf(pn);
		}
		return -1;
	}
	
	public void addArc(Arc a)
	{
		path.add(a);
		
		if (path.size() == 1)
		{
			nodes.add(a.getSource());
		}
		nodes.add(a.getTarget());
	}
	
	public PetrinetNode getDest()
	{
		if (path.size() > 0)
		{
			return path.lastElement().getTarget();
		}
		return null;
	}
}
