package org.processmining.processprofiler3d.netstructure;

import java.util.Vector;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class ArcPathCollection 
{
	private Vector<ArcPath> mypaths;
	
	public ArcPathCollection(Vector<ArcPath> paths)
	{
		mypaths = paths;
	}
	
	public int getMaxDist(PetrinetNode pn)
	{
		int mdist = 0;
		
		for (ArcPath ap : mypaths)
		{
			int ndist = ap.nodeDist(pn);
			if (ndist > mdist)
			{
				mdist = ndist;
			}
		}
		
		return mdist;
	}
}
