package org.processmining.processprofiler3d.netstructure;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Vector;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.processprofiler3d.compviz.INetDataSource;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPnTransition;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;

public class JSOPnTransitionSorter implements Comparator<JSOPnTransition>
{
	public INetDataSource pn = null;
	public Place start = null;
	
	public HashMap<JSOPnTransition, Integer> cache = new HashMap<JSOPnTransition, Integer>();
	private PetriNetStructureUtil pnsu;
	private Vector<PetrinetNode> nodesLst = null;
	
	public JSOPnTransitionSorter(JSOSubNet jspn)
	{
		this.pn = jspn.getPetriNet();
		this.start = pn.getStartPlace();
		
		pnsu = new PetriNetStructureUtil(this.pn);
		
		nodesLst = pnsu.getPathFragmentCollection().getMaxSortedNodes();
	}
	
	public int compare(JSOPnTransition o1, JSOPnTransition o2) 
	{
		if (o1.getParentNet() == o2.getParentNet())
		{
			int dist1 = 0;
			int dist2 = 0;
			
			if (cache.containsKey(o1))
			{
				dist1 = cache.get(o1);
			}
			else
			{
				dist1 = nodesLst.lastIndexOf(o1.orgTransition);
				cache.put(o1, dist1);
			}
			
			if (cache.containsKey(o2))
			{
				dist2 = cache.get(o2);
			}
			else
			{
				//dist2 = allPaths.getMaxDist(o2.orgTransition);
				dist2 = nodesLst.lastIndexOf(o2.orgTransition);
				cache.put(o2, dist2);
			}

			return dist1 - dist2;
		}
		return 0;
	}
	
}
