package org.processmining.processprofiler3d.netstructure;

import java.util.Vector;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class PathFragmentParallel extends PathFragment 
{
	private PathFragment myFrag1 = null;
	private PathFragment myFrag2 = null;
	
	public PathFragmentParallel(PathFragment pf1, PathFragment pf2)
	{
		myFrag1 = pf1;
		myFrag2 = pf2;
	}
	
	@Override
	public void getSimpleFragments(Vector<PathFragmentSimple> fs)
	{
		if (myFrag1 instanceof PathFragmentSimple)
		{
			fs.add((PathFragmentSimple)myFrag1);
		}
		else
		{
			myFrag1.getSimpleFragments(fs);
		}
		
		if (myFrag2 instanceof PathFragmentSimple)
		{
			fs.add((PathFragmentSimple)myFrag2);
		}
		else
		{
			myFrag2.getSimpleFragments(fs);
		}
	}
	
	@Override
	public PetrinetNode getSource()
	{
		return myFrag1.getSource();
	}

	@Override
	public PetrinetNode getTarget()
	{
		return myFrag1.getTarget();
	}

}
