package org.processmining.processprofiler3d.placealignment;

import java.util.Vector;

import org.deckfour.xes.model.XLog;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.processprofiler3d.compviz.INetDataSource;
import org.processmining.processprofiler3d.psen.PetriNetIndexed;
import org.processmining.processprofiler3d.psen.classification.ClassificationCohort;

public class PlaceAlignmentCalculator
{

	public PlaceAlignmentCalculator()
	{
		// TODO Auto-generated constructor stub
	}
	
	public static Vector<PlaceAlignmentInfo> Analyse(INetDataSource net, XLog log, Marking initMarking, Marking finalMarking)
	{
		Vector<PlaceAlignmentInfo> paiLst = new Vector<PlaceAlignmentInfo>();
		PetriNetIndexed pidx = new PetriNetIndexed(net);
		
		for (Place p : net.getPlaces())
		{
			PlaceAlignmentInfo pai = new PlaceAlignmentInfo(p);
			pai.Calculate(log, initMarking, finalMarking, net, pidx);
			
			paiLst.add(pai);
		}
		
		String sx = "";
		
		return paiLst;
	}
	
	public static Vector<PlaceAlignmentInfo> Analyse(INetDataSource net, XLog log, Marking initMarking, Marking finalMarking, ClassificationCohort cohort)
	{
		Vector<PlaceAlignmentInfo> paiLst = new Vector<PlaceAlignmentInfo>();
		PetriNetIndexed pidx = new PetriNetIndexed(net);
		
		for (Place p : net.getPlaces())
		{
			PlaceAlignmentInfo pai = new PlaceAlignmentInfo(p);
			pai.Calculate(log, initMarking, finalMarking, net, pidx, cohort);
			
			paiLst.add(pai);
		}
		
		String sx = "";
		
		return paiLst;
	}

}
