package org.processmining.processprofiler3d.placealignment;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

public class PlaceAlignmentCellRenderer extends DefaultTableCellRenderer
{

	public PlaceAlignmentCellRenderer()
	{
		// TODO Auto-generated constructor stub
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus,
			int row, int col)
	{

		//Cells are by default rendered as a JLabel.
		JLabel l = (JLabel) super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);

		//Get the status for the current row.
		if (table.getModel() instanceof IPlaceAlignmentTableModel)
		{
			IPlaceAlignmentTableModel tableModel = (IPlaceAlignmentTableModel) table.getModel();
			float cellStatus = tableModel.getCellStatus(row, col);
			
			Color c = Color.WHITE;
			if (cellStatus <= 1.0f)
			{
				c = Mix(Color.WHITE, Color.YELLOW, cellStatus);
			}
			else
			{
				c = Mix(Color.YELLOW, Color.RED, cellStatus - 1.0f);
			}
			
			l.setBackground(c);
		}

		//Return the JLabel which renders the cell.
		return l;
	}
	
	private Color Mix(Color a, Color b, float mix)
	{
		int red = (int)((a.getRed() * (1.0f-mix)) + (b.getRed() * mix));
		int green = (int)((a.getGreen() * (1.0f-mix)) + (b.getGreen() * mix));
		int blue = (int)((a.getBlue() * (1.0f-mix)) + (b.getBlue() * mix));
		
		Color c = new Color(red, green, blue);
		
		return c;
	}

}
