package org.processmining.processprofiler3d.placealignment;

import java.util.Vector;

import javax.swing.table.AbstractTableModel;

public class PlaceAlignmentTableModelDetailQual extends AbstractTableModel implements IPlaceAlignmentTableModel
{
    private String[] columnNames = {"Place",
            "Support",
//            "Confidence",
//            "Confidence2"};
            "Confidence"};
    
    private Vector<PlaceAlignmentInfo> data = null;

    public PlaceAlignmentTableModelDetailQual(Vector<PlaceAlignmentInfo> lst)
    {
    	data = lst;
    }
    
    public int getNumCases()
    {
    	if (data.isEmpty())
    	{
    		return 0;
    	}
    	return data.firstElement().numberOfCases;
    }
    
    public int getColumnCount() 
    {
        return columnNames.length;
    }

    public int getRowCount() 
    {
    	int count = 0;
    	
    	for (PlaceAlignmentInfo pai : data)
    	{
    		count += pai.detailPais.keySet().size();
    	}
    	
        return count;
    }

    public String getColumnName(int col) 
    {
        return columnNames[col];
    }

    public PlaceAlignmentInfoDetail getPaid(int row)
    {
    	int count = 0;
    	
    	for (PlaceAlignmentInfo paix : data)
    	{
    		for (String s : paix.detailPais.keySet())
    		{
    			if (row == count)
    			{
    		    	return paix.detailPais.get(s);
    			}
    			count++;
    		}
    	}
    	return null;
    }
    
    public Object getValueAt(int row, int col) 
    {
    	PlaceAlignmentInfoDetail pai = getPaid(row);
    	
    	if (col == 0)
    	{
    		return pai.getLabel();
    	}
    	else if (col == 1)
    	{
    		return pai.getSupport();
    	}
    	else if (col == 2)
    	{
    		return pai.getConfidence();
    	}
//    	else if (col == 3)
//    	{
//    		return pai.getConfidence2();
//    	}
		
        return null;
    }

    public float getCellStatus(int row, int col) 
    {
    	PlaceAlignmentInfoDetail pai = getPaid(row);
    	
    	if (col == 0)
    	{
    		return 0;
    	}
    	else if (col == 1)
    	{
    		return 0;
    	}
    	else if (col == 2)
    	{
    		float perc = pai.getConfidence();
    		return (1.0f-perc) * 2.0f;
    	}
//    	else if (col == 3)
//    	{
//    		float perc = pai.getConfidence2();
//    		return (1.0f-perc) * 2.0f;
//    	}
		
        return 0;
    }

    public Class getColumnClass(int c) 
    {
        return getValueAt(0, c).getClass();
    }

    /*
     * Don't need to implement this method unless your table's
     * editable.
     */
//    public boolean isCellEditable(int row, int col) {
//        //Note that the data/cell address is constant,
//        //no matter where the cell appears onscreen.
//        if (col < 2) {
//            return false;
//        } else {
//            return true;
//        }
//    }

    /*
     * Don't need to implement this method unless your table's
     * data can change.
     */
//    public void setValueAt(Object value, int row, int col) {
//        data[row][col] = value;
//        fireTableCellUpdated(row, col);
//    }
//    ...
}
