package org.processmining.processprofiler3d.psen;

import java.util.HashSet;

import org.deckfour.xes.model.XEvent;
import org.processmining.plugins.petrinet.replayresult.StepTypes;
import org.processmining.processprofiler3d.psen.preprocess.LPPAction;

public class AlignedLog 
{
	public static String ATT_NAME_REPLAY_GROUP_ID = "alignment:replayResultGroupId";
	public static String ATT_NAME_IS_RELIABLE = "alignment:isReliable";
	public static String ATT_NAME_IS_BROKEN = "alignment:isBroken";
	public static String ATT_NAME_IS_PERFECT_FIT = "alignment:isPerfectFit";
	public static String ATT_NAME_NODE_ID = "alignment:localNodeId";
	public static String ATT_NAME_STEP_TYPE = "alignment:stepType";
	
	public static boolean CheckLogIsAligned(LogAnalyser la)
	{
		HashSet<String> lst = la.calcAvailableTraceAttrs();
		HashSet<String> lst2 = la.calcAvailableEventAttrs();
		return (lst.contains(AlignedLog.ATT_NAME_IS_RELIABLE) || lst2.contains(AlignedLog.ATT_NAME_NODE_ID) || lst2.contains(AlignedLog.ATT_NAME_STEP_TYPE));
	}
	
	public static String getLocalNodeId(XEvent evt)
	{
		return LPPAction.getAttributeValueLiteral(evt, AlignedLog.ATT_NAME_NODE_ID);
	}
	
	public static StepTypes getStepType(XEvent evt)
	{
		String val = LPPAction.getAttributeValueLiteral(evt, AlignedLog.ATT_NAME_STEP_TYPE);

		if (val.equals(StepTypes.L.toString()) || val.equals("L"))
		{
			return StepTypes.L;
		}
		if (val.equals(StepTypes.LMGOOD.toString()) || val.equals("LMGOOD"))
		{
			return StepTypes.LMGOOD;
		}
		if (val.equals(StepTypes.MINVI.toString()) || val.equals("MINVI"))
		{
			return StepTypes.MINVI;
		}
		if (val.equals(StepTypes.MREAL.toString()) || val.equals("MREAL"))
		{
			return StepTypes.MREAL;
		}
		if (val.equals(StepTypes.LMNOGOOD.toString()) || val.equals("LMNOGOOD"))
		{
			return StepTypes.LMNOGOOD;
		}
		if (val.equals(StepTypes.LMREPLACED.toString()) || val.equals("LMREPLACED"))
		{
			return StepTypes.LMREPLACED;
		}
		if (val.equals(StepTypes.LMSWAPPED.toString()) || val.equals("LMSWAPPED"))
		{
			return StepTypes.LMSWAPPED;
		}
		return null;
	}
}
