package org.processmining.processprofiler3d.psen;

import java.util.List;
import java.util.concurrent.CancellationException;
import java.util.concurrent.ExecutionException;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.PluginDescriptor;
import org.processmining.framework.plugin.PluginExecutionResult;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.plugins.connectionfactories.logpetrinet.TransEvClassMapping;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

public class MyPOLogReplayer implements ILogReplayer
{
	//private TransEvClassMapping mapping = null;
	
	public static boolean IsPartialOrderAvailable(final UIPluginContext context)
	{
		for (PluginDescriptor pd : context.getParentContext().getPluginManager().getAllPlugins(true))
		{
			if (pd.getName().contains("Partial") && pd.getName().contains("Aware") && pd.getName().contains("Replay"))
			{
				String str = "";
				PluginExecutionResult per = null;
				UIPluginContext childContext = context.createChildContext("POChild");
				//find the method that fits our parameters!
				for (int i = 0 ; i < pd.getNumberOfMethods(); i++)
				{
					boolean bFits = false;
					List<Class<?>> tlst = pd.getParameterTypes(i);
					if (tlst.size() == 2)
					{
						bFits = true;
						if (!tlst.get(0).isAssignableFrom(Petrinet.class))
						{
							bFits = false;
						}
						if (!tlst.get(1).isAssignableFrom(XLog.class))
						{
							bFits = false;
						}
						
					}
					
					if (bFits)
					{
						return true;		
					}
				}
			}
		}
		return false;
	}
	
	public PNRepResult replayLog(final UIPluginContext context, PetrinetGraph pgexp, XLog log)
	{
//		PNRepResult obj = null;
//		PartialNetReplayer rep = new PartialNetReplayer();
//		try
//		{
//			obj = rep.replayLogGUIStandard(context, pgexp, log);
//		}
//		catch (ConnectionCannotBeObtained e)
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		catch (AStarException e)
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		
//		rrp.logReplayResult = obj;
		
		for (PluginDescriptor pd : context.getParentContext().getPluginManager().getAllPlugins(true))
		{
			if (pd.getName().contains("Partial") && pd.getName().contains("Aware") && pd.getName().contains("Replay"))
			{
				String str = "";
				PluginExecutionResult per = null;
				UIPluginContext childContext = context.createChildContext("POChild");
				try
				{
					//find the method that fits our parameters!
					for (int i = 0 ; i < pd.getNumberOfMethods(); i++)
					{
						boolean bFits = false;
						List<Class<?>> tlst = pd.getParameterTypes(i);
						if (tlst.size() == 2)
						{
							bFits = true;
							if (!tlst.get(0).isAssignableFrom(pgexp.getClass()))
							{
								bFits = false;
							}
							if (!tlst.get(1).isAssignableFrom(log.getClass()))
							{
								bFits = false;
							}
							
						}
						
						if (bFits)
						{
							per = pd.invoke(i, childContext, pgexp, log);
							per.synchronize();
							break;
						}
					}
					
				}
				catch (CancellationException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				catch (ExecutionException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				catch (InterruptedException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				PNRepResult obj = per.getResult(0);
				
				//rrp.logReplayResult = obj;
				return obj;
			}
		}
		return null;
	}

	public TransEvClassMapping getMapping()
	{
		//return this.mapping;
		return null;
	}

}
