package org.processmining.processprofiler3d.psen;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class PetriNet1to1Mapping 
{
	private Map<PetrinetNode, PetrinetNode> mapOrig2ViewNode = new HashMap<PetrinetNode, PetrinetNode>();
	private Map<PetrinetNode, PetrinetNode> mapView2OrigNode = new HashMap<PetrinetNode, PetrinetNode>();
	
	public void addPair(PetrinetNode orig, PetrinetNode view)
	{
		mapOrig2ViewNode.put(orig, view);
		mapView2OrigNode.put(view, orig);
	}
	
	public boolean hasOrigNode(PetrinetNode pn)
	{
		return mapOrig2ViewNode.containsKey(pn);
	}
	
	public boolean hasViewNode(PetrinetNode pn)
	{
		return mapView2OrigNode.containsKey(pn);
	}
	
	public Collection<PetrinetNode> getOrigValues()
	{
		return mapOrig2ViewNode.keySet();
	}
	
	public Collection<PetrinetNode> getViewValues()
	{
		return mapView2OrigNode.keySet();
	}
	
	public PetrinetNode mapToView(PetrinetNode pn)
	{
		return mapOrig2ViewNode.get(pn);
	}
	
	public PetrinetNode mapToOrig(PetrinetNode pn)
	{
		return mapView2OrigNode.get(pn);
	}
}
