package org.processmining.processprofiler3d.psen.classification;

import java.util.Vector;

import org.deckfour.xes.model.XTrace;

public class ClassificationCohort 
{
	protected ClassificationCohort parent = null;
	protected int cohortID = -1;
	protected String name;
	protected Vector<ClassificationCohort> children = new Vector<ClassificationCohort>();
	
	public ClassificationCohort(String n)
	{
		name = n;
	}
	
	public int getID()
	{
		return cohortID;
	}
	
	public void setID(int cid)
	{
		cohortID = cid;
	}
	
	public int getLevel()
	{
		if (parent != null)
		{
			return parent.getLevel() + 1;
		}
		return 0;
	}
	
	public Vector<ClassificationCohort> getChildren()
	{
		return new Vector<ClassificationCohort>(children);
	}
	
	public ClassificationCohort getParent()
	{
		return parent;
	}
	
	public String getName()
	{
		return name;
	}
	
	public boolean hasChildren()
	{
		return !children.isEmpty();
	}
	
	public CohortDefinition getCohortDefinition()
	{
		return null;
	}
	
	public boolean isPartOfCohort(XTrace trc)
	{
		return true;
	}
	
	public void addChild(ClassificationCohort cc)
	{
		children.add(cc);
		cc.parent = this;
	}
	
	public void removeChild(ClassificationCohort cc)
	{
		children.remove(cc);
		cc.parent = null;
	}
	
	public int mapTraceToCohortID(XTrace trc)
	{
		if (isPartOfCohort(trc))
		{
			for (ClassificationCohort cc : children)
			{
				int id = cc.mapTraceToCohortID(trc);
				if (id != -1)
				{
					return id;
				}
			}
			return cohortID;
		}
		return -1;
	}
}
