package org.processmining.processprofiler3d.psen.classification;

public class CohortDefinitionIntRange extends CohortDefinition
{
	public int startValue = 0;
	public int endValue = 0;
	public boolean bInclStart = false;
	public boolean bInclEnd = true;
	
	public CohortDefinitionIntRange(String n, String aName, int st, int et)
	{
		super(n, aName);
		
		startValue = st;
		endValue = et;
	}
	
	public CohortDefinitionIntRange(String n, String aName, int st, int et, boolean bStartIn, boolean bEndIn)
	{
		super(n, aName);
		
		startValue = st;
		endValue = et;
		bInclStart = bStartIn;
		bInclEnd = bEndIn;
	}
	
	@Override
	public String getClassifierType()
	{
		return ClassificationCohortIntRange.classifierName;
	}
	
	public ClassificationCohort createClassificationCohort()
	{
		ClassificationCohortIntRange cc = new ClassificationCohortIntRange(this);
		
		for (CohortDefinition cd : children)
		{
			cc.addChild(cd.createClassificationCohort());
		}
		return cc;
	}
}
