package org.processmining.processprofiler3d.psen.classification;

public class CohortDefinitionTimeOfDay extends CohortDefinition
{
	public int startTime = 0;
	public int endTime = 0;
	public boolean bInclStart = false;
	public boolean bInclEnd = true;
	
	public CohortDefinitionTimeOfDay(String n, String aName, int st, int et)
	{
		super(n, aName);
		
		startTime = st;
		endTime = et;
	}
	
	public CohortDefinitionTimeOfDay(String n, String aName, int st, int et, boolean bStartIn, boolean bEndIn)
	{
		super(n, aName);
		
		startTime = st;
		endTime = et;
		bInclStart = bStartIn;
		bInclEnd = bEndIn;
	}
	
	@Override
	public String getClassifierType()
	{
		return ClassificationCohortTimeOfDay.classifierName;
	}
	
	public ClassificationCohort createClassificationCohort()
	{
		ClassificationCohortTimeOfDay cc = new ClassificationCohortTimeOfDay(this);
		
		for (CohortDefinition cd : children)
		{
			cc.addChild(cd.createClassificationCohort());
		}
		return cc;
	}
}
