package org.processmining.processprofiler3d.psen.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;

public class PSENConnection extends AbstractConnection
{
	public static final String PSEN = "psen";
	public static final String WTEN = "wten";
	  
	private IPerformanceStatisticsEnrichedNet psen;
	private IPerformanceStatisticsEnrichedNet wten;
	
	public PSENConnection(IPerformanceStatisticsEnrichedNet psen, IPerformanceStatisticsEnrichedNet wten) 
	{
	    super("PSEN connection for " + psen.toString() + " and " + wten.toString());
	    put(PSEN, psen);
	    put(WTEN, wten);
	    
	    this.psen = psen;
	    this.wten = wten;
	}
	  
	public IPerformanceStatisticsEnrichedNet getPerformanceStatisticsEnrichedNet()
	{
		return psen;
	}
	  
	public IPerformanceStatisticsEnrichedNet getWaitingTimeEnrichedNet()
	{
		return wten;
	}
}
