package org.processmining.processprofiler3d.psen.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.processprofiler3d.psen.PetriNet1to1Mapping;

public class PetrinetFlattenConnection  extends AbstractConnection
{
	public static final String HIERARCHICAL_NET = "psenh";
	public static final String FLATTENED_NET = "psenf";
	public static final String MAPPING = "psenm";
	
	public PetrinetFlattenConnection(Petrinet hierarchicalNet, Petrinet flatNet, PetriNet1to1Mapping map)
	{
	    super("Petrinet Flatten connection for " + hierarchicalNet.toString() + " to " + flatNet.toString());
	    put(HIERARCHICAL_NET, hierarchicalNet);
	    put(FLATTENED_NET, flatNet);
	    put(MAPPING, map);
	}
	
	public Petrinet getHierarchicalNet()
	{
		return getObjectWithRole(PetrinetFlattenConnection.HIERARCHICAL_NET);
	}
	
	public Petrinet getFlattenedNet()
	{
		return getObjectWithRole(PetrinetFlattenConnection.FLATTENED_NET);
	}
	
	public PetriNet1to1Mapping getNetMapping()
	{
		return getObjectWithRole(PetrinetFlattenConnection.MAPPING);
	}
}
