package org.processmining.processprofiler3d.psen.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.processprofiler3d.psen.PetriNet1toManyMapping;

public class PetrinetLifecycleExpansionConnection  extends AbstractConnection
{
	public static final String SOURCE_NET = "psenh";
	public static final String EXPANDED_NET = "psenf";
	public static final String MAPPING = "psenm";
	
	public PetrinetLifecycleExpansionConnection(Petrinet hierarchicalNet, Petrinet flatNet, PetriNet1toManyMapping map)
	{
	    super("Petrinet Flatten connection for " + hierarchicalNet.toString() + " to " + flatNet.toString());
	    put(SOURCE_NET, hierarchicalNet);
	    put(EXPANDED_NET, flatNet);
	    put(MAPPING, map);
	}
	
	public Petrinet getExpandedNet()
	{
		return getObjectWithRole(PetrinetLifecycleExpansionConnection.EXPANDED_NET);
	}
	
	public Petrinet getSourceNet()
	{
		return getObjectWithRole(PetrinetLifecycleExpansionConnection.SOURCE_NET);
	}
	
	public PetriNet1toManyMapping getNetMapping()
	{
		return getObjectWithRole(PetrinetLifecycleExpansionConnection.MAPPING);
	}
}
