package org.processmining.processprofiler3d.psen.datastructure;

import java.sql.Connection;
import java.sql.DriverManager;

public class H2MemoryDatabase 
{
	private static int dbNum = 1;
	
    private static final String DB_DRIVER = "org.h2.Driver";
    private static final String DB_USER = "test";
    private static final String DB_PASSWORD = "";

    private String DB_CONNECTION = "jdbc:h2:mem:test;DB_CLOSE_DELAY=-1";

    private Connection con;
    
    public H2MemoryDatabase()
    {
    	String dbName = "psen" + dbNum;
    	DB_CONNECTION = "jdbc:h2:mem:" + dbName + ";DB_CLOSE_DELAY=-1";
    	
    	dbNum++;
    }
    
    public boolean isDriverAvailable()
    {
    	try 
    	{
    	    Class.forName(DB_DRIVER);
    	    // Success.
    	    return true;
    	} 
    	catch (ClassNotFoundException e) 
    	{
    	    // Fail.
			System.out.println("H2 JDBC database driver is not available! Please check if the H2 jar dependency was installed properly!");
			return false;
    	}
    }
    
    public Connection getConnection()
    {
    	if (con == null)
    	{
			try
			{
				Class.forName(DB_DRIVER);
		        con = DriverManager.getConnection(DB_CONNECTION, DB_USER, DB_PASSWORD);
			}
			catch( Exception e )
			{
				System.out.println( e.getMessage() );
				e.printStackTrace();
			}
    	}
    	return con;
    }
}
