package org.processmining.processprofiler3d.psen.datastructure;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.Vector;

import org.deckfour.xes.model.XTrace;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.processprofiler3d.psen.classification.CohortClassifier;

public interface IPerformanceStatisticsEnrichedNet 
{

	public abstract void update();

	// A set of methods that return the variables
	public abstract Collection<PSENLabel> getLabels();
	
	public abstract HashSet<String> getClassifierValues();

	public abstract Set<String> getTransitions();
	
	public abstract Set<String> getTransitionsInclNone();

	public abstract void addLabel(PSENLabel l);

	public abstract boolean hasLabel(String labelName);

	public abstract PSENLabel getLabelByName(String label_name);
	
	public abstract int getValueCount();

	public abstract boolean hasValue(String transition);

	public abstract boolean hasValue(String transition, String labelName);

	public abstract boolean hasValue(String transition, String labelName, String classifierValue);

	public abstract double getValue(String transition, String labelName, String classifierValue);
	
	public abstract Vector<Double> getValues(String transition, String labelName, String classifierValue);

	public abstract void addValue(String transition, String labelName, String traceId, double myValue);

	//public abstract void setCohortsForTraces(XLog log, CohortClassifier cc);
	
	public abstract void setCohortsForTraces(Iterable<XTrace> log, CohortClassifier cc);

	public abstract boolean fitsPetrinet(PetrinetGraph pnet);

}