package org.processmining.processprofiler3d.psen.datastructure;

import java.sql.Connection;
import java.sql.Types;

import org.h2.api.AggregateFunction;

import com.google.common.collect.TreeMultiset;

public class MedianTest implements AggregateFunction 
{
    //private final ArrayList<Double> list = New.arrayList();
    //private final TreeSet<Double> list = new TreeSet<Double>();
    private final TreeMultiset<Double> list = TreeMultiset.create();

    @Override
    public void add(Object value) 
    {
        list.add((Double)value);
    }

    @Override
    public Object getResult() 
    {
		//Collections.sort(list);
		Double[] valuesArray = new Double[list.size()];
		valuesArray = list.toArray(valuesArray);
		
		if (list.size() == 0)
		{
			return 0.0;
		}
		else if ((list.size()) % 2 == 0)
		{
			int id1 = list.size() / 2;
			int id2 = id1 - 1;
			double val1 = valuesArray[id1].doubleValue();
			double val2 = valuesArray[id2].doubleValue();
			
			return val1 + ((val2 - val1) * 0.5);
		}
		else
		{
			int id = (list.size() - 1) / 2;
			return valuesArray[id].doubleValue();
		}
    }

    @Override
    public int getType(int[] inputType) 
    {
        return Types.DOUBLE;
    }

    @Override
    public void init(Connection conn) 
    {
    }

}

