package org.processmining.processprofiler3d.psen.datastructure;

public class PSENLabel 
{
	public static final int MIN = 0;
	public static final int MEAN = 1;
	public static final int MAX = 2;
	public static final int COUNT = 3;
	public static final int SUM = 4;
	public static final int MEDIAN = 5;

	private String labelName;	
	private int aggregationType;
	private String nodeName;
	private boolean bTimeSpan = false;
	
	public int lid = -1;
	
	public PSENLabel(String myName, String nodeName, int aggType, boolean bTimeSpan)
	{
		this.labelName = myName;
		this.nodeName = nodeName;
		this.aggregationType = aggType;
		this.bTimeSpan = bTimeSpan;
	}
	
	public String getLabelName()
	{
		return this.labelName;
	}
 
	public String getNodeName()
	{
		return this.nodeName;
	}
	
	public int getAggregationType()
	{
		return this.aggregationType;
	}
	
	public boolean isTimeSpan()
	{
		return bTimeSpan;
	}
	
	public void setLabelName(String myName)
	{
		this.labelName = myName;
	}
	
	public void setLabelType(int myType)
	{
		this.aggregationType = myType;
	}
	
	public String getSQLAggOperator()
	{
		if (aggregationType == PSENLabel.MIN)
		{
			return "MIN";
		}
		else if (aggregationType == PSENLabel.MEAN)
		{
			return "AVG";
		}
		else if (aggregationType == PSENLabel.MAX)
		{
			return "MAX";
		}
		else if (aggregationType == PSENLabel.COUNT)
		{
			return "COUNT";
		}
		else if (aggregationType == PSENLabel.SUM)
		{
			return "SUM";
		}
		else if (aggregationType == PSENLabel.MEDIAN)
		{
			return "MEDIAN";
		}
		return "";
	}

}
