package org.processmining.processprofiler3d.psen.datastructure;

import java.util.Collection;
import java.util.HashMap;
import java.util.Vector;

public class PerformanceDBLabelStore
{
	private HashMap<String, PSENLabel> labels = new HashMap<String, PSENLabel>();

	public PerformanceDBLabelStore()
	{
		// TODO Auto-generated constructor stub
	}
	
	public Collection<PSENLabel> values()
	{
		return this.labels.values();
	}
	
	public void addLabel(PSENLabel l)
	{
		Vector<String> lstNodeNames = new Vector<String>();
		boolean bExists = false;
		for (PSENLabel lx : labels.values())
		{
			if (!lstNodeNames.contains(lx.getNodeName()))
			{
				lstNodeNames.add(lx.getNodeName());
			}
			if (lx.getNodeName().equals(l.getNodeName()))
			{
				l.lid = lx.lid;
				bExists = true;
			}
		}
		
		if (!bExists)
		{
			int labelNum = lstNodeNames.size();
			l.lid = labelNum;
		}
		this.labels.put(l.getLabelName(), l);
	}
	
	public boolean hasLabel(String labelName)
	{
		return labels.containsKey(labelName);
	}
	
	public PSENLabel getLabelByName(String labelName)
	{
		return labels.get(labelName);
	}
	
	public PSENLabel getLabelById(int labelId)
	{
		for (PSENLabel l : labels.values())
		{
			if (l.lid == labelId)
			{
				return l;
			}
		}
		return null;
		//return labels.get(labelName);
	}

}
