package org.processmining.processprofiler3d.psen.fileio;

import java.util.HashMap;
import java.util.Vector;

public class HtmlUtil 
{
	public static HashMap<String, String> chs = null;
	
	private static void initDictionary()
	{
		chs = new HashMap<String, String>();
		chs.put("&amp;", "&");
		chs.put("&quot;", "\"");
		
		chs.put("&#32;", " ");
		chs.put("&#33;", "!");
		chs.put("&#34;", "\"");
		chs.put("&#35;", "#");
		chs.put("&#36;", "$");
		chs.put("&#37;", "%");
		chs.put("&#38;", "&");
		chs.put("&#39;", "'");
		chs.put("&#40;", "(");
		chs.put("&#41;", ")");
		chs.put("&#42;", "*");
		chs.put("&#43;", "+");
		chs.put("&#44;", ",");
		chs.put("&#45;", "-");
		chs.put("&#46;", ".");
		chs.put("&#47;", "/");

		chs.put("&lt;", "<");
		chs.put("&gt;", ">");
		
		//TODO: decode add all possible html chars!
	}
	
	public static String decodeHtmlChars(String str)
	{
		//init dictionary
		if (chs == null)
		{
			initDictionary();
		}
		
		String strf = str;
		
		if (strf.contains("&"))
		{
			Vector<String> lst = Helper(str);
			while (!lst.isEmpty())
			{
				String htmlCode = lst.firstElement();
				if (chs.containsKey(htmlCode))
				{
					strf = strf.replace(htmlCode, chs.get(htmlCode));
				}
				else
				{
					System.out.println("Found unknown HTML char: " + htmlCode);
				}
				lst.remove(0);
			}
		}
		
		return strf;
	}
	
	private static Vector<String> Helper(String str)
	{
		Vector<String> lst = new Vector<String>();
		int idx = str.indexOf("&", 0);
		while (idx > -1)
		{
			String sx = str.substring(idx, idx+5);
			int idx2 = sx.indexOf(";");
			if (idx2 > -1)
			{
				sx = sx.substring(0, idx2+1);
				lst.add(sx);
				idx = str.indexOf("&", idx + idx2 + 1);
			}
			else
			{
				idx = str.indexOf("&", idx+1);
			}
		}
		
		return lst;
	}
}
