package org.processmining.processprofiler3d.psen.fileio.obj;

import java.util.Vector;

import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class OBJObject 
{
	public String objName = "";
	public String material = null;
	public Vector<JoglVectord3> verts = null;
	public Vector<JoglVectord2> texcoords = null;
	public Vector<OBJFace> faces = null;
	
	public OBJObject(String n)
	{
		objName = n;
	}
	
	public int WriteVertex(JoglVectord3 v)
	{
		if (verts == null)
		{
			verts = new Vector<JoglVectord3>();
		}
		
		verts.add(v);
		
		return verts.size() - 1;
	}
	
	public int WriteTexCoords(JoglVectord2 v)
	{
		if (texcoords == null)
		{
			texcoords = new Vector<JoglVectord2>();
		}
		
		texcoords.add(v);
		
		return texcoords.size() - 1;
	}

	public void WriteUseMtl(String mtlName)
	{
		material = mtlName;
	}
	
	public void WriteFaceTri(int v1, int v2, int v3)
	{
		if (faces == null)
		{
			faces = new Vector<OBJFace>();
		}
		
		faces.add(new OBJFace(v1, v2, v3));
	}
	
	public void WriteFaceTriTex(int v1, int v2, int v3, int vt1, int vt2, int vt3)
	{
		if (faces == null)
		{
			faces = new Vector<OBJFace>();
		}
		
		faces.add(new OBJFaceTextured(v1, v2, v3, vt1, vt2, vt3));
	}
}
