package org.processmining.processprofiler3d.psen.fileio.obj;

import java.util.Vector;

import org.processmining.visualisation3d.maths.JoglVectord2;
import org.processmining.visualisation3d.maths.JoglVectord3;

public class OBJObjectWriter extends OBJWriter
{
	public Vector<OBJObject> objList = new Vector<OBJObject>();
	private OBJObject currentObj = null;
	
	public OBJObjectWriter()
	{
	}

	@Override
	public void Open(String filePath)
	{
	}

	@Override
	public void Write(String s)
	{
	}

	@Override
	public void WriteLine(String s)
	{
	}

	@Override
	public void WriteMtlLib(String name)
	{
	}

	@Override
	public void WriteNewObject(String name)
	{
		if (currentObj != null)
		{
			objList.add(currentObj);
		}
		
		currentObj = new OBJObject(name);
	}

	@Override
	public int WriteVertex(JoglVectord3 v)
	{
		return currentObj.WriteVertex(v);
	}

	@Override
	public int WriteVertex(double x, double y, double z)
	{
		return currentObj.WriteVertex(new JoglVectord3(x,y,z));
	}
	
	@Override
	public int WriteTexCoords(JoglVectord2 v)
	{
		return currentObj.WriteTexCoords(v);
	}

	@Override
	public int WriteTexCoords(double u, double v)
	{
		return currentObj.WriteTexCoords(new JoglVectord2(u, v));
	}
	
	@Override
	public void WriteUseMtl(String mtlName)
	{
		currentObj.WriteUseMtl(mtlName);
	}

	@Override
	public void WriteFaceTri(int v1, int v2, int v3)
	{
		currentObj.WriteFaceTri(v1, v2, v3);
	}

	@Override
	public void WriteFaceTriTex(int v1, int v2, int v3, int vt1, int vt2, int vt3)
	{
		currentObj.WriteFaceTriTex(v1, v2, v3, vt1, vt2, vt3);
	}

	@Override
	public void Close()
	{
		if (currentObj != null)
		{
			objList.add(currentObj);
		}
	}
}
