package org.processmining.processprofiler3d.psen.fileio.obj;

import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPSENEdgeVisualizationLayer;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOPSENTransitionVisualizationLayer;
import org.processmining.processprofiler3d.compviz.jogl.scene.JSOSubNet;
import org.processmining.processprofiler3d.compviz.scenemanagement.JoglModelScene;
import org.processmining.processprofiler3d.compviz.scenemanagement.JoglPSENVisualizationScene;
import org.processmining.visualisation3d.scenemanagement.JoglScene;

public class SceneExporter 
{	
	public static void Export(OBJWriter out, JoglScene scene)
	{
		if (scene instanceof JoglModelScene)
		{
			
			if (scene instanceof JoglPSENVisualizationScene)
			{
				JoglPSENVisualizationScene jms = (JoglPSENVisualizationScene)scene;
				jms.getPetriNet().Export(scene, out);
				for (JSOSubNet snet : jms.getPetriNet().getAllSubNets())
				{
					JSOPSENTransitionVisualizationLayer tvisx = jms.getTransitionVisualizer(snet);
					tvisx.Export(out);
				}
				for (JSOSubNet snet : jms.getPetriNet().getAllSubNets())
				{
					JSOPSENEdgeVisualizationLayer evisx = jms.getEdgeVisualizer(snet);
					evisx.Export(out);
				}
			}
			else
			{
				JoglModelScene jms = (JoglModelScene)scene;
				jms.getPetriNet().Export(scene, out);
			}
		}
	}

}
