package org.processmining.processprofiler3d.psen.fileio.xml;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Vector;

public class XMLTag 
{
	private String tagName = "";
	private boolean bClosingTag = false;
	private boolean bClosedTag = false;
	private HashMap<String,String> attrs = new HashMap<String,String>();
	
	public XMLTag(String tName, boolean bClosing, boolean bClosed)
	{
		tagName = tName;
		bClosingTag = bClosing;
		bClosedTag = bClosed;
	}
	
	public boolean getIsClosingTag()
	{
		return bClosingTag;
	}
	
	public boolean getIsClosedTag()
	{
		return bClosedTag;
	}

	public boolean isTagName(String tn)
	{
		return getTagName().equals(tn);
	}
	
	public String getTagName()
	{
		return tagName;
	}
	
	public boolean hasAttribute(String attrName)
	{
		return attrs.containsKey(attrName);
	}
	
	public String getAttribute(String attrName)
	{
		return attrs.get(attrName);
	}
	
	public void setAttribute(String attrName, String value)
	{
		attrs.put(attrName, value);
	}
	
	public static XMLTag ReadFrom(BufferedReader br)
	{
		boolean bInsideTag = false;
		boolean bInsideString = false;
		String aBuffer = "";
		Vector<String> strs = new Vector<String>();
		
		try 
		{
			//String s = br.readLine();
			int ic = br.read();
			while (ic > -1)
			{
				//for (int i = 0; i < s.length(); i++)
				{
					//char c = s.charAt(i);
					char c = (char)ic;
					
					if (!bInsideTag)
					{
						if (Character.isWhitespace(c))
						{
							
						}
						else if (c == '<')
						{
							bInsideTag = true;
						}
					}
					else
					{
						if (!bInsideString)
						{
							if (Character.isWhitespace(c))
							{
								if (aBuffer != "")
								{
									strs.add(aBuffer);
								}
								aBuffer = "";
							}
							else if (c == '"' || c == '\'')
							{
								aBuffer += c;
								bInsideString = true;
							}
							else if (c == '>')
							{
								if (aBuffer != "")
								{
									strs.add(aBuffer);
								}
								aBuffer = "";
								bInsideTag = false;
								return createTag(strs);
							}
							else
							{
								aBuffer += c;
							}
						}
						else
						{
							if (c == '"' || c == '\'')
							{
								bInsideString = false;
							}
							aBuffer += c;
						}
						
					}
				}
				//s = br.readLine();
				ic = br.read();
			}
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}
	
	public static String ReadToNextTag(BufferedReader br)
	{
		boolean bInsideTag = false;
		String aBuffer = "";
		
		try 
		{
			//String s = br.readLine();
			br.mark(1);
			int ic = br.read();
			while (ic > -1)
			{
				//for (int i = 0; i < s.length(); i++)
				{
					//char c = s.charAt(i);
					char c = (char)ic;
					
					if (!bInsideTag)
					{
						if (c == '<')
						{
							br.reset();
							return aBuffer;
						}
						else
						{
							aBuffer += c;
						}
					}
				}
				//s = br.readLine();
				br.mark(1);
				ic = br.read();
			}
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}
	
	private static XMLTag createTag(Vector<String> strs)
	{
		XMLTag tag = null;
		int lastIndex = strs.size() - 1;
		if (strs.get(0).startsWith("/"))
		{
			tag = new XMLTag(strs.get(0).substring(1), true, false);
		}
		else if (strs.get(lastIndex).endsWith("/"))
		{
			String lastText = strs.get(lastIndex).substring(0, strs.get(lastIndex).length() - 1);
			if (lastText == "")
			{
				strs.remove(lastIndex);
			}
			else
			{
				strs.set(lastIndex, lastText);
			}
			tag = new XMLTag(strs.get(0), false, true);
		}
		else
		{
			tag = new XMLTag(strs.get(0), false, false);
		}
		
		//handle tag attributes
		if (tag != null)
		{
			for (int i = 1; i < strs.size(); i++)
			{
				String s = strs.get(i);
				
				for (int j = 0; j < s.length(); j++)
				{
					if (s.charAt(j) == '=')
					{
						String aName = s.substring(0, j);
						String aValue = s.substring(j + 1);
						
						if (aValue.startsWith("\"") && aValue.endsWith("\""))
						{
							aValue = aValue.substring(1, aValue.length() - 1);
						}
						if (aValue.startsWith("'") && aValue.endsWith("'"))
						{
							aValue = aValue.substring(1, aValue.length() - 1);
						}
						
						tag.setAttribute(aName, aValue);
						break;
					}
				}
			}
		}
		return tag;
	}
}
