package org.processmining.processprofiler3d.psen.fileio.xml;

import java.util.Vector;

public class XMLTagNode extends XMLNode
{
	public XMLTagNode parent = null;
	public XMLTag openTag = null;
	public XMLTag closeTag = null;
	public Vector<XMLNode> children = new Vector<XMLNode>();
	
	public XMLTagNode(XMLTag tag)
	{
		openTag = tag;
	}
	
	public boolean isTagName(String tn)
	{
		return getTagName().equals(tn);
	}
	
	public String getTagName()
	{
		if (openTag != null)
		{
			return openTag.getTagName();
		}
		return "";
	}
	
	public boolean hasAttribute(String attrName)
	{
		if (openTag != null)
		{
			return openTag.hasAttribute(attrName);
		}
		return false;
	}
	
	public String getAttribute(String attrName)
	{
		if (openTag != null)
		{
			return openTag.getAttribute(attrName);
		}
		return "";
	}
	
	public boolean isAttributeValue(String attrName, String attrValue)
	{
		if (openTag != null && openTag.hasAttribute(attrName))
		{
			return openTag.getAttribute(attrName).equals(attrValue);
		}
		return false;
	}
}
