package org.processmining.processprofiler3d.psen.fileio.xml;

import java.io.BufferedReader;

public class XMLTree 
{
	public XMLTagNode root = null;
	//public Vector<XMLNode> nodes = new Vector<XMLNode>();
	
	public static String removeWhitespace(String str)
	{
		String s = "";
		for (int i = 0; i < str.length(); i++)
		{
			Character c = str.charAt(i);
			if (!Character.isWhitespace(c))
			{
				s = s + c;
			}
		}
		return s;
	}
	
	public static XMLTree ReadFrom(BufferedReader br)
	{
		XMLTree tree = new XMLTree();
		
		boolean bNotFinished = true;
		
		XMLTagNode parent = null;
		
		while (bNotFinished)
		{
			String s = XMLTag.ReadToNextTag(br);
			String sNWS = removeWhitespace(s);

			if (sNWS != "")
			{
				XMLTextNode tn = new XMLTextNode(s.trim());
				if (parent != null)
				{
					parent.children.add(tn);
				}
			}
			
			XMLTag tag = XMLTag.ReadFrom(br);
			
			if (tag == null)
			{
				return tree;
			}
			
			if (!tag.getIsClosingTag())
			{
				
				XMLTagNode node = new XMLTagNode(tag);
				//tree.nodes.add(node);
				if (tree.root == null)
				{
					tree.root = node;
				}
				
				if (parent != null)
				{
					parent.children.add(node);
				}
				node.parent = parent;
				if (!tag.getIsClosedTag())
				{
					parent = node;
				}
				else
				{
					node.closeTag = tag;
				}
			}
			else
			{
				if (parent != null && tag.isTagName(parent.getTagName()))
				{
					parent.closeTag = tag;
					parent = parent.parent;
				}
			}
			
			if (tag.isTagName("pnml") && tag.getIsClosingTag())
			{
				bNotFinished = false;
			}
		}
		
		return tree;
	}
}
