package org.processmining.processprofiler3d.psen.gui;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.processprofiler3d.psen.preprocess.AddCohortDialog;

import com.fluxicon.slickerbox.components.SlickerButton;

public class AddCohortPane 
{
    public static JOptionPane getOptionPane(JComponent parent) 
    {
        JOptionPane pane = null;
        if (!(parent instanceof JOptionPane)) 
        {
        	Container pparent = parent.getParent();
        	if (pparent instanceof JComponent)
        	{
        		pane = getOptionPane((JComponent)pparent);
        	}
        } 
        else 
        {
            pane = (JOptionPane) parent;
        }
        return pane;
    }
    
    public static JButton getOKButton(JComponent parent) 
    {
    	for (int i = 0; i < parent.getComponentCount(); i++)
    	{
    		Component child = parent.getComponent(i);
    		if (child instanceof JButton)
    		{
    			JButton btn = (JButton)child;
    			if (btn.getText().equals("OK"))
    			{
    				return btn;
    			}
    		}
    		else if (child instanceof JComponent)
    		{
    			JComponent jchild = (JComponent)child;
    			JButton btn = getOKButton(jchild);
    			if (btn != null)
    			{
    				return btn;
    			}
    		}
    	}
        return null;
    }
    
    public static JButton getCancelButton(JComponent parent) 
    {
    	for (int i = 0; i < parent.getComponentCount(); i++)
    	{
    		Component child = parent.getComponent(i);
    		if (child instanceof JButton)
    		{
    			JButton btn = (JButton)child;
    			if (btn.getText().equals("Cancel"))
    			{
    				return btn;
    			}
    		}
    		else if (child instanceof JComponent)
    		{
    			JComponent jchild = (JComponent)child;
    			JButton btn = getCancelButton(jchild);
    			if (btn != null)
    			{
    				return btn;
    			}
    		}
    	}
        return null;
    }

	public static int showDialog(UIPluginContext context, Object message)
	{
//		final JButton jButton = new SlickerButton("OK");
//		jButton.addActionListener(new ActionListener() 
//		{
//            @Override
//            public void actionPerformed(ActionEvent e) 
//            {
//                JOptionPane pane = getOptionPane((JComponent)e.getSource());
//                pane.setValue(jButton);
//            }
//        });
//		
//		final JButton jButton2 = new SlickerButton("Cancel");
//		jButton2.addActionListener(new ActionListener() 
//		{
//            @Override
//            public void actionPerformed(ActionEvent e) 
//            {
//                JOptionPane pane = getOptionPane((JComponent)e.getSource());
//                pane.setValue(jButton2);
//            }
//        });
//		
//	    return JOptionPane.showOptionDialog(null, message, "Add Classifier Cohort", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null, new Object[] { jButton, jButton2 }, null);
		AddCohortDialog acd = new AddCohortDialog("Add Classifier Cohort", (JPanel)message);
		return acd.ShowDialog(context);
	}

	public static int showDialog(Object message)
	{
		final JButton jButton = new SlickerButton("OK");
		jButton.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) 
            {
                JOptionPane pane = getOptionPane((JComponent)e.getSource());
                pane.setValue(jButton);
            }
        });
		
		final JButton jButton2 = new SlickerButton("Cancel");
		jButton2.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) 
            {
                JOptionPane pane = getOptionPane((JComponent)e.getSource());
                pane.setValue(jButton2);
            }
        });
		
	    return JOptionPane.showOptionDialog(null, message, "Add Classifier Cohort", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null, new Object[] { jButton, jButton2 }, null);
//		AddCohortDialog acd = new AddCohortDialog("Add Classifier Cohort", (JPanel)message);
//		return acd.ShowDialog(context);
	}

	public static int showDialog(Object message, String title)
	{
		final JButton jButton = new SlickerButton("OK");
		jButton.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) 
            {
                JOptionPane pane = getOptionPane((JComponent)e.getSource());
                pane.setValue(jButton);
            }
        });
		
		final JButton jButton2 = new SlickerButton("Cancel");
		jButton2.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) 
            {
                JOptionPane pane = getOptionPane((JComponent)e.getSource());
                pane.setValue(jButton2);
            }
        });
		
	    return JOptionPane.showOptionDialog(null, message, title, JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null, new Object[] { jButton, jButton2 }, null);
//		AddCohortDialog acd = new AddCohortDialog("Add Classifier Cohort", (JPanel)message);
//		return acd.ShowDialog(context);
	}

	public static int showDialog(UIPluginContext context, String title, Object message)
	{
//		final JButton jButton = new SlickerButton("OK");
//		jButton.addActionListener(new ActionListener() 
//		{
//            @Override
//            public void actionPerformed(ActionEvent e) 
//            {
//                JOptionPane pane = getOptionPane((JComponent)e.getSource());
//                pane.setValue(jButton);
//            }
//        });
//		
//		final JButton jButton2 = new SlickerButton("Cancel");
//		jButton2.addActionListener(new ActionListener() 
//		{
//            @Override
//            public void actionPerformed(ActionEvent e) 
//            {
//                JOptionPane pane = getOptionPane((JComponent)e.getSource());
//                pane.setValue(jButton2);
//            }
//        });
//		
//	    return JOptionPane.showOptionDialog(null, message, title, JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null, new Object[] { jButton, jButton2 }, null);  
		AddCohortDialog acd = new AddCohortDialog(title, (JPanel)message);
		return acd.ShowDialog(context);
	}
}
