package org.processmining.processprofiler3d.psen.gui;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;
import org.processmining.processprofiler3d.psen.classification.ClassificationCohortLiteral;
import org.processmining.processprofiler3d.psen.classification.ClassificationCohortTimeOfDay;
import org.processmining.processprofiler3d.psen.classification.CohortClassifier;
import org.processmining.processprofiler3d.psen.classification.CohortPreset;

public class CohortConfigurationStep implements ProMWizardStep<CohortClassifier>
{
	private XLog log;
	public static String classifierType = "";
	
	public CohortConfigurationStep(XLog l)
	{
		log = l;
	}
	
	public String getTitle() 
	{
		return "Setup Classifiers";
	}

	public JComponent getComponent(CohortClassifier model) 
	{
		PSENClassifierConfigPanel panel = new PSENClassifierConfigPanel(log);
		
		return panel;
	}

	public boolean canApply(CohortClassifier model, JComponent component) 
	{
		return true;
	}

	public CohortClassifier apply(CohortClassifier model, JComponent component) 
	{
		PSENClassifierConfigPanel panel = (PSENClassifierConfigPanel)component;
		classifierType = panel.getSelectedClassifierType();
		
		CohortClassifier cc = panel.getClassifier();

		if (panel.getSelectedPreset() != "None")
		{
			CohortPreset preset = null;
			if (panel.getSelectedClassifierType().equals(ClassificationCohortTimeOfDay.classifierName))
			{
				preset = CohortClassifier.getPreset(panel.getSelectedPreset(), panel.getSelectedAttribute(), log);
			}
			else if (panel.getSelectedClassifierType().equals(ClassificationCohortLiteral.classifierName))
			{
				preset = CohortClassifier.getPreset(panel.getSelectedPreset(), panel.getSelectedAttribute(), log);
			}
			
			if (preset != null)
			{
				cc.setPreset(preset);
			}
		}
		
		return cc;
	}

}
