package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;
import org.processmining.processprofiler3d.psen.classification.CohortClassifier;

public class CohortConfigurationStep2 implements ProMWizardStep<CohortClassifier>
{
	private XLog log;
	private UIPluginContext context; 
	
	public CohortConfigurationStep2(XLog l)
	{
		log = l;
	}
	
	public String getTitle() 
	{
		return "Configure Classifier Cohorts";
	}

	public JComponent getComponent(CohortClassifier model) 
	{
		//JComponent panel = model.getConfigureComponent();

		PSENCohortConfigPanel panel = new PSENCohortConfigPanel(log, model, CohortConfigurationStep.classifierType);		
		panel.setPreferredSize(new Dimension(1000,500));
		
		//return ccp;
		
		return panel;
	}

	public boolean canApply(CohortClassifier model, JComponent component) 
	{
		return (model.getNumCohorts() >= 2);
	}

	public CohortClassifier apply(CohortClassifier model, JComponent component) 
	{
		//PSENCohortConfigPanel panel = (PSENCohortConfigPanel)component;
		
		return model;
	}

}
