package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.UIManager;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import org.deckfour.uitopia.ui.overlay.AbstractOverlayDialog;

public class MarkingWarningDialog extends ProMUIOverlay
{	
	private String myText;
	private JButton yesButton;
	private JButton noButton;
	
	public MarkingWarningDialog(String text)
	{
		this.myText = text;
		this.overlayTitle = "Warning:";
		
		this.overlayWidth = 500;
		this.overlayHeight = 225;
	}
	
	public MarkingWarningDialog(String text, String title)
	{
		this.myText = text;
		this.overlayTitle = title;
		
		this.overlayWidth = 500;
		this.overlayHeight = 225;
	}
	
	@Override
	public void actionPerformed(ActionEvent e)
	{
    	//GetUIHierarchy((JComponent)e.getSource());
    	
		if (e.getSource() == yesButton)
		{
			interactionResult = JOptionPane.YES_OPTION;
		}
		if (e.getSource() == noButton)
		{
			interactionResult = JOptionPane.NO_OPTION;
		}
    	CloseDialog();

    	String s = "";
    	s = "";
	}
	
	@Override
	protected JComponent CreateContentPanel()
	{
		JPanel listPane = new JPanel();
		listPane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		listPane.setBackground(ProMUIColors.BACKGROUND_GRAY);
		//listPane.setBackground(new Color(255,0,0));
		listPane.setMinimumSize(new Dimension(500, 60));
		listPane.setPreferredSize(new Dimension(600, 60));
		listPane.setMaximumSize(new Dimension(600, 100));
		listPane.setLayout(new BoxLayout(listPane, BoxLayout.LINE_AXIS));
		
		Icon icon = UIManager.getIcon("OptionPane.questionIcon");
		JLabel iconLbl = new JLabel("", icon, JLabel.LEFT);
		//iconLbl.setMinimumSize(new Dimension(100, 40));
		//iconLbl.setMaximumSize(new Dimension(100, 40));
		iconLbl.setAlignmentX(0.0f);

		JLabel textLbl2 = new JLabel(myText); //HACK!!!
		Font fnt = textLbl2.getFont().deriveFont(14.0f);		
		
		JTextPane textLbl = new JTextPane();
		StyledDocument doc = textLbl.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		try
		{
			doc.insertString(0, myText, center);
		}
		catch (BadLocationException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		
		textLbl.setBackground(ProMUIColors.BACKGROUND_GRAY);
		//textLbl.setBackground(new Color(255,0,0));
		textLbl.setFont(fnt);
		textLbl.setBorder(BorderFactory.createEmptyBorder());
		
		
		listPane.add(iconLbl);
		listPane.add(Box.createHorizontalGlue());
		listPane.add(textLbl);
		listPane.add(Box.createHorizontalGlue());
		listPane.add(Box.createRigidArea(new Dimension(40, 40)));
//		listPane.add(new JLabel("Max Trace Fitness: " + maxTraceFitness));
//		listPane.add(new JLabel("Avg Trace Fitness: " + avgTraceFitness));
		
		return listPane;
	}
	
	@Override
	protected AbstractOverlayDialog CreateDialog()
	{
		JComponent content = CreateContentPanel();
		
		YesNoOverlayDialog afd = new YesNoOverlayDialog(overlayTitle, content);
		yesButton = afd.getYesButton();
		noButton = afd.getNoButton();
		
		yesButton.addActionListener(this);
		noButton.addActionListener(this);
		
		return afd;
	}

}
