package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;

public class OkayCancelOverlayDialog extends ProMOverlayDialog
{
	private JButton yesButton;
	private JButton noButton;
	private JPanel cpanel;
	
	public OkayCancelOverlayDialog(String title, JComponent content)
	{
		super(title);

		this.titleFontSize = 18.0f;
		
		BoxLayout blayout = new BoxLayout(this, BoxLayout.Y_AXIS);
		this.setBorder(BorderFactory.createEmptyBorder(borderWidth, borderWidth, borderWidth, borderWidth));
		this.add(Box.createVerticalStrut(titleBarHeight));
		this.setOpaque(false);
		this.setLayout(blayout);
		
		cpanel = new JPanel();
		
		cpanel.setMinimumSize(new Dimension(50,50));
		cpanel.setMaximumSize(new Dimension(1000,500));
		cpanel.setAlignmentX(0.5f);
		//cpanel.setBackground(WidgetColors.COLOR_LIST_BG);
		cpanel.setBackground(ProMUIColors.BACKGROUND_GRAY);
		
		cpanel.add(content);
		
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new BoxLayout(btnPanel, BoxLayout.X_AXIS));
		btnPanel.setBackground(ProMUIColors.BACKGROUND_GRAY);
		
		yesButton = ProMButtonFactory.createGreenButton(ProMButtonFactory.ButtonType_OK, "Okay");
		yesButton.setMinimumSize(new Dimension(98, 40));
		yesButton.setMaximumSize(new Dimension(100, 40));
		yesButton.setSize(100, 40);
		yesButton.setAlignmentX(0.5f);
		
		noButton = ProMButtonFactory.createRedButton(ProMButtonFactory.ButtonType_Cancel, "Cancel");
		noButton.setMinimumSize(new Dimension(98, 40));
		noButton.setMaximumSize(new Dimension(100, 40));
		noButton.setSize(100, 40);
		noButton.setAlignmentX(0.5f);

		Font fnt = yesButton.getFont().deriveFont(14.0f);
		yesButton.setFont(fnt);
		noButton.setFont(fnt);
		
		btnPanel.add(noButton);
		btnPanel.add(Box.createRigidArea(new Dimension(10, 40)));
		btnPanel.add(yesButton);

		this.add(cpanel);
		this.add(Box.createVerticalStrut(10));
		this.add(btnPanel);
		this.add(Box.createVerticalStrut(10));
	}
	
	public JButton getYesButton()
	{
		return yesButton;
	}
	
	public JButton getNoButton()
	{
		return noButton;
	}
}
