package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class OneButtonOverlayDialog extends ProMOverlayDialog
{
	private JButton myButton;
	private JPanel cpanel;
	
	public OneButtonOverlayDialog(String title, JComponent content, int messageType)
	{
		super(title);

		this.titleFontSize = 18.0f;
		
		BoxLayout blayout = new BoxLayout(this, BoxLayout.Y_AXIS);
		this.setBorder(BorderFactory.createEmptyBorder(borderWidth, borderWidth, borderWidth, borderWidth));
		this.add(Box.createVerticalStrut(titleBarHeight));
		this.setOpaque(false);
		this.setLayout(blayout);
		
		cpanel = new JPanel();
		
		cpanel.setMinimumSize(new Dimension(50,50));
		cpanel.setMaximumSize(new Dimension(1000,500));
		cpanel.setAlignmentX(0.5f);
		//cpanel.setBackground(WidgetColors.COLOR_LIST_BG);
		cpanel.setBackground(ProMUIColors.BACKGROUND_GRAY);
		
		cpanel.add(content);
		
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new BoxLayout(btnPanel, BoxLayout.X_AXIS));
		btnPanel.setBackground(ProMUIColors.BACKGROUND_GRAY);
		
		if (messageType == JOptionPane.PLAIN_MESSAGE || messageType == JOptionPane.INFORMATION_MESSAGE || messageType == JOptionPane.QUESTION_MESSAGE || messageType == JOptionPane.WARNING_MESSAGE)
		{
			myButton = ProMButtonFactory.createGreenButton(ProMButtonFactory.ButtonType_OK, "Okay");
		}
		else
		{
			myButton = ProMButtonFactory.createRedButton(ProMButtonFactory.ButtonType_Cancel, "Okay");
		}
		
		myButton.setMinimumSize(new Dimension(98, 40));
		myButton.setMaximumSize(new Dimension(100, 40));
		myButton.setSize(100, 40);
		myButton.setAlignmentX(0.5f);

		Font fnt = myButton.getFont().deriveFont(14.0f);
		myButton.setFont(fnt);
		
		btnPanel.add(myButton);

		this.add(cpanel);
		this.add(Box.createVerticalStrut(10));
		this.add(btnPanel);
		this.add(Box.createVerticalStrut(10));
	}
	
	public JButton getButton()
	{
		return myButton;
	}
}
