package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.List;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JPanel;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.processprofiler3d.psen.classification.CohortClassifier;

import com.fluxicon.slickerbox.components.SlickerButton;

public class PSENCohortConfigPanel extends ProMPropertiesPanel implements ActionListener, MouseListener
{
	private static final long serialVersionUID = 3081495994837953427L;

	private XLog log;
	private CohortClassifier classifier = null;
	
	private ProMList<String> lst;
	private DefaultListModel<String> lm;
	
	private JButton btnAdd;
	private JButton btnEdit;
	private JButton btnRemove;
	
	private String classifierType = "";
	
	public List<String> getSelectedItems()
	{
		return lst.getSelectedValuesList();
	}
	
	public PSENCohortConfigPanel( XLog log, CohortClassifier cc, String cType) 
	{
		super("Classifier Cohort Configuration");
		
		classifier = cc;
		classifierType = cType;
		this.log = log;
		
		Vector<String> l = classifier.getCohortNames();
		
		lm = new DefaultListModel<String>();
		for (String s : l)
		{
			lm.addElement(s);
		}
		
		lst = new ProMList<String>("Classifier Cohorts", lm);
		lst.setPreferredSize(new Dimension(800, 500));
		lst.addMouseListener(this);
		
		add(lst);
		
		JPanel panel = new JPanel();
		BoxLayout layout = new BoxLayout(panel, BoxLayout.X_AXIS);
		panel.setLayout(layout);
		panel.setBackground(this.getBackground());
		
		btnAdd = new SlickerButton("Add");
		btnAdd.addActionListener(this);
		
		panel.add(btnAdd);

		btnEdit = new SlickerButton("Edit");
		btnEdit.addActionListener(this);
		
		panel.add(btnEdit);
		
		btnRemove = new SlickerButton("Remove");
		btnRemove.addActionListener(this);
		
		panel.add(btnRemove);
		
		add(panel);
	}

	public void actionPerformed(ActionEvent aEvent) 
	{
		if (aEvent.getSource() == btnAdd)
		{
//			if (classifierType.equals(ClassificationCohortTimeOfDay.classifierName))
//			{
//				PSENAddTimeOfDayCohortPanel.showDialog(classifier, log);
//			}
//			else if (classifierType.equals(ClassificationCohortLiteral.classifierName))
//			{
//				PSENAddGenericLiteralCohortPanel.showDialog(classifier, log);
//			}
//			else if (classifierType.equals(ClassificationCohortIntRange.classifierName))
//			{
//				PSENAddIntRangeCohortPanel.showDialog(classifier, log);
//			}
			PSENAddGenericCohortPanel.showDialog(classifier, log);
		}
		else if (aEvent.getSource() == btnEdit)
		{
			editHelper();
		}
		else if (aEvent.getSource() == btnRemove)
		{
			removeHelper();
		}

		//update contents of list
		lm.removeAllElements();
		for (String s : classifier.getCohortNames())
		{
			lm.addElement(s);
		}
		lst.invalidate();
		lst.validate();
		lst.repaint();
	}
	
	private void editHelper()
	{
		List<String> lst = getSelectedItems();
		for (String s : lst)
		{
			//classifier.removeCohort(s);
		}
	}
	
	private void removeHelper()
	{
		List<String> lst = getSelectedItems();
		for (String s : lst)
		{
			classifier.removeCohort(s);
		}
	}

	public void mouseClicked(MouseEvent arg0) 
	{
		// TODO Auto-generated method stub
		if (arg0.getButton() == MouseEvent.BUTTON1)
		{
			
		}
	}

	public void mouseEntered(MouseEvent arg0) 
	{
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent arg0) 
	{
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent arg0) 
	{
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent arg0) 
	{
		// TODO Auto-generated method stub
		
	}
	

}
