package org.processmining.processprofiler3d.psen.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.UIManager;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import org.deckfour.uitopia.ui.overlay.AbstractOverlayDialog;

public class ProMMessageDialog extends ProMUIOverlay
{	
	private int messageType = 0;
	private String myText;
	private JButton myButton;
	
	public ProMMessageDialog(String text, int messageType)
	{
		this.messageType = messageType;
		this.myText = text;
		this.overlayTitle = "Warning:";
		
		this.overlayWidth = 500;
		this.overlayHeight = 225;
	}
	
	public ProMMessageDialog(String text, String title, int messageType)
	{
		this.messageType = messageType;
		this.myText = text;
		this.overlayTitle = title;
		
		this.overlayWidth = 500;
		this.overlayHeight = 225;
	}
	
	@Override
	public void actionPerformed(ActionEvent e)
	{
    	//GetUIHierarchy((JComponent)e.getSource());
    	
		if (e.getSource() == myButton)
		{
			interactionResult = JOptionPane.YES_OPTION;
		}
    	CloseDialog();

    	String s = "";
    	s = "";
	}
	
	@Override
	protected JComponent CreateContentPanel()
	{
		JPanel listPane = new JPanel();
		listPane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		listPane.setBackground(ProMUIColors.BACKGROUND_GRAY);
		//listPane.setBackground(new Color(255,0,0));
		listPane.setMinimumSize(new Dimension(500, 60));
		listPane.setPreferredSize(new Dimension(600, 60));
		listPane.setMaximumSize(new Dimension(600, 100));
		listPane.setLayout(new BoxLayout(listPane, BoxLayout.LINE_AXIS));
		
		Icon icon = null;
		if (messageType == JOptionPane.QUESTION_MESSAGE)
		{
			icon = UIManager.getIcon("OptionPane.questionIcon");
		}
		else if (messageType == JOptionPane.WARNING_MESSAGE)
		{
			icon = UIManager.getIcon("OptionPane.warningIcon");
		}
		else if (messageType == JOptionPane.INFORMATION_MESSAGE)
		{
			icon = UIManager.getIcon("OptionPane.informationIcon");
		}
		else if (messageType == JOptionPane.ERROR_MESSAGE)
		{
			icon = UIManager.getIcon("OptionPane.errorIcon");
		}
		
		JLabel textLbl2 = new JLabel(myText); //HACK!!!
		Font fnt = textLbl2.getFont().deriveFont(14.0f);
		
		JTextPane textLbl = new JTextPane();
		StyledDocument doc = textLbl.getStyledDocument();
		SimpleAttributeSet center = new SimpleAttributeSet();
		
		StyleConstants.setAlignment(center, StyleConstants.ALIGN_CENTER);
		try
		{
			doc.insertString(0, myText, center);
		}
		catch (BadLocationException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		doc.setParagraphAttributes(0, doc.getLength(), center, false);
		textLbl.setBackground(ProMUIColors.BACKGROUND_GRAY);
		//textLbl.setBackground(new Color(255,0,0));
		textLbl.setFont(fnt);
		textLbl.setBorder(BorderFactory.createEmptyBorder());
		
		if (icon != null)
		{
			JLabel iconLbl = new JLabel("", icon, JLabel.LEFT);
			//iconLbl.setMinimumSize(new Dimension(100, 40));
			//iconLbl.setMaximumSize(new Dimension(100, 40));
			iconLbl.setAlignmentX(0.0f);
			
			listPane.add(iconLbl);
		}
		else
		{
			listPane.add(Box.createRigidArea(new Dimension(40, 40)));
		}
		listPane.add(Box.createHorizontalGlue());
		listPane.add(textLbl);
		listPane.add(Box.createHorizontalGlue());
		listPane.add(Box.createRigidArea(new Dimension(40, 40)));
//		listPane.add(new JLabel("Max Trace Fitness: " + maxTraceFitness));
//		listPane.add(new JLabel("Avg Trace Fitness: " + avgTraceFitness));
		
		return listPane;
	}
	
	@Override
	protected AbstractOverlayDialog CreateDialog()
	{
		JComponent content = CreateContentPanel();
		
		OneButtonOverlayDialog afd = new OneButtonOverlayDialog(overlayTitle, content, messageType);
		myButton = afd.getButton();
		
		myButton.addActionListener(this);
		
		return afd;
	}

}
