package org.processmining.processprofiler3d.psen.gui;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.RoundRectangle2D;
import java.awt.image.BufferedImage;

import org.deckfour.uitopia.ui.overlay.AbstractOverlayDialog;

import com.fluxicon.slickerbox.util.GraphicsUtilities;

public class ProMOverlayDialog extends AbstractOverlayDialog
{
	protected int borderWidth = 20;
	protected float cornerInnerRadius = 30.0f;
	protected float cornerOuterRadius = 60.0f;
	protected int titleBarHeight = 60;

	protected Color HEADER_COLOR = new Color(40,40,40);
	protected Color BODY_COLOR = new Color(150,150,150);
	protected Color TITLE_COLOR = new Color(150,150,150);
	
	protected String title = "Test";
	protected float titleFontSize = 22.0f;
	protected int titleFontStyle = Font.BOLD;

	public ProMOverlayDialog(String title)
	{
		super(title);
		this.title = title;
	}
	
	@Override
	public void paintComponent(Graphics g)
	{
		int width = getWidth();
		int height = getHeight();
		
		Graphics2D g2d = (Graphics2D)g.create();
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		RoundRectangle2D.Float round = new RoundRectangle2D.Float(1.0f, 1.0f, (float)(width-2), (float)(height-2), cornerOuterRadius, cornerOuterRadius);
		
		g2d.setColor(new Color(0, 0, 0, 160));
		g2d.fill(round);
		
		BufferedImage buffer = GraphicsUtilities.createTranslucentCompatibleImage(width, height);
		Graphics2D b2d = buffer.createGraphics();
		
		b2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		b2d.setComposite(AlphaComposite.Clear);
		b2d.fillRect(0, 0, width, height);
		b2d.setComposite(AlphaComposite.Src);
		
		b2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		b2d.setColor(Color.WHITE);
		
		round = new RoundRectangle2D.Float(borderWidth, borderWidth, (float)(width - (borderWidth * 2)), (float)(height - (borderWidth * 2)), cornerInnerRadius, cornerInnerRadius);
		b2d.fill(round);
		b2d.setComposite(AlphaComposite.SrcAtop);

		b2d.setColor(HEADER_COLOR);
		b2d.fillRect(0, 0, width, borderWidth + titleBarHeight);
		
		b2d.setColor(BODY_COLOR);
		b2d.fillRect(0, borderWidth + titleBarHeight, width, height - (borderWidth + titleBarHeight));
		
		b2d.setPaint(new GradientPaint((float)(width - 160), 0.0f, TITLE_COLOR, (float)(width - 120), 0.0f, HEADER_COLOR));
		
		b2d.setFont(g2d.getFont().deriveFont(titleFontSize).deriveFont(titleFontStyle));
		b2d.drawString(title, 40, 58);
		
		b2d.dispose();
		
		g2d.drawImage(buffer, 0, 0, null);
		
		g2d.dispose();
		
	}

}
