package org.processmining.processprofiler3d.psen.plugins;


import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.processprofiler3d.psen.preprocess.LPPAction;
import org.processmining.processprofiler3d.psen.preprocess.PreprocessMenuPanel;


/*
 * This is the entry class of the comparative visualisation plug-in.
 * */
public class ModelComparisonPreprocess 
{
	@Plugin(
		name = "Process Profiler 3D: Log Preprocessing", 
		parameterLabels = { "Event Log"}, 
		returnLabels = { "Preprocessed Event Log" }, 
		returnTypes = { XLog.class}, 
		userAccessible = true, 
		help = "This plug-in preprocesses a log to compare the differences between different process models"
	)
	@UITopiaVariant(
		affiliation = "Queensland University of Technology", 
		author = "Erik Poppe", 
		email = "erik.poppe@qut.edu.au"
	)

	
	public XLog replayALog(final UIPluginContext context, XLog log)
	{	
		XLog newLog = log;
		
		newLog = PreprocessMenuPanel.showDialog(context, newLog);
		
		if (newLog == null)
		{
			context.getFutureResult(0).cancel(true);
		}
		else
		{
			String logName = LPPAction.getAttributeValueLiteral(newLog, XConceptExtension.KEY_NAME);
			if (logName != null)
			{
			    context.getFutureResult(0).setLabel(logName);
			}
		}
		return newLog;
	}
		
	
	
}
