package org.processmining.processprofiler3d.psen.plugins;


import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.processprofiler3d.psen.gui.TransitionVisConfigPanel;


/*
 * This is the entry class of the comparative visualisation plug-in.
 * */
public class ModelTransitionVisHierarchical
{
	@Plugin(
		name = "Process Profiler 3D: Configure Transition Visibility for Hierarchical Net", 
		parameterLabels = { "Petri Net"}, 
		returnLabels = { "Petri Net" }, 
		returnTypes = { Petrinet.class}, 
		userAccessible = true, 
		help = "This plug-in configures the visibility of transitions for hierarchical petri nets."
	)
	@UITopiaVariant(
		affiliation = "Queensland University of Technology", 
		author = "Erik Poppe", 
		email = "erik.poppe@qut.edu.au"
	)
	
	public Petrinet replayALog(final UIPluginContext context, Petrinet hierarchicalNet) 
	{
		TransitionVisConfigPanel panel = new TransitionVisConfigPanel(hierarchicalNet);		
		context.showConfiguration("Configure Transition Visibility", panel);

		return null;
	}
}
