package org.processmining.processprofiler3d.psen.preprocess;

import java.util.Date;

import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;

public class LPPCheckEventOrdering extends LPPAction 
{
	@Override
	public XLog execute(final UIPluginContext context, XLog log)
	{	
		boolean bOrdered = true;
		
		//for each trace
		for (XTrace trace : log)
		{
			Date lastDate = new Date(0);
			//for each event in trace
			for (XEvent event : trace)
			{
				Date eventTime = getAttributeValueTimestamp(event, XTimeExtension.KEY_TIMESTAMP);
				
				if (lastDate.getTime() > eventTime.getTime())
				{
					System.out.println("Trace events not ordered!");
					bOrdered = false;
					break;
				}
				
				lastDate = eventTime;
			}
		}
		
		if (bOrdered)
		{
			System.out.println("All traces are ordered correctly.");
		}
		else
		{
			System.out.println("Not all traces are ordered correctly.");
		}
		
		
		return log;
	}
}
