package org.processmining.processprofiler3d.psen.preprocess;

import java.util.Vector;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;

public class LogPreprocessor 
{
	public static XLog promoteEventAttributes(final UIPluginContext context, XLog log)
	{	
		return new LPPPromoteEventAttributes().execute(context, log);
	}
	
	public static XLog addTimingAttributes(final UIPluginContext context, XLog log)
	{	
		return new LPPAddCaseTimingAttributes().execute(context, log);
	}
	
	public static XLog addCohortAttribute(final UIPluginContext context, XLog log)
	{	
		return new LPPAddCaseCohortAttribute().execute(context, log);
	}
	
	public static XLog removeEventAttributes(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveEventAttributes().execute(context, log);
	}
	
	public static XLog removeEventAttributes(final UIPluginContext context, XLog log, Vector<String> remAttrs)
	{	
		return new LPPRemoveEventAttributes().execute(context, log, remAttrs);
	}
	
	public static XLog removeTraceAttributes(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveTraceAttributes().execute(context, log);
	}
	
	public static XLog removeTraceAttributes(final UIPluginContext context, XLog log, Vector<String> remAttrs)
	{	
		return new LPPRemoveTraceAttributes().execute(context, log, remAttrs);
	}
	
	public static XLog removeEventsByAttribute(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveEventsByAttribute().execute(context, log);
	}
	
	public static XLog removeEventsByLifecycle(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveEventsByLifecycle().execute(context, log);
	}
	
	public static XLog removeTracesByAttribute(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveTracesByAttribute().execute(context, log);
	}
	
	public static XLog mergeLifecycleEvents(final UIPluginContext context, XLog log)
	{	
		return new LPPRemoveEventsByLifecycle().execute(context, log);
	}
	
	public static XLog checkEventOrdering(final UIPluginContext context, XLog log)
	{	
		return new LPPCheckEventOrdering().execute(context, log);
	}

	public static XLog renameEvents(final UIPluginContext context, XLog log)
	{	
		return new LPPRenameEvents().execute(context, log);
	}

	public static XLog sortEvents(final UIPluginContext context, XLog log)
	{	
		return new LPPSortEvents().execute(context, log);
	}
}
