package org.processmining.processprofiler3d.psen.preprocess;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.processprofiler3d.psen.gui.AddCohortPane;

import com.fluxicon.slickerbox.components.SlickerButton;

public class PreprocessSelectAttributesPanel  extends ProMPropertiesPanel implements ActionListener
{
	private static final long serialVersionUID = 2643942608122666179L;

	private ProMTextField name;
	
	private ProMList<String> lst;
	private DefaultListModel<String> lm;
	
	private ProMList<String> lst2;
	private DefaultListModel<String> lm2;
	
	private SlickerButton btn;
	private SlickerButton btn2;

	public static Vector<String> showDialog(final UIPluginContext context, String title, Vector<String> availableValues)
	{
		PreprocessSelectAttributesPanel glcp = new PreprocessSelectAttributesPanel(title, availableValues);

	    int result = AddCohortPane.showDialog(context, title, glcp);
		
	    if (result == JOptionPane.OK_OPTION)
	    {
	    	return glcp.getSelectedValues();
	    }
	    return new Vector<String>();
	}
	
	public Vector<String> getSelectedValues()
	{	
    	Vector<String> vals = new Vector<String>();
    	for (int i = 0; i < lm2.size(); i++)
    	{
    		vals.add(lm2.get(i));
    	}
    	
		return vals;
	}
	
	public PreprocessSelectAttributesPanel(String title, Vector<String> availableValues) 
	{
		super(title);
		
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setBackground(this.getBackground());
		
		JPanel panel = new JPanel();
		
		BoxLayout layout = new BoxLayout(panel, BoxLayout.X_AXIS);
		
		panel.setLayout(layout);
		panel.setBackground(this.getBackground());
		
		lm = new DefaultListModel<String>();
//		for (String s : availableValues)
//		{
//			lm.addElement(s);
//		}
		
		lst = new ProMList<String>("Available Values", lm);
		lst.setPreferredSize(new Dimension(200, 500));
		
		panel.add(lst);

		JPanel panel2 = new JPanel();
		BoxLayout layout2 = new BoxLayout(panel2, BoxLayout.Y_AXIS);
		panel2.setLayout(layout2);
		panel2.setBackground(this.getBackground());
		
	    btn = new SlickerButton("Add");
	    btn.addActionListener(this);
	    panel2.add(btn);
	    
	    btn2 = new SlickerButton("Remove");
	    btn2.addActionListener(this);
	    panel2.add(btn2);
	    
	    panel.add(panel2);

		lm2 = new DefaultListModel<String>();
		for (String s : availableValues)
		{
			lm2.addElement(s);
		}
		
		lst2 = new ProMList<String>("Selected Values", lm2);
		lst2.setPreferredSize(new Dimension(200, 500));
		
		panel.add(lst2);
	    
	    add(panel);
	    
	    setPreferredSize(new Dimension(800,600));
	}

	public void actionPerformed(ActionEvent arg0) 
	{
		//add button pressed
		if (arg0.getSource() == btn)
		{
			addPressed();
		}
		//remove button pressed
		else if (arg0.getSource() == btn2)
		{
			removePressed();
		}
	}
	
	private void addPressed()
	{
		List<String> vals = lst.getSelectedValuesList();

		for (String s : vals)
		{
			lm.removeElement(s);
		}
		lst.invalidate();
		lst.validate();
		lst.repaint();
		
		//update contents of list
		//lm2.removeAllElements();
		for (String s : vals)
		{
			lm2.addElement(s);
		}
		lst2.invalidate();
		lst2.validate();
		lst2.repaint();
	}
	
	private void removePressed()
	{
		List<String> vals = lst2.getSelectedValuesList();

		for (String s : vals)
		{
			lm2.removeElement(s);
		}
		lst2.invalidate();
		lst2.validate();
		lst2.repaint();
		
		//update contents of list
		//lm.removeAllElements();
		for (String s : vals)
		{
			lm.addElement(s);
		}
		lst.invalidate();
		lst.validate();
		lst.repaint();
	}

}
