package org.processmining.processprofiler3d.psen.replayanalysis;

import java.util.Map;

import org.processmining.plugins.petrinet.replayresult.StepTypes;
import org.processmining.plugins.replayer.replayresult.SyncReplayResult;

public class ReplayResultWrapper implements IReplayResultWrapper 
{
	private SyncReplayResult syncRepRes;
	
	public ReplayResultWrapper(SyncReplayResult syncRepRes)
	{
		this.syncRepRes = syncRepRes;
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.IReplayResultWrapper#isReliable()
	 */
	@Override
	public boolean isReliable()
	{
		return syncRepRes.isReliable();
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.IReplayResultWrapper#getInfo()
	 */
	@Override
	public Map<String, Double> getInfo()
	{
		return syncRepRes.getInfo();
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.IReplayResultWrapper#getStepCount()
	 */
	@Override
	public int getStepCount()
	{
		return syncRepRes.getStepTypes().size();
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.IReplayResultWrapper#getStepType(int)
	 */
	@Override
	public StepTypes getStepType(int i)
	{
		return syncRepRes.getStepTypes().get(i);
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.IReplayResultWrapper#getNodeInstance(int)
	 */
	@Override
	public Object getNodeInstance(int i)
	{
		return syncRepRes.getNodeInstance().get(i);
	}
}
