package org.processmining.processprofiler3d.psen.replayanalysis;

import java.util.Collections;
import java.util.Date;
import java.util.Vector;

public class TimePeriod
{	
    public long start;
    public long end;

	public TimePeriod(long s, long e)
	{
        if (s < e)
        {
            start = s;
            end = e;
        }
        else
        {
            start = e;
            end = s;
        }
	}
	
	public TimePeriod(Date s, Date e)
	{
        if (s.getTime() < e.getTime())
        {
            start = s.getTime();
            end = e.getTime();
        }
        else
        {
            start = e.getTime();
            end = s.getTime();
        }
	}

    public boolean Contains(Date i)
    {
        return (start < i.getTime() && i.getTime() < end);
    }

    public boolean IsEmpty()
    {
        return (start == end);
    }

    public TimeSpan getTimeSpan()
    {
        return new TimeSpan(start, end);
    }

    public static TimePeriod Merge(TimePeriod a, TimePeriod b)
    {
        if (Overlap(a, b) || Connect(a, b))
        {
            Vector<Long> inst = new Vector<Long>();
            inst.add(a.start);
            inst.add(a.end);
            inst.add(b.start);
            inst.add(a.end);

            //inst.sort();
            Collections.sort(inst);

            return new TimePeriod(inst.get(0), inst.get(3));
        }
        return null;
    }

    public static boolean Connect(TimePeriod p1, TimePeriod p2)
    {
        return ((p1.start == p2.start) || (p1.start == p2.end) || (p1.end == p2.end));
    }

    public static boolean Overlap(TimePeriod p1, TimePeriod p2)
    {
        if (p1.end < p2.start)
        {
            return false;
        }
        else if (p2.end < p1.start)
        {
            return false;
        }
        else
        {
            if ((p2.start < p1.end) && (p2.end > p1.start))
            {
                return true;
            }
            else if ((p1.start < p2.end) && (p1.end > p2.start))
            {
                return true;
            }
        }

        return false;
    }

}
