package org.processmining.processprofiler3d.psen.replayanalysis;

import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;

public class TimePeriodCollection
{
    public Vector<TimePeriod> periods = new Vector<TimePeriod>();

    public TimeSpan getTimeSpan()
    {
        long ts = 0;
        for (TimePeriod p : periods)
        {
            ts += p.getTimeSpan().getMilliseconds();
        }
        return new TimeSpan(ts);
    }

    public void Include(TimePeriod p)
    {
    	Vector<TimePeriod> lst = new Vector<TimePeriod>();
    	TimePeriod px = p;
        while (periods.size() > 0)
        {
            if (TimePeriod.Overlap(periods.get(0), px) || TimePeriod.Connect(periods.get(0), px))
            {
                px = TimePeriod.Merge(px, periods.get(0));
                periods.remove(0);
            }
            else
            {
                lst.add(periods.get(0));
            }
        }
        lst.add(px);
   
        Collections.sort(lst, new Comparator<TimePeriod>() 
        {
             @Override
             public int compare(TimePeriod p1, TimePeriod p2) 
             {
            	 return Long.compareUnsigned(p1.start, p2.start);
             }           
         });

        periods = lst;
    }

    public void Exclude(TimePeriod p)
    {
    	Vector<TimePeriod> lst = new Vector<TimePeriod>();
        for (TimePeriod px : periods)
        {
            lst.addAll(ExcludeFrom(px, p));
        }
        periods = lst;
    }

    //exclude period b from period a
    public static Vector<TimePeriod> ExcludeFrom(TimePeriod a, TimePeriod b)
    {
    	Vector<TimePeriod> lst = new Vector<TimePeriod>();
        if (!TimePeriod.Overlap(a, b))
        {
            lst.add(a);
            return lst;
        }

        Vector<Long> inst = new Vector<Long>();
        inst.add(a.start);
        inst.add(a.end);
        inst.add(b.start);
        inst.add(b.end);

        Collections.sort(inst);

        for (int i = 0; i < inst.size() - 1; i++)
        {
        	TimePeriod p = new TimePeriod(inst.get(i), inst.get(i+1));
            if ((!p.IsEmpty()) && (!TimePeriod.Overlap(p, b)))
            {
                lst.add(p);
            }
        }

        return lst;
    }

}
