package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionDuration extends StatCalculatorTransitionTimes
{
	public StatCalculatorTransitionDuration()
	{
		super("Duration");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "duration";
		myLabels.add(new PSENLabel("duration_min", myLabelNode, PSENLabel.MIN, true));
		myLabels.add(new PSENLabel("duration_mean", myLabelNode, PSENLabel.MEAN, true));
		myLabels.add(new PSENLabel("duration_max", myLabelNode, PSENLabel.MAX, true));
		myLabels.add(new PSENLabel("duration_med", myLabelNode, PSENLabel.MEDIAN, true));
		
		for (PSENLabel myLabel : myLabels)
		{
			psnet.addLabel(myLabel);
		}
	}
	
//	@Override
//	public TimeSpan getTimeForTransitionEvent(TransitionEvent te, XTrace tr)
//	{
//		return te.getDuration(tr);
//	}
	
	@Override
	public int getStartId(TransitionEvent te)
	{
		int sId = te.getStartId();

		return sId;
	}
	
	@Override
	public int getEndId(TransitionEvent te)
	{
		int cId = te.getCompleteId();

		return cId;
	}
}
