package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Vector;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.datastructure.PerformanceStatisticsDB;
import org.processmining.processprofiler3d.psen.preprocess.LPPAction;
import org.processmining.processprofiler3d.psen.replayanalysis.ITraceAlignment;
import org.processmining.processprofiler3d.psen.replayanalysis.TraceReplayAnalyser;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionPairAlignedFrequency extends StatCalculatorTransitionPairTimes
{
	public StatCalculatorTransitionPairAlignedFrequency()
	{
		super("aligned_frequency", "Aligned Frequency");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "aligned_frequency";
		myLabels.add(new PSENLabel("aligned_frequency", myLabelNode, PSENLabel.SUM, false));
		
		for (PSENLabel myLabel : myLabels)
		{
			wtt.addLabel(myLabel);
		}
	}
	
//	//trace alignment level
//	@Override
//	public void getTimesFromTraceAlignment(ITraceAlignment ta, Transition t1, Transition t2, XTrace tr, IPerformanceStatisticsEnrichedNet wten)
//	{
//		String psenLabel = myLabels.firstElement().getLabelName();
//		String traceID = LPPAction.getAttributeValueLiteral(tr, XConceptExtension.KEY_NAME);
//		String tpairID = t1.getLocalID().toString() + t2.getLocalID().toString();
//		Vector<TransitionEvent> evts = ta.getTransitionEventsFor(t2);
//		for (TransitionEvent t2e : evts)
//		{
//			for (TimeSpan ts : t2e.getWaitingTimesFrom(tr, t1))
//			{
//				wten.addValue(tpairID, psenLabel, traceID, 1.0);
//			}
//		}
//	}
	
	//trace alignment level
	@Override
	public void getTimesFromTraceAlignmentBatch(ITraceAlignment ta, Transition t1, Transition t2, Vector<TraceReplayAnalyser> tras, IPerformanceStatisticsEnrichedNet wten)
	{
		String psenLabel = myLabels.firstElement().getLabelName();
		String tpairID = t1.getLocalID().toString() + t2.getLocalID().toString();

		PerformanceStatisticsDB pdb = (PerformanceStatisticsDB)wten;
		PreparedStatement ps = pdb.getBatchAddFor(tpairID, psenLabel);
		
		try
		{
			Vector<TransitionEvent> evts = ta.getTransitionEventsFor(t2);
			for (TransitionEvent t2e : evts)
			{
				for (Integer ts : t2e.getPathsFrom(t1))
				{
					for (TraceReplayAnalyser tra : tras)
					{
						String traceID = LPPAction.getAttributeValueLiteral(tra.getTrace(), XConceptExtension.KEY_NAME);
						int trid = pdb.regTracePublic(traceID);
						ps.setInt(3, trid);
						ps.setDouble(4, 1.0);
						ps.addBatch();
						//wten.addValue(tpairID, psenLabel, traceID, 1.0);
					}
				}
			}
			pdb.commitBatchAdd();
		}
		catch (SQLException ex)
		{
			// TODO Auto-generated catch block
			ex.printStackTrace();
		}
	}
}
