package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionQueueTime extends StatCalculatorTransitionTimes
{
	public StatCalculatorTransitionQueueTime()
	{
		super("Queue time");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "queue_time";
		myLabels.add(new PSENLabel("queue_time_min", myLabelNode, PSENLabel.MIN, true));
		myLabels.add(new PSENLabel("queue_time_mean", myLabelNode, PSENLabel.MEAN, true));
		myLabels.add(new PSENLabel("queue_time_med", myLabelNode, PSENLabel.MEDIAN, true));
		myLabels.add(new PSENLabel("queue_time_max", myLabelNode, PSENLabel.MAX, true));
		
		for (PSENLabel myLabel : myLabels)
		{
			psnet.addLabel(myLabel);
		}
	}
	
//	@Override
//	public TimeSpan getTimeForTransitionEvent(TransitionEvent te, XTrace tr)
//	{
//		return te.getQueueTime(tr);
//	}
	
	@Override
	public int getStartId(TransitionEvent te)
	{
		int sId = te.getScheduleId();

		return sId;
	}
	
	@Override
	public int getEndId(TransitionEvent te)
	{
		int cId = te.getAssignId();

		return cId;
	}
}
