package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionRunTime extends StatCalculatorTransitionTimes
{
	public StatCalculatorTransitionRunTime()
	{
		super("Run Time");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "run_time";
		myLabels.add(new PSENLabel("run_time_min", myLabelNode, PSENLabel.MIN, true));
		myLabels.add(new PSENLabel("run_time_mean", myLabelNode, PSENLabel.MEAN, true));
		myLabels.add(new PSENLabel("run_time_med", myLabelNode, PSENLabel.MEDIAN, true));
		myLabels.add(new PSENLabel("run_time_max", myLabelNode, PSENLabel.MAX, true));

		for (PSENLabel myLabel : myLabels)
		{
			psnet.addLabel(myLabel);
		}
	}
	
//	@Override
//	public TimeSpan getTimeForTransitionEvent(TransitionEvent te, XTrace tr)
//	{
//		//Date traceStart = LPPAction.getAttributeValueTimestamp(tr, "arrivalTime");
//		Date traceStart = LPPAction.getAttributeValueTimestamp(tr.get(0), XTimeExtension.KEY_TIMESTAMP);
//		
//		Date eventTime = te.getStartTime(tr);
//		if (eventTime == null)
//		{
//			eventTime = te.getCompleteTime(tr);
//		}
//		if (traceStart != null && eventTime != null)
//		{
//			return new TimeSpan(traceStart, eventTime);
//		}
//		return null;
//	}

	@Override
	public int getStartId(TransitionEvent te)
	{
		return -2; //HACK!!! use as signifier for case start time
	}

	@Override
	public int getEndId(TransitionEvent te)
	{
		return te.getStartId();
	}
}
