package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.replayanalysis.TimeSpan;
import org.processmining.processprofiler3d.psen.replayanalysis.TraceReplayAnalyser;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionSoujournTime extends StatCalculatorTransitionTimes
{
	public StatCalculatorTransitionSoujournTime()
	{
		super("Soujourn time");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "soujourn_time";
		myLabels.add(new PSENLabel("soujourn_time_min", myLabelNode, PSENLabel.MIN, true));
		myLabels.add(new PSENLabel("soujourn_time_mean", myLabelNode, PSENLabel.MEAN, true));
		myLabels.add(new PSENLabel("soujourn_time_med", myLabelNode, PSENLabel.MEDIAN, true));
		myLabels.add(new PSENLabel("soujourn_time_max", myLabelNode, PSENLabel.MAX, true));

		for (PSENLabel myLabel : myLabels)
		{
			psnet.addLabel(myLabel);
		}
	}
	
//	@Override
//	public TimeSpan getTimeForTransitionEvent(TransitionEvent te, XTrace tr)
//	{
//		return te.getSoujournTime(tr);
//	}

	@Override
	public TimeSpan getTimeForTransitionEvent(TraceReplayAnalyser tra, TransitionEvent te, int sId, int cId)
	{
		return te.getSoujournTime(tra.getTrace());
	}
}
