package org.processmining.processprofiler3d.psen.replayanalysis.stats;

import org.processmining.processprofiler3d.psen.datastructure.IPerformanceStatisticsEnrichedNet;
import org.processmining.processprofiler3d.psen.datastructure.PSENLabel;
import org.processmining.processprofiler3d.psen.replayanalysis.TransitionEvent;

public class StatCalculatorTransitionThroughputTime extends StatCalculatorTransitionTimes
{
	public StatCalculatorTransitionThroughputTime()
	{
		super("Throughput time");
	}
	
	@Override
	public void addLabelsToPSEN(IPerformanceStatisticsEnrichedNet psnet, IPerformanceStatisticsEnrichedNet wtt)
	{
		myLabelNode = "throughput_time";
		myLabels.add(new PSENLabel("throughput_time_min", myLabelNode, PSENLabel.MIN, true));
		myLabels.add(new PSENLabel("throughput_time_mean", myLabelNode, PSENLabel.MEAN, true));
		myLabels.add(new PSENLabel("throughput_time_med", myLabelNode, PSENLabel.MEDIAN, true));
		myLabels.add(new PSENLabel("throughput_time_max", myLabelNode, PSENLabel.MAX, true));

		for (PSENLabel myLabel : myLabels)
		{
			psnet.addLabel(myLabel);
		}
	}
	
//	@Override
//	public TimeSpan getTimeForTransitionEvent(TransitionEvent te, XTrace tr)
//	{
//		return te.getThroughputTime(tr);
//	}
	
	@Override
	public int getStartId(TransitionEvent te)
	{
		int sId = te.getScheduleId();

		return sId;
	}
	
	@Override
	public int getEndId(TransitionEvent te)
	{
		int cId = te.getCompleteId();

		return cId;
	}
}
