package org.processmining.processprofiler3d.psen.replayanalysis.tokenflow;

import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Arc;
import org.processmining.models.graphbased.directed.petrinet.elements.InhibitorArc;
import org.processmining.models.graphbased.directed.petrinet.elements.ResetArc;

public class TokenFlowArc implements ITokenFlowArc 
{
	private PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> myEdge;
	
	//This hack is arcward!
	public TokenFlowArc(PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge)
	{
		myEdge = edge;
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.ITokenFlowArc#getSource()
	 */
	@Override
	public PetrinetNode getSource()
	{
		return myEdge.getSource();
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.ITokenFlowArc#getTarget()
	 */
	@Override
	public PetrinetNode getTarget()
	{
		return myEdge.getTarget();
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.ITokenFlowArc#isResetArc()
	 */
	@Override
	public boolean isResetArc()
	{
		return (myEdge instanceof ResetArc);
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.ITokenFlowArc#isInhibitorArc()
	 */
	@Override
	public boolean isInhibitorArc()
	{
		return (myEdge instanceof InhibitorArc);
	}
	
	/* (non-Javadoc)
	 * @see org.processmining.plugins.psen.replayanalysis.ITokenFlowArc#getWeight()
	 */
	@Override
	public int getWeight()
	{
		if (myEdge instanceof Arc)
		{
			Arc a = (Arc)myEdge;
			return a.getWeight();
		}
		return 1;
	}
}
