package org.processmining.processprofiler3d.resourceanalysis.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JCheckBox;
import javax.swing.JLabel;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.processprofiler3d.resourceanalysis.statics.BasicLogStatisticsProvider;

public class AddCohortDialog extends ProMPropertiesPanel implements ActionListener{
	
	  /**
	 * 
	 */
	  private static final long serialVersionUID    = 1L;

	 // private ArrayList<String> listOfAttribute     = new ArrayList<String>();
	  private ArrayList<String> listOfTransitions   = new ArrayList<String>(); 
	  private ArrayList<String> listOfDurationTypes = new ArrayList<String>();
	  
	  private BasicLogStatisticsProvider provider;
	
	        
	  private JCheckBox durationCheckBox;
	  private JCheckBox queuetimeCheckBox;
	  private JCheckBox servicetimeCheckBox;
	  private JCheckBox throughputtimeCheckBox; 
	  private JLabel durationSelector;
	  
	  private boolean hasSchedule  = false;
	  private boolean hasAssign    = false;
	  private boolean hasStart     = false;
	  private boolean hasComplete  = false;
	  
	  public AddCohortDialog(XLog log)
	  {
		  super("Add cohort");
		 
		  this.provider = new BasicLogStatisticsProvider(log);
		 // this.listOfAttribute = provider.getListOfAttributes();		
		  this.listOfTransitions = provider.getListOfLifecycleTransitions();
		  this.initComponents();
		  this.autoSetCheckBoxEnable();

	  }
	  
	   private void initComponents() {

	        durationCheckBox = new JCheckBox();
	        queuetimeCheckBox = new JCheckBox();
	        servicetimeCheckBox = new JCheckBox();
	        throughputtimeCheckBox = new JCheckBox();
	        durationSelector = new JLabel();

	        durationCheckBox.setText("Duration of an activity (start->complete)");
	        durationCheckBox.setActionCommand("Duration of an activity (Start -> Complete)");
	        durationCheckBox.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent evt) {
	                durationCheckBoxActionPerformed(evt);
	            }
	        });
	        
	        queuetimeCheckBox.setText("Queue time of an activity (schedule->assign)");
	        queuetimeCheckBox.setActionCommand("Queue time of an activity (schedule->assign)");
	        queuetimeCheckBox.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent evt) {
	                queuetimeCheckBoxActionPerformed(evt);
	            }
	        });
	        
	        
	        servicetimeCheckBox.setText("Service time of an activity (assign->complete)");
	        servicetimeCheckBox.setActionCommand("Service time of an activity (assign->complete)");
	        servicetimeCheckBox.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent evt) {
	            	servicetimeCheckBoxActionPerformed(evt);
	            }
	        });
	        
	        
	        throughputtimeCheckBox.setText("Throughput time of an activity (schedule->complete)");
	        throughputtimeCheckBox.setActionCommand("Throughput time of an activity (schedule->complete)");
	        throughputtimeCheckBox.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent evt) {
	            	 throughputtimeCheckBoxActionPerformed(evt);
	            }
	        });
	        
	        durationSelector.setText("Select the set of different duration types");

	        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
	        this.setLayout(layout);
	        layout.setHorizontalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(layout.createSequentialGroup()
	                .addGap(42, 42, 42)
	                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	                    .addComponent(throughputtimeCheckBox)
	                    .addComponent(servicetimeCheckBox)
	                    .addComponent(queuetimeCheckBox)
	                    .addComponent(durationCheckBox)
	                    .addComponent(durationSelector, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE))
	                .addContainerGap(360, Short.MAX_VALUE))
	        );
	        layout.setVerticalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(layout.createSequentialGroup()
	                .addGap(44, 44, 44)
	                .addComponent(durationSelector, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
	                .addGap(18, 18, 18)
	                .addComponent(durationCheckBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
	                .addGap(18, 18, 18)
	                .addComponent(queuetimeCheckBox)
	                .addGap(18, 18, 18)
	                .addComponent(servicetimeCheckBox)
	                .addGap(18, 18, 18)
	                .addComponent(throughputtimeCheckBox)
	                .addContainerGap(263, Short.MAX_VALUE))
	        );
	    }// </editor-fold>                
	   
	   public BasicLogStatisticsProvider getBasicLogStatisticsProvider()
	   {
		   return this.provider;
	   }
	   
	   
	  public void autoSetCheckBoxEnable()
	  {
		  for (String str : this.listOfTransitions)
		  {
			  if(str.equalsIgnoreCase("schedule"))
			  {
				  this.hasSchedule = true;
			  } 
			  else if (str.equalsIgnoreCase("assign"))
			  {
				  this.hasAssign = true;
			  } 
			  else if (str.equalsIgnoreCase("start"))
			  {
				  this.hasStart = true;
			  } 
			  else if (str.equalsIgnoreCase("complete"))
			  {
				  this.hasComplete = true;
			  }  
		  }
		  
		  this.durationCheckBox.setEnabled((this.hasStart)&&(this.hasComplete));
		  this.queuetimeCheckBox.setEnabled((this.hasSchedule)&&(this.hasAssign));
		  this.servicetimeCheckBox.setEnabled((this.hasAssign)&&(this.hasComplete));
		  this.throughputtimeCheckBox.setEnabled((this.hasSchedule)&&(this.hasComplete));
		  
	  }
	  

	  public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
	  }
	  
	
     private void durationCheckBoxActionPerformed(ActionEvent evt) {                                           
        // TODO add your handling code here:
    	 JCheckBox cb = (JCheckBox) evt.getSource();
    	 if(cb.isSelected())
    	 {
    		 this.listOfDurationTypes.add("duration");
    	 }else if(!cb.isSelected())
    	 {
    		 if(this.listOfDurationTypes.contains("duration"))
    		 {
    			 this.listOfDurationTypes.remove("duration");
    		 }
    	 }
    	 System.out.println("Output the list of duration types: ");
    	 for (String str:this.listOfDurationTypes)
    	 {
    		 System.out.println(str);
    	 }
     }                                          


	 private void queuetimeCheckBoxActionPerformed(ActionEvent evt) {
		// TODO Auto-generated method stub
		 JCheckBox cb = (JCheckBox) evt.getSource();
    	 if(cb.isSelected())
    	 {
    		 this.listOfDurationTypes.add("queue time");
    	 }else if(!cb.isSelected())
    	 {
    		 if(this.listOfDurationTypes.contains("queue time"))
    		 {
    			 this.listOfDurationTypes.remove("queue time");
    		 }
    	 }
	 }
	 

	private void servicetimeCheckBoxActionPerformed(ActionEvent evt) {
			// TODO Auto-generated method stub
		 JCheckBox cb = (JCheckBox) evt.getSource();
		 if(cb.isSelected())
		 {
			 this.listOfDurationTypes.add("service time");
		 }else if(!cb.isSelected())
		 {
			 if(this.listOfDurationTypes.contains("service time"))
		 {
			 this.listOfDurationTypes.remove("service time");
			 }
		 }
	}
	
	

	private void throughputtimeCheckBoxActionPerformed(ActionEvent evt) {
		// TODO Auto-generated method stub
		 JCheckBox cb = (JCheckBox) evt.getSource();
		 if(cb.isSelected())
		 {
			 this.listOfDurationTypes.add("throughput time");
		 }else if(!cb.isSelected())
		 {
			 if(this.listOfDurationTypes.contains("throughput time"))
		 {
			 this.listOfDurationTypes.remove("throughput time");
			 }
		 }
	}

    
    public ArrayList<String> getListOfDurationTypes()
    {
    	return this.listOfDurationTypes;
    }
     

}
