package org.processmining.processprofiler3d.resourceanalysis.plugins;

import javax.swing.JComponent;
import javax.swing.JTabbedPane;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processprofiler3d.resourceanalysis.gui.AddCohortDialog;
import org.processmining.processprofiler3d.resourceanalysis.gui.DisplayPanel;



@Plugin(name = "Process Profiler: Mining Resource Patterns from Event Log",
parameterLabels = { "Event Log" },
returnLabels = { "Process Profiler: Mining Resource Patterns from Event Log" },
returnTypes = { JTabbedPane.class },
userAccessible = false)

public class ResourceAnalysisPlugin 
{
	
	@PluginVariant(variantLabel = "Process Profiler: Mining Resource Patterns from Event Log", requiredParameterLabels = { 0 })
	@UITopiaVariant(uiLabel = "Process Profiler: Mining Resource Patterns from Event Log", affiliation = "Queensland University of Technology", author = "Jingxin Xu", email = "j15.xu@qut.edu.au")
	public JComponent GenerateChangeVisualizationTabbedPane(final UIPluginContext context, XLog log) throws Exception 
	{
	
		JTabbedPane tabbedPane = new JTabbedPane();
		AddCohortDialog dialog = new AddCohortDialog(log);
		InteractionResult result = context.showConfiguration("Configure cohort and transition", dialog);
		
		if (result == InteractionResult.CONTINUE) 
		{
				
				
				DisplayPanel output = new DisplayPanel(dialog.getBasicLogStatisticsProvider());
				
				tabbedPane.addTab("Resource Pattern Mining", null, output, "Provides an overview on human resource behaviours through visualising the statistics from event logs.");
		
				ResourceAnalysisVisualiser viz = new ResourceAnalysisVisualiser();
				viz.Visualizer(context, tabbedPane);
		}
		
		return tabbedPane;
	}
}
