package org.processmining.processprofiler3d.resourceanalysis.plugins;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processprofiler3d.resourceanalysis.statics.AdvancedStatisticsProvider;
import org.processmining.processprofiler3d.resourceanalysis.statics.BasicLogStatisticsProvider;
import org.processmining.processprofiler3d.resourceanalysis.statics.FrequencyTree;



@Plugin(name = "Process Profiler 3D: Mining Resource Patterns from Event Log",
parameterLabels = { "Event Log" },
returnLabels = { "Process Profiler: Mining Resource Patterns from Event Log" },
returnTypes = { FrequencyTree.class },
userAccessible = false)

public class ResourceAnalysisPluginNew 
{
	
	@PluginVariant(variantLabel = "Process Profiler 3D: Mining Resource Patterns from Event Log", requiredParameterLabels = { 0 })
	@UITopiaVariant(uiLabel = "Process Profiler 3D: Mining Resource Patterns from Event Log", affiliation = "Queensland University of Technology", author = "Jingxin Xu", email = "j15.xu@qut.edu.au")
	public FrequencyTree GenerateChangeVisualizationTabbedPane(final UIPluginContext context, XLog log) throws Exception 
	{
		BasicLogStatisticsProvider provider = new BasicLogStatisticsProvider(log);
		AdvancedStatisticsProvider myAdvancedProvider = new AdvancedStatisticsProvider(provider);
		FrequencyTree myFrequencyTree = myAdvancedProvider.getFrequencyTree();
		
		return myFrequencyTree;
	}
}
