package org.processmining.processprofiler3d.resourceanalysis.statics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.deckfour.xes.model.XLog;
import org.processmining.processprofiler3d.psen.datastructure.H2MemoryDatabase;

public class AdvancedStatisticsProvider 
{
	protected Map<String, Integer> frequencyStats = new HashMap<String, Integer>();

	private XLog mylog;
	private ArrayList<String> mylistOfCohorts = new ArrayList<String>();
	private ArrayList<String> mylistOfActivities = new ArrayList<String>();
	private ArrayList<String> mylistOfResources = new ArrayList<String>();
 	private FrequencyTree myfrequencytree;
 	
	public AdvancedStatisticsProvider(BasicLogStatisticsProvider basicProvider)
	{
		this.mylog = basicProvider.getEventLog();
		this.mylistOfActivities =  basicProvider.getListOfActivities();
		this.mylistOfCohorts = basicProvider.getListOfCohorts();
		this.mylistOfResources = basicProvider.getListOfResources();
		
		H2MemoryDatabase h2db = new H2MemoryDatabase();
		LogToDatabase mydatabase = new LogToDatabase(h2db, this.mylog);
		mydatabase.Init();
		mydatabase.updatetable();
		this.myfrequencytree  = mydatabase.setFrequency(new FrequencyTree(this.mylistOfCohorts, this.mylistOfActivities, this.mylistOfResources));
		mydatabase.printquery();
	}
	
	public ArrayList<String> getListOfActivities()
	{
		return this.mylistOfActivities;
	}

	public ArrayList<String> getListOfResources()
	{
		return this.mylistOfResources;
	}

	public ArrayList<String> getListOfCohorts()
	{
		return this.mylistOfCohorts;
	}

	public FrequencyTree getFrequencyTree()
	{
		return this.myfrequencytree;
	}

}
