package org.processmining.processprofiler3d.resourceanalysis.statics;

import java.util.ArrayList;

import javax.swing.tree.DefaultMutableTreeNode;

public class FrequencyTree
{

	private ArrayList<String> mylistOfCohorts = new ArrayList<String>();
	private ArrayList<String> mylistOfActivities = new ArrayList<String>();
	private ArrayList<String> mylistOfResources = new ArrayList<String>();

	private DefaultMutableTreeNode rootnode = new DefaultMutableTreeNode("Root");

	public ArrayList<String> getCohorts()
	{
		return mylistOfCohorts;
	}
	
	public ArrayList<String> getActivities()
	{
		return mylistOfActivities;
	}
	
	public ArrayList<String> getResources()
	{
		return mylistOfResources;
	}
	
	public FrequencyTree(ArrayList<String> listOfCohorts, ArrayList<String> listOfActivities,
			ArrayList<String> listOfResources)
	{
		this.mylistOfCohorts = listOfCohorts;
		this.mylistOfActivities = listOfActivities;
		this.mylistOfResources = listOfResources;
		this.generateTree();
	}

	public void generateTree()
	{

		for (String activity : this.mylistOfActivities)
		{
			DefaultMutableTreeNode activitynode = new DefaultMutableTreeNode(activity);
			rootnode.add(activitynode);
			for (String resource : this.mylistOfResources)
			{
				DefaultMutableTreeNode resourcenode = new DefaultMutableTreeNode(resource);
				activitynode.add(resourcenode);
				for (String cohort : this.mylistOfCohorts)
				{
					DefaultMutableTreeNode cohortnode = new DefaultMutableTreeNode(cohort);
					resourcenode.add(cohortnode);
					DefaultMutableTreeNode valuenode = new DefaultMutableTreeNode(0);
					cohortnode.add(valuenode);
				}
			}
		}
	}

	public DefaultMutableTreeNode getTreeRoot()
	{
		return this.rootnode;
	}

	public void setValue(String activity, String resource, String cohort, int frequency)
	{
		for (int i = 0; i < rootnode.getChildCount(); i++)
		{
			DefaultMutableTreeNode activitychildnode = (DefaultMutableTreeNode) rootnode.getChildAt(i);
			if (activity.equals((String) activitychildnode.getUserObject()))
			{
				for (int j = 0; j < activitychildnode.getChildCount(); j++)
				{
					DefaultMutableTreeNode resourcechildnode = (DefaultMutableTreeNode) activitychildnode.getChildAt(j);
					if (resource.equals((String) resourcechildnode.getUserObject()))
					{
						for (int k = 0; k < resourcechildnode.getChildCount(); k++)
						{
							DefaultMutableTreeNode cohortchildnode = (DefaultMutableTreeNode) resourcechildnode
									.getChildAt(k);
							if (cohort.equals((String) cohortchildnode.getUserObject()))
							{
								DefaultMutableTreeNode valuechildnode = (DefaultMutableTreeNode) cohortchildnode
										.getChildAt(0);
								valuechildnode.setUserObject(frequency);
								break;
							}
						}
						break;
					}
				}
				break;
			}
		}
	}

	public int getValue(String activity, String resource, String cohort)
	{
		int frequency = 0;
		for (int i = 0; i < rootnode.getChildCount(); i++)
		{
			DefaultMutableTreeNode activitychildnode = (DefaultMutableTreeNode) rootnode.getChildAt(i);
			if (activity.equals((String) activitychildnode.getUserObject()))
			{
				for (int j = 0; j < activitychildnode.getChildCount(); j++)
				{
					DefaultMutableTreeNode resourcechildnode = (DefaultMutableTreeNode) activitychildnode.getChildAt(j);
					if (resource.equals((String) resourcechildnode.getUserObject()))
					{
						for (int k = 0; k < resourcechildnode.getChildCount(); k++)
						{
							DefaultMutableTreeNode cohortchildnode = (DefaultMutableTreeNode) resourcechildnode
									.getChildAt(k);
							if (cohort.equals((String) cohortchildnode.getUserObject()))
							{
								DefaultMutableTreeNode valuechildnode = (DefaultMutableTreeNode) cohortchildnode
										.getChildAt(0);
								frequency = (int) valuechildnode.getUserObject();
								break;
							}
						}
						break;
					}
				}
				break;
			}
		}
		return frequency;
	}

}
